Dear Jim,

This is the whole 9 yards.  We use this
program for several things - primarily
the estimation of WAS amplitudes and
ground motions such as PGA, PGV, and PGD.
The main program is called redi_wave and
can be invoked with different options.  Of
relevance to you -w for WAS and -g for
the ground motions.

This codes does do all kinds of things,
so it may be difficult for you to work
through it.  Here is a general outline.

redi_wave is entirely command-line driven.
Various options tell it what to do.  The
final argument is the list of files to work
with.

Once the program figures out what it is supposed
to do (and it can do many different things with 
the same data files), it loops over the list of
data files.  It opens the files, reads in the
data and retrieves information about the station
and instrument.  It checks for clipping and 
optionally checks to make sure that it has the
correct amount of time.  Then it actually does
something.

est_wood is the subroutine that computes the WAS
amplitudes.  This routine calls coinst2, which is
the workhorse Fourier domain routine.  coinst2
does the deconvolution/reconvolution/filtering
operations.

Have fun!

      subroutine fetch_pick(io_res,filen,head,pick,ipick,ierr)
c
c     subroutine will find open pickfile and extract picks for
c     station stat at stime
c
c     input:
c           io_res- io unit to open
c           filen - file containing picks
c           head  - station header structure
c     output:
c           cchan  - chan of pick
c           pid   - pick id
c           pdate    - pick time
c           ierr  - integer error flag
c                 = 0 for picks found
c            = 999 for no picks found
c
      include '/usr/local/include/qlib2.inc'
      record /INT_TIME/ pdate
      record /EXT_TIME/ pt
      include 'station_hdr.inc'
      include 'pick_hdr.inc'
      record /PICK/ pick(100)
c
      character*1 qual, fmotion
      character*3 cchan
      character*4 stat, cstat, pid
      character*256 filen, token, string, string1, string2
      integer*4 io_res, ierr, daymo
c
c     Initialize
c
      ierr = 999
c
      stat  = head.station_id
c
      open(io_res,file=filen)
c
c     read the first 2 lines and ignore them
c
      read(io_res,'(a)') string1
      read(io_res,'(a)') string2
c
      ipick = 0
c
c     loop over the picks in the file
c
100   continue
      read(io_res,'(a)',end=110) string
      call klen(string,kk)
      do ii = 1, kk
        if (string(ii:ii) .eq. ':') then
          string(ii:ii) = ' '
        end if
      end do
c
c     decode various items
c
      is = 0
c
c     station name
c
      call ciptok(string,is,cstat)
      if (cstat .eq. stat) then
          ipick = ipick + 1
c
c         channel
c
          call ciptok(string,is,cchan)
c
c         sample index
c
          call ciptok(string,is,token)
          call cipnum(token,rnum,ierr)
          index = rnum
c
c         pick quality
c
          call ciptok(string,is,qual)
c
c         phase name
c
          call ciptok(string,is,pid)
c
c         time offset
c
          call ciptok(string,is,token)
          call cipnum(token,dtime,ierr)
c
c         first motion
c
          call ciptok(string,is,fmotion)
c
c         time uncertainty
c
          call ciptok(string,is,token)
          call cipnum(token,utime,ierr)
c
c         Now read the actual pick time
c
c         year
c
          call ciptok(string,is,token)
          call cipnum(token,ryr,ierr)
          isyr = ryr
c
c         day of year
c
          call ciptok(string,is,token)
          call cipnum(token,rdy,ierr)
          isdy = rdy
c
c         time
c
          call ciptok(string,is,token)
          call cipnum(token,rshr,ierr)
          ishr = rshr
          call ciptok(string,is,token)
          call cipnum(token,rsmn,ierr)
          ismn = rsmn
          call ciptok(string,is,token)
          call cipnum(token,fsec,ierr)
          issc = int(fsec)
          iusec = (fsec - issc)*usecs_per_sec
c
c         Checking
c
c         print*, stat, chan, pid, isyr, isdy, ishr, ismn, fsec
c
c         Form pick structure
c
          pt.year   = isyr
          pt.doy    = isdy
          ierr = daymo(isdy,pt.month,pt.day,isyr)
          pt.hour   = ishr
          pt.minute = ismn
          pt.second = issc
          pt.usec  = iusec
          call f_ext_to_int(pt,pdate)
c
          pick(ipick).station_id = cstat
          pick(ipick).channel_id = cchan
          pick(ipick).ptime = pdate
          pick(ipick).pid = pid
          pick(ipick).noff = index
          pick(ipick).qual = qual
          pick(ipick).fmotion = fmotion
          ierr = 0
          go to 100
      end if
      go to 100
c
110   continue
c
      close(io_res)
      return
      end
c

c

      INTEGER FUNCTION LPYR(YEAR)
C
C Function lpyr determines if year
C is a leap year.
C
C This function uses the intrinsic
C function mod. If your machine
C does not supply this function,
C make one -
C mod(i,j) = iabs(i - (i/j)*j)
C
C
C Calls:
C   mod - intrinsic funtion
C
C      Programmed by Madeleine Zirbes
C         September 15,1980
C
C YEAR - INPUT
      INTEGER YEAR
      IF (.NOT.(MOD(YEAR, 400) .EQ. 0)) GOTO 6100
        LPYR = (1)
        RETURN
6100  CONTINUE
      IF (.NOT.(MOD(YEAR, 4) .NE. 0)) GOTO 6120
        LPYR = (0)
        RETURN
6120  CONTINUE
      IF (.NOT.(MOD(YEAR, 100) .EQ. 0)) GOTO 6140
        LPYR = (0)
        RETURN
6140  CONTINUE
      LPYR = (1)
      RETURN
      END

      subroutine azimth(slat,slon,rlat,rlon,delta,azim,bazim)
c
c   This routine uses Euler angles to find the geocentric 
c   distance, azimuth, and back azimuth for a source-reciever
c   pair.
c
c                      Input
c   slat  - source geographic latitude in decimal degrees
c   slon  - source longitude in decimal degrees
c   rlat  - receiver geographic latitude in decimal degrees
c   rlon  - receiver longitude in decimal degrees
c
c                     Output
c   delta - source-reciever distance in decimal degrees of arc
c   azim  - azimuth from the source to the reciever in degrees
c   bazim - back azimuth from the receiver to the source in degrees
c
c   Mark Riedesel, January 30, 1986
c
      include 'numerical.h'
      dtor = drad
      e = 1.0/flt
c
c    convert to geocentric coordinates and from latitude to 
c    colatitude
c
      slatra = dtor*slat
      w = sin(slatra)
      s = ((2.-e)*w +4.*e*(w**3))*e*cos(slatra)
      scolat = pi2 - slatra + s
c
      rlatra = dtor*rlat
      w = sin(rlatra)
      s = ((2.-e)*w +4.*e*(w**3))*e*cos(rlatra)
      rcolat = pi2 - rlatra + s
c
      slonra=slon*dtor
      rlonra=rlon*dtor
      c2=cos(scolat)
      s2=sin(scolat)
      c1=cos(slonra)
      s1=sin(slonra)
c
c  find the azimuth and distance by rotating the source to the
c  North pole
c
      slatrc=sin(rcolat)
      x0=slatrc*cos(rlonra)
      y0=slatrc*sin(rlonra)
      z0=cos(rcolat)
c
      x1=c1*x0+s1*y0
      y1=-s1*x0+c1*y0
      z1=z0
      x2=c2*x1-s2*z1
      y2=y1
      z2=c2*z1+s2*x1
c
      call angles(x2,y2,z2,delta,azim)
      azim = 180.-azim
c
c  find the back azimuth by rotating the reciever to the 
c  North pole
c
      c2=cos(rcolat)
      s2=sin(rcolat)
      c1=cos(rlonra)
      s1=sin(rlonra)
c
      slatrc=sin(scolat)
      x0=slatrc*cos(slonra)
      y0=slatrc*sin(slonra)
      z0=cos(scolat)
c
      x1=c1*x0+s1*y0
      y1=-s1*x0+c1*y0
      z1=z0
      x2=c2*x1-s2*z1
      y2=y1
      z2=c2*z1+s2*x1
c
      call angles(x2,y2,z2,delta,bazim)
      bazim = 180.-bazim
      return
      end

	subroutine check_clip(chan,npts,idata,iere)
c
c     subroutine to check for clipped data
c
c     input:  
c             chan   - channel name
c             npts   - number of points in timeseries
c             idata  - integer data array
c     output:  
c             iere   - error return code
c                      999 if data if clipped
c                      0 otherwise
c
      integer*4 idata(*)
      integer*4 npts, iere, ixmax, ix
      real*4 rcomp, rxcomp, rmax
      character*3 chan
c
c     scale for determining clipping
c
      rcomp = 0.85 * real (2**23)
      if (chan(2:2) .eq. 'H') then
        rxcomp = rcomp
      elseif (chan(2:2) .eq. 'L') then
        rxcomp = 0.125*rcomp
      end if
c
c     initialize error flag
c
      iere = 0
c
c     find the maximum value
c
      ixmax = 0.0
      do ii = 1, npts
        ix = abs(idata(ii))
        if (ix .gt. ixmax) then
          ixmax = ix
        end if
      end do
      rmax = ixmax
      if (rmax .gt. rxcomp) then
        iere = 999
      end if
c
c     all done
c
      return
      end

      FUNCTION BPCOS(W,WMIN,WL,WU,WMAX)
C
C  COS TAPER BETWEEN WMIN AND WL AND WU AND WMAX
C
      PARAMETER (PI=3.1415926535898)
      IF(WMIN.LT.0.) GO TO 6
      IF(W.LT.WMIN.OR.W.GT.WMAX) GO TO 7
      IF(W-WL) 1,2,2
    1 ARG=PI*(W-WMIN)/(WL-WMIN)
      GO TO 5
    2 IF(W-WU) 4,4,3
    3 ARG=PI*(WMAX-W)/(WMAX-WU)
      GO TO 5
    4 GO TO 6
    5 BPCOS=.5*(1.-COS(ARG))
      RETURN
    6 BPCOS=1.
      RETURN
    7 BPCOS=0.
      RETURN
      END

      COMPLEX FUNCTION BPBWTH(W,W1,W2)
C
C $$$$$ CALLS ONLY LIBRARY ROUTINES $$$$$
C
C   BPBWTH RETURNS THE COMPLEX FORWARD TRANSFER FUNCTION OF A SIX POLE
C   BUTTERWORTH FILTER AS A FUNCTION OF ANGULAR FREQUENCY W.  THIS
C   FILTER IS A BAND PASS WITH CORNERS AT W1 AND W2 AND A ROLLOFF OF
C   36 DB/OCTAVE.  A FOURIER TRANSFORM CONVENTION OF
C   F(W) = INT F(T)*EXP(-IWT)*DT IS ASSUMED.
C
C                                                     -ALL
      COMPLEX S
      DATA A1,A2,A3/3.863703305,7.464101615,9.141620173/
      W=AMAX1(1.E-2,W)
      W0=(W*W-W1*W2)/(W*(W2-W1))
      S=CMPLX(0.,W0)
      S=S*(A1+S*(A2+S*(A3+S*(A2+S*(A1+S)))))+1
      BPBWTH=1./S
      RETURN
      END

      subroutine detrend (xx, n, dt, yy)
c
c     remove the best-fitting line from a set of time-points
c
      real*4 xx(*),yy(*)
c
c     sx = 0.0
c     sxx = 0.0
c     sy = 0.0
c     sxy = 0.0
c     s = float(n)
c     do i = 1, n
c       x = (i - 1)*dt
c       sx = sx + x
c       sxx = sxx + x**2
c       sy = sy + xx(i)
c       sxy = sxy + xx(i)*x
c     end do
c     delta = s*sxx - sx**2
c     a = (sxx*sy - sx*sxy)/delta
c     b = (s*sxy - sx*sy)/delta
c
c     apparently this is numerically unstable; let's try another approach
c
      sx = 0.0
      sy = 0.0
      s = float(n)
      do i = 1, n
        x = (i - 1)*dt
        sx = sx + x
        sy = sy + xx(i)
      end do
      sxos = sx/s
      st2 = 0.0
      b = 0.0
      do i = 1, n
        x = (i - 1)*dt
        t = x - sxos
        st2 = st2 + t*t
        b = b + t * xx(i)
      end do
      b = b/st2
      a = sy/s - sxos*b
c
c     if (abs(b) .gt. 0.00001) then
c       print*,' removing linear trend (int and slope): ', a, b
c     endif
c
      do i = 1, n
        x = (i - 1)*dt
        yy(i) = xx(i) - a - b * x
      end do
c
      return
      end

      subroutine angles(x,y,z,theta,phi)
c
c  finds the angles theta and phi of a spherical polar coordinate
c  system from the cartesion coordinates x, y, and z.
c
c  Mark Riedesel, 1983
c
      real*4 x, y, z, theta, phi
      real*4 arg1, eps
c
      include 'numerical.h'
c
      eps = 1.e-4
      rtod = radd
c
      arg1=sqrt(x*x+y*y)
      theta=atan2(arg1,z)
      if(abs(x).le.eps.and.abs(y).le.eps) then
         phi=0.
      else
         phi=atan2(y,x)
      end if
      phi=phi*rtod
      theta=theta*rtod
      return
      end

      subroutine amaxper(npts,dt,fc,amaxmm,pmax,imax)
c 
c     compute maximum amplitude and its associated period
c
c     input:
c             npts   - number of points in timeseries
c             dt     - sample spacing in sec
c             fc     - input timeseries
c     output:
c             amaxmm - raw maximum
c             pmax   - period of maximum
c             imax   - index of maxmimum point
c
      real*4 fc(*)
c
      include 'numerical.h'
c
      imax = 1
      amax = 0.
      amaxmm = 0.0
      pmax = 0.0
      do i = 1,npts
        x = abs(fc(i))
        if (x .gt. amax) then
          imax = i
          amax = x
        endif
      end do
c
c     compute period of maximum
c
      if (fc(imax) .gt. 0.) then
        pp = 0.
        j = imax
    2   j = j+1
        if(fc(j) .gt. 0.) then
          pp = pp+dt
          go to 2
        endif
        pp = pp+dt*(0.-fc(j-1))/(fc(j)-fc(j-1))
        pm = 0.
        j = imax
    3   j = j-1
        if(fc(j) .gt. 0.) then
          pm = pm+dt
          go to 3
        endif
        pm = pm+dt*(0.-fc(j+1))/(fc(j)-fc(j+1))
      else
        pp = 0.
        j = imax
    4   j = j+1
        if(fc(j) .lt. 0.) then
          pp = pp+dt
          go to 4
        endif
        pp = pp+dt*(0.-fc(j-1))/(fc(j)-fc(j-1))
        pm = 0.
        j = imax
    5   j = j-1
        if(fc(j) .lt. 0.) then
          pm = pm+dt
          go to 5
        endif
        pm = pm+dt*(0.-fc(j+1))/(fc(j)-fc(j+1))
      endif
c
      pmax = 2.*(pm+pp)
      amaxmm = amax
c
      return
      end

	subroutine est_wood(head,d1,dw,io_out,ierr)
c
c     subroutine for estimation of wood-anderson amplitudes
c
c     input:  
c             head   - station/channel header
c             d1     - data array
c             dw     - spectral array
c             io_out - unit number for writing
c     output:  
c             ierr   - error return code
c
c
c     include files for header
c
      include '/usr/local/include/qlib2.inc'
      include 'station_hdr.inc'
c
      real*4 d1(*)
      real*4 dt
      real*4 amaxmm, pmax, xmag
      integer*4 npts, io_out, ierr
      integer*4 imax
      complex*8 dw(*)
      character*3 chan
      character*4 stat
      character*10 string,ch1,ch2,ch3,ch4
      logical lexist
c
c     initialize error return
c
      ierr = 0
c
c     set variables for Wood-Anderson calculation
c
      ind = 3
      ind2 = 0
      fl = 0.0
      fh = 0.0
      np = 0
c
      stat  = head.station_id
      chan  = head.channel_id
      npts  = head.num_pts
      dt  = 1.0/head.sample_rate
c
c     remove instrument and reconvolve with Wood Anderson
c
      call coinst2(npts,dt,ind,ind2,d1,dw,np,fl,fh,ierr)
      if (ierr .ne. 0) then
        return
      end if
c
c     amaxmm is the WA amplitude in millimeters
c     pmax is the period of the maximum
c
      call amaxper(npts,dt,d1,amaxmm,pmax,imax)
      xmag = alog10(amaxmm/pmax)
c
c     check file existence, other fun stuff
c
      inquire(file='wood.wave',exist=lexist)
      if (lexist) then
        open(unit=io_out,file='wood.wave',fileopt='eof')
      else
        open(unit=io_out,file='wood.wave')
        write(io_out,'(a2)') '# '
        write(io_out,'(a2)') '# '
      end if
c
c     this is ugly and awkward - but I cannot think of a clever
c       way to reproduce Seistool output
c
      call klen(stat,kk)
      write(string,'(f10.3)') amaxmm
      call kstart(string,k1)
      call klen(string,k2)
      ch1 = string(k1:k2)
      id1 = k2 - k1 + 1
      write(string,'(f10.3)') pmax
      call kstart(string,k1)
      call klen(string,k2)
      ch2 = string(k1:k2)
      id2 = k2 - k1 + 1
      write(string,'(i10)') imax - 1
      call kstart(string,k1)
      call klen(string,k2)
      ch3 = string(k1:k2)
      id3 = k2 - k1 + 1
      write(string,'(f10.3)') xmag
      call kstart(string,k1)
      call klen(string,k2)
      ch4 = string(k1:k2)
      id4 = k2 - k1 + 1
c
c     this should be identical to a Seistool WA amplitude file
c
      write(io_out,100) stat(1:kk),chan,' WAS ',
     . ch1(1:id1),' ',ch2(1:id2),' ',ch3(1:id3),' ',
     . ch4(1:id4)
100   format(1x,10a)
      close(io_out)
c
c     all done
c
      return
      end

	subroutine calc_azm(npts,data,az,aaoi)
c
c ...... calculate az .and. aoi of phase onset
c ...... based on a Bob program
c
c
      parameter (maxp  = 65536)

	real*4 data(maxp,*)
	real*4 az(*),aaoi(*)
c
	do i = 1, npts
  	  xx = data(i,1)
	  yy = data(i,2)
	  zz = data(i,3)
c
	  if ((xx .eq. 0.0).and.(yy .eq. 0.0)) then
	    azx = 0 
	  else
	    azx = atan2d(xx,yy)
	    if (azx .lt. 0.0) then
            azx = 360.0 + azx
          end if
        end if
        az(i) = azx
c
	  fmag = sqrt(xx*xx+yy*yy)
	  if ((fmag .eq. 0.0).and.(zz .eq. 0.0)) then
	    aaoi(i)=0.
	  else
	    aaoi(i)=atan2d(fmag,zz)
	  endif
c
      end do
c
	return
	end

      program resp40

c     This program calculates the response spectrum 

      real f(100), t(62), sa(3), sv(3), sd(3), psv(3), psa(3)
      real acc(8200), maxpga(3)
      real w, pi, beta, dt
      character*80 fileout, filein     
      integer nzero, npts, nskip, ev, stanum, tb, te, npole
      integer mpad
      real mag, delta, depth, azimuth
      complex cx(8200)
      common cx
      common /tmp1/acc
      data t/0.040, 0.046, 0.051, 0.056, 0.062, 0.068, 0.075,
     1       0.083, 0.091, 0.100, 0.110, 0.121, 0.133, 0.147,
     2       0.162, 0.178, 0.196, 0.215, 0.237, 0.261, 0.287,
     3       0.316, 0.348, 0.383, 0.422, 0.464, 0.511, 0.562,
     4       0.619, 0.681, 0.750, 0.825, 0.909, 1.000, 1.10,
     5       1.21, 1.33, 1.47, 1.62, 1.78, 1.96, 2.15, 2.37,
     6       2.61, 2.87, 3.16, 3.48, 3.83, 4.22, 4.64, 5.11,
     7       5.62, 6.19, 6.81, 7.50, 8.25, 9.09, 10.00, 11.00,
     8       12.12, 13.3, 15.0/

c     SET PARAMETERS
      fc = 0.1
      npole = 4
      nmin = 0

c tb = taper beginning percent.
      tb = 3
c te = taper ending percent.
      te = 3

      pi = 3.1415926

c calculate at 62 diferent periods.
      nper = 62

      write (*,*) 'Enter the value of damping Beta.'
      read (*,*) beta

c      write (*,*) 'Enter the number of stations.'
c      read (*,*) nsta     
      nsta = 1

      write (*,*) 'Enter the event,magnitude,delta,depth and azimuth.'
      read (*,*) ev,mag,delta,depth,azimuth

      write (*,*) 'Enter the input data file name.'
      read (*,'(a80)') filein

      Write (*,*) 'Enter the time steps and npts for the data.'
      read (*,*) dt,npts

      write (*,*) 'Enter the plotxy output file name.'  
      read (*,'( a80)') fileout

      open (20,file=fileout,status='unknown')
      open (4,file=filein,status='old')

      write (20,'( 2x,f10.4,''  damping'')') beta
      write (20,'(i5,4f10.4)') ev,mag,delta,depth,azimuth

c calculate the 62 different freq.
      nfreq = nper
      do 2 i=1,nfreq
        f(i) = 1./T(i)
  2   continue

c Number of components.
      ncomp = 1

      do 600 jj=1,nsta

        do 300 icomp=1,ncomp
          nskip = 0

c         READ THE TIME HISTORY FILE
c          call rdat (acc,dt,npts)
          do 17 k=1,npts,1
             read (4,18) time,acc(k)
c            write (*,18) time,acc(k)
 17       continue
 18       format (f10.3,f10.3)

c         REMOVE THE DC
          call rdc (acc,npts,0)

c         TAPER
          call taper (acc,npts,tb,te)

c         PAD TO POWER OF 2
          call pad (acc,npts,nmin,mpad)
          df = 1./(npts*dt)
          write (*,'( 2x,''mpad ='',i4)') mpad

c         LOAD INTO COMPLEX ARRAY
          do 10 i=1,npts
            cx(i) = cmplx(acc(i),0.)
  10      continue

c         FFT
          write (*,'( 2x,''FFT'')')
          call cool (-1.,mpad)

c         FILTER
          write (*,'( 2x,''FILTER'')')
          call hpass(npole,npts,fc,df)

c         INVERSE FFT
          write (*,'( 2x,''INVERSE FFT'')')
          call cool (1.,mpad)

c         COPY TO REAL ARRAY
          do 15 i=1,npts
            acc(i) = real(cx(i))/npts
  15      continue

c         FIND MAX PGA
          maxpga(icomp) = 0.0
          do 20 i=1,npts
            maxpga(icomp) = amax1(maxpga(icomp),abs(acc(i)))
  20      continue

c         LOOP FOR EACH FREQUENCY
          do 200 l=1,nfreq
            w = 2.*pi*f(l)
            call coeff (w,beta,dt)

c           CALCULATE THE ACCELERATION RESPONSE 
            call brs (acc,w,beta,npts,sa1,sv1,sd1)

            SA(icomp) = sa1/980.
            SV(icomp) = sv1
            SD(icomp) = sd1
            PSV(icomp) = w*sd1
            PSA(icomp) = w**2*sd1
            write (*,5500) l,PSV(icomp),PSA(icomp),SA(icomp),SV(icomp),
     1                     SD(icomp)
 5500       format( 2x,i2,3x,5f9.3)

            write (20,'( 2x,7f9.3)') f(l),psv(icomp),psa(icomp),
     1         sa(icomp),sa(icomp)/maxpga(icomp),SV(icomp),SD(icomp)
 200      continue
 300    continue
 600  continue

      close (20)
      close (4)

      stop
      end

c************************************************************
c      subroutine rdat(acc,dt,npts)
c This subroutine will read the data file from the aux01 disk
c of the Loma Prieta Mainshock data. These records have been 
c processed by CSMIP.

c      real acc(8200)

c     Read the data

c     do 100 i=npts+1,1
c       read (4,1001) time,acc(i)
c  100 continue

c      return
c 1001 format(f10.3,f10.3)
c      end


c*********************************
      subroutine coeff (w,beta,dt)
      common /coef/a11,a12,a21,a22,b11,b12,b21,b22
c
c     Set up reapeated terms
      t1 = sqrt(1.-beta**2)
      t2 = sin (w*t1*dt)
      t3 = cos (w*t1*dt)
      t4 = exp (-beta*w*dt)
      s1 = (2.*beta**2-1.) / (w**2*dt)
      s2 = 2.*beta / (w**3*dt)
c
c     calculate the a's
      a11 = t4*(beta*t2/t1+t3)
      a12 = t4*t2 / (w*t1)
      a21 = -t4*w*t2 / t1
      a22 = t4*(t3-beta*t2/t1)
c
c     calculate the b's
      b11 = t4*((s1+beta/w)*t2 / (w*t1) + (s2+1./w**2)*t3) - s2
      b12 = -t4*(s1*t2/(w*t1)+s2*t3) - 1./w**2 + s2
      b21 = (s1+beta/w) * (t3-beta*t2/t1)
      b21 = t4*(b21 - (s2+1./w**2)*(w*t1*t2+beta*w*t3)) + 1./(w**2*dt)
      b22 = s1*(t3-beta*t2/t1)
      b22 = -t4*(b22 - s2*(w*t1*t2+beta*w*t3)) - 1./(w**2*dt)
      return
      end

c********************************************
      subroutine brs (x,w,beta,npts,sa,sv,sd)
      real x(1), sa, sv, sd, w, beta
      integer npts
      common /coef/ a11,a12,a21,a22,b11,b12,b21,b22
c
c     initialize
      t1 = 2.*beta*w
      t2 = w**2
      d = 0.
      v = 0.
      a = 0.
      Sa = 0.0
      Sv = 0.0
      Sd = 0.0
c
c     calculate the response
      do 10 i=1,npts
        ap1 = x(i)
        dp1 = a11*d + a12*v + b11*a + b12*ap1
        vp1 = a21*d + a22*v + b21*a + b22*ap1
        z = -(t1*vp1 + t2*dp1)
        Sa = amax1(Sa,abs(z))
        Sv = amax1(Sv,abs(vp1))
        Sd = amax1(Sd,abs(dp1))
        a = ap1
        v = vp1
        d = dp1
  10  continue
      return
      end 

c**********************************
      subroutine rdc (x,npts,iflag)

c     This subroutine removes a dc shift from the data

c     IFLAG = 0    remove the mean
c     IFLAG = 1    remove the mean value of the first 10 points
c     IFLAG = 2    manual set of DC value to be removed

      real x(1),sum,mean
      integer npts,iflag

      if (iflag .eq. 0) then
        sum = 0.0
        do 10 i=1,npts
          sum = x(i) + sum
  10    continue
        mean = sum/float(npts)

      elseif (iflag .eq. 1) then
        sum = 0.0
        do 20 i=1,10
          sum = x(i) + sum
  20    continue
        mean = sum / float(npts)

      else
        write (*,1000)
        read (*,1001) mean

      endif

      do 100 i=1,npts
        x(i) = x(i) - mean
  100 continue
      write (*,1010) mean
 1010 format( 2x,'Remove DC of ',f12.8)

      return
 1000 format( 2x,'Enter mean to be removed')
 1001 format( f12.8)
      end

c************************************
      subroutine taper (x,npts,tb,te)

c     This subroutine tapers the x array
    
      real x(1), arg
      integer npts,tb,te
      pio2 = 3.1415926/2.

      if (tb .ne. 0.) then
        n = (npts*tb)/100
        do 10 i=1,n
          arg = pio2*float(i-1)/float(n)
          x(i) = x(i)*sin(arg)
  10    continue
        write (*,1000) tb
 1000   format( 2x,'Taper beginning ',i2,' percent')

      endif

      if (te .ne. 0.) then
        n = (npts*te)/100
        do 20 i=1,n
          arg = pio2*float(i-1)/float(n)
          x(npts-i+1) = x(npts-i+1) * sin(arg)
  20    continue
        write (*,1001) te
 1001   format( 2x,'Taper end ',i2,' percent')

      endif
      return
      end

c***********************************
      subroutine pad (x,npts,nmin,m)

c     This subroutine pads the x array to a power of 2

      real x(1)
      integer test,npts,m,nmin

      do 10 i=1,20
        test = 2**i
        if (test .ge. npts .and. test .ge. nmin) goto 20
  10  continue
  20  m = i
      write (*,1000) test,m
 1000 format( 2x,'Pad to ',i4,' points,  m =',i4)

      do 30 i=npts,test
        x(i) = 0.0
  30  continue
      npts = test

      return
      end

c******************************
      subroutine cool (signi,n)
      complex cx(8200),carg,temp,cw
      common cx
      pi = 3.1415926*signi
      lx = 2**n
      j = 1
      do 30 i=1,lx
        if (i .gt. j) goto 10
        temp = cx(j)
        cx(j) = cx(i)
        cx(i) = temp
  10    m = lx/2
  20    if (j .le. m) goto 25
        j = j-m
        m = m/2
        if (m .ge. 1) goto 20
  25    j = j+m
  30  continue
      l = 1
  40  istep = l+l
      do 50 m=1,l
        carg = cmplx(0.,pi*float(m-1)/float(l))
        cw = cexp(carg)
        do 45 i=m,lx,istep
          temp = cw*cx(i+l) 
          cx(i+l) = cx(i)-temp
          cx(i) = cx(i)+temp
  45    continue
  50  continue
      l = istep
      if (l .lt. lx) goto 40
      return
      end

c***********************************
      subroutine hpass(n,npts,fc,df)
c     This subroutine is a "n" pole high-pass Butterworth filter
      complex cx(8200)
      real omega, df, fc
      integer npts
      common cx
      
      domega = df/fc
      do 100 i=2,npts/2
        omega = (i-1)*domega
        YH = sqrt(omega**(2*n)/(1.+omega**(2*n)))
        cx(i) = cx(i)*YH
        cx(npts-i+2) = cx(npts-i+2)*YH
 100  continue
      cx(1) = cmplx(0.,0.)
      return
      end

      subroutine warn(msg)
      character*(*) msg
      write(*,100) msg
 100  format(1x,a)
      return
      end
      subroutine tnoua(ia)
c
c $$$$$ calls no other routine $$$$$
c
c   Subroutine tnoua writes the character string ia to the standard 
c   output without the trailing newline (allowing user input on the 
c   same line).  Programmed on 17 September 1980 by R. Buland.
c
      save
      character*(*) ia
      write(*,100)ia
 100  format(a,$)
      return
      end
      subroutine dasign(lu,mode,ia,len)
c
c $$$$$ calls no other routine $$$$$
c
c   Subroutine dasign opens (connects) logical unit lu to the disk file
c   named by the character string ia with mode mode.  If iabs(mode) = 1,
c   then open the file for reading.  If iabs(mode) = 2, then open the
c   file for writing.  If iabs(mode) = 3, then open a scratch file for
c   writing.  If mode > 0, then the file is formatted.  If mode < 0,
c   then the file is unformatted.  All files opened by dasign are
c   assumed to be direct access.  Programmed on 3 December 1979 by
c   R. Buland.
c
      save
      character*(*) ia
      logical exst
c
      if(mode.ge.0) nf=1
      if(mode.lt.0) nf=2
      ns=iabs(mode)
      if(ns.le.0.or.ns.gt.3) ns=3
      go to (1,2),nf
 1    go to (11,12,13),ns
 11   open(lu,file=ia,status='old',form='formatted',
     1 access='direct',recl=len)
      return
 12   inquire(file=ia,exist=exst)
      if(exst) go to 11
 13   open(lu,file=ia,status='new',form='formatted',
     1 access='direct',recl=len)
      return
 2    go to (21,22,23),ns
 21   open(lu,file=ia,status='old',form='unformatted',access='direct',
     1 recl=len)
      return
 22   inquire(file=ia,exist=exst)
      if(exst) go to 21
 23   open(lu,file=ia,status='new',form='unformatted',access='direct',
     1 recl=len)
      return
      end
      subroutine vexit(ierr)
      call exit(ierr)
      end

      INTEGER FUNCTION DAYMO(DOFY, MONTH, DAY, YEAR)
C
C Function daymo determines the month and day
C of the month,given the year and day of year.
C It returns 1 if it was successful,0 otherwise.
C If dofy is not within legal limits,month and
C day will be returned as zero.
C
C
C Calls:
C   lpyr
C
C      Programmed by Madeleine Zirbes
C         September 15,1980
C
C DAY OF YEAR - INPUT
      INTEGER DOFY
C MONTH - OUTPUT
      INTEGER MONTH
C DAY OF MONTH - OUTPUT
      INTEGER DAY
C YEAR - INPUT
      INTEGER YEAR
C
C DAY OF YEAR
      INTEGER IDAY
C FUNCTION
      INTEGER LPYR
C NUMBER OF DAYS IN MONTH
      INTEGER MDAYS(12)
      DATA MDAYS/31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/
C
      IDAY = DOFY
      IF (.NOT.(IDAY .LT. 1)) GOTO 2060
        MONTH = 0
        DAY = 0
        DAYMO = (0)
        RETURN
C
2060  CONTINUE
      IF (.NOT.(LPYR(YEAR) .EQ. 1)) GOTO 2080
        MDAYS(2) = 29
        GOTO 2090
2080  CONTINUE
        MDAYS(2) = 28
C
2090  CONTINUE
      DO 2100 MONTH = 1, 12
        DAY = IDAY
        IDAY = IDAY - MDAYS(MONTH)
        IF (.NOT.(IDAY .LE. 0)) GOTO 2120
          DAYMO = (1)
          RETURN
2120    CONTINUE
C
2100  CONTINUE
      MONTH = 0
      DAY = 0
      DAYMO = (0)
      RETURN
C
      END

      subroutine asnag1(lu,mode,n,ia,ib)
c
c $$$$$ calls assign, iargc, and getarg $$$$$
c
c   Asnag1 assigns logical unit lu to a direct access disk file
c   with mode "mode" and record length "len".  See dasign for
c   details.  The n th argument is used as the model name.  If there
c   is no n th argument and ib is non-blank, it is taken to be the
c   model name.  If ib is blank, the user is prompted for the
c   model name using the character string in variable ia as the
c   prompt.  Programmed on 8 October 1980 by R. Buland.
c
      save
      logical log
      character*(*) ia,ib
c
cccc these lines commented out 10/28/92  LSG
c     if(iargc(i).lt.n) go to 1
c     call getarg(n,ib)
c     go to 2
cccc end commented section
c
 1    if(ib.ne.' ') go to 2
      call query(ia,log)
      read(*,100)ib
 100  format(a)
c
 2    nb=index(ib,' ')-1
      if(nb.le.0) nb=len(ib)
      call assign(lu,mode,ib(1:nb)//'.hed')
      return
      end
      subroutine assign(lu,mode,ia)
c
c $$$$$ calls no other routine $$$$$
c
c   Subroutine assign opens (connects) logical unit lu to the disk file
c   named by the character string ia with mode mode.  If iabs(mode) = 1,
c   then open the file for reading.  If iabs(mode) = 2, then open the
c   file for writing.  If iabs(mode) = 3, then open a scratch file for
c   writing.  If mode > 0, then the file is formatted.  If mode < 0,
c   then the file is unformatted.  All files opened by assign are
c   assumed to be sequential.  Programmed on 3 December 1979 by
c   R. Buland.
c
      save
      character*(*) ia
      logical exst
c
      if(mode.ge.0) nf=1
      if(mode.lt.0) nf=2
      ns=iabs(mode)
      if(ns.le.0.or.ns.gt.3) ns=3
      go to (1,2),nf
 1    go to (11,12,13),ns
 11   open(lu,file=ia,status='old',form='formatted')
      rewind lu
      return
 12   inquire(file=ia,exist=exst)
      if(exst) go to 11
 13   open(lu,file=ia,status='new',form='formatted')
      return
 2    go to (21,22,23),ns
 21   open(lu,file=ia,status='old',form='unformatted')
      rewind lu
      return
 22   inquire(file=ia,exist=exst)
      if(exst) go to 21
 23   open(lu,file=ia,status='new',form='unformatted')
      return
      end
      subroutine bkin(lu,nrec,len,buf)
c
c $$$$$ calls no other routines $$$$$
c
c   Bkin reads a block of len double precision words into array buf(len)
c   from record nrec of the direct access unformatted file connected to
c   logical unit lu.
c
      save
      double precision buf(len),tmp
c
      if(nrec.le.0) go to 1
      read(lu,rec=nrec)buf
      tmp=buf(1)
      return
c   If the record doesn't exist, zero fill the buffer.
 1    do 2 i=1,len
 2    buf(i)=0d0
      return
      end
      subroutine brnset(nn,pcntl,prflg)
c
c   Brnset takes character array pcntl(nn) as a list of nn tokens to be
c   used to select desired generic branches.  Prflg(3) is the old
c   prnt(2) debug print flags in the first two elements plus a new print
c   flag which controls a branch selected summary from brnset.  Note that
c   the original two flags controlled a list of all tau interpolations
c   and a branch range summary respectively.  The original summary output
c   still goes to logical unit 10 (ttim1.lis) while the new output goes
c   to the standard output (so the caller can see what happened).  Each
c   token of pcntl may be either a generic branch name (e.g., P, PcP,
c   PKP, etc.) or a keyword (defined in the data statement for cmdcd
c   below) which translates to more than one generic branch names.  Note
c   that generic branch names and keywords may be mixed.  The keywords
c   'all' (for all branches) and 'query' (for an interactive token input
c   query mode) are also available.
c
      save
      parameter(ncmd=4,lcmd=16)
      include 'ttlim.inc'
      logical prflg(3),segmsk,prnt,fnd,all
      character*(*) pcntl(nn)
      character*8 phcd,segcd(jbrn),cmdcd(ncmd),cmdlst(lcmd),phtmp,
     1 phlst(jseg)
      double precision zs,pk,pu,pux,tauu,xu,px,xt,taut,coef,tauc,xc,
     1 tcoef,tp
      dimension nsgpt(jbrn),ncmpt(2,ncmd)
      common/brkc/zs,pk(jseg),pu(jtsm0,2),pux(jxsm,2),tauu(jtsm,2),
     1 xu(jxsm,2),px(jbrn,2),xt(jbrn,2),taut(jout),coef(5,jout),
     2 tauc(jtsm),xc(jxsm),tcoef(5,jbrna,2),tp(jbrnu,2),odep,
     3 fcs(jseg,3),nin,nph0,int0(2),ki,msrc(2),isrc(2),nseg,nbrn,ku(2),
     4 km(2),nafl(jseg,3),indx(jseg,2),kndx(jseg,2),iidx(jseg),
     5 jidx(jbrn),kk(jseg)
      common/pcdc/phcd(jbrn)
c   Segmsk is a logical array that actually implements the branch
c   editing in depset and depcor.
      common/prtflc/segmsk(jseg),prnt(2)
c
c   The keywords do the following:
c      P      gives P-up, P, Pdiff, PKP, and PKiKP
c      P+     gives P-up, P, Pdiff, PKP, PKiKP, PcP, pP, pPdiff, pPKP,
c             pPKiKP, sP, sPdiff, sPKP, and sPKiKP
c      S+     gives S-up, S, Sdiff, SKS, sS, sSdiff, sSKS, pS, pSdiff,
c             and pSKS
c      basic  gives P+ and S+ as well as ScP, SKP, PKKP, SKKP, PP, and
c             P'P'
c   Note that generic S gives S-up, Sdiff, and SKS already and so
c   doesn't require a keyword.
c
      data cmdcd/'P','P+','basic','S+'/
      data cmdlst/'P','PKiKP','PcP','pP','pPKiKP','sP','sPKiKP','ScP',
     1 'SKP','PKKP','SKKP','PP','S','ScS','sS','pS'/
      data ncmpt/1,2,1,7,1,13,13,16/
c
cccc changed initialization for multiple calls
c
      do i = 1, jseg
        segmsk(i) = .true.
      end do
c
cccc
c
c   Take care of the print flags.
      prnt(1)=prflg(1)
      prnt(2)=prflg(2)
      if(prnt(1)) prnt(2)=.true.
c   Copy the token list into local storage.
      no=min0(nn,jseg)
      do 23 i=1,no
 23   phlst(i)=pcntl(i)
c   See if we are in query mode.
      if(no.gt.1.or.(phlst(1).ne.'query'.and.phlst(1).ne.'QUERY'))
     1 go to 1
c
c   In query mode, get the tokens interactively into local storage.
c
 22   print *,'Enter desired branch control list at the prompts:'
      no=0
 21   call query(' ',fnd)
      if(no.ge.jseg) go to 1
      no=no+1
      read 100,phlst(no)
 100  format(a)
c   Terminate the list of tokens with a blank entry.
      if(phlst(no).ne.' ') go to 21
      no=no-1
      if(no.gt.0) go to 1
c   If the first token is blank, help the user out.
      print *,'You must enter some branch control information!'
      print *,'     possibilities are:'
      print *,'          all'
      print 101,cmdcd
 101  format(11x,a)
      print *,'          or any generic phase name'
      go to 22
c
c   An 'all' keyword is easy as this is already the default.
 1    all=.false.
      if(no.eq.1.and.(phlst(1).eq.'all'.or.phlst(1).eq.'ALL')) then
        all=.true.
      endif
      if (all.and..not.prflg(3)) return
c
c   Make one or two generic branch names for each segment.  For example,
c   the P segment will have the names P and PKP, the PcP segment will
c   have the name PcP, etc.
c
      kseg=0
      j=0
c   Loop over the segments.
      do 2 i=1,nseg
      if(.not.all) segmsk(i)=.false.
c   For each segment, loop over associated branches.
 9    j=j+1
      phtmp=phcd(j)
c   Turn the specific branch name into a generic name by stripping out
c   the crustal branch and core phase branch identifiers.
      do 3 l=2,8
 6    if(phtmp(l:l).eq.' ') go to 4
      if(phtmp(l:l).ne.'g'.and.phtmp(l:l).ne.'b'.and.phtmp(l:l).ne.'n')
     1 go to 5
      if(l.lt.8) phtmp(l:)=phtmp(l+1:)
      if(l.ge.8) phtmp(l:)=' '
      go to 6
 5    if(l.ge.8) go to 3
      if(phtmp(l:l+1).ne.'ab'.and.phtmp(l:l+1).ne.'ac'.and.
     1 phtmp(l:l+1).ne.'df') go to 3
      phtmp(l:)=' '
      go to 4
 3    continue
c4    print *,'j phcd phtmp =',j,' ',phcd(j),' ',phtmp
c
c   Make sure generic names are unique within a segment.
 4    if(kseg.lt.1) go to 7
      if(phtmp.eq.segcd(kseg)) go to 8
 7    kseg=kseg+1
      segcd(kseg)=phtmp
      nsgpt(kseg)=i
c     if(prflg(3)) print *,'kseg nsgpt segcd =',kseg,nsgpt(kseg),' ',
c    1 segcd(kseg)
 8    if(jidx(j).lt.indx(i,2)) go to 9
 2    continue
      if(all) go to 24
c
c   Interpret the tokens in terms of the generic branch names.
c
      do 10 i=1,no
c   Try for a keyword first.
      do 11 j=1,ncmd
      if(phlst(i).eq.cmdcd(j)) go to 12
 11   continue
c
c   If the token isn't a keyword, see if it is a generic branch name.
      fnd=.false.
      do 14 k=1,kseg
      if(phlst(i).ne.segcd(k)) go to 14
      fnd=.true.
      l=nsgpt(k)
      segmsk(l)=.true.
c     print *,'Brnset:  phase found - i k l segcd =',i,k,l,' ',
c    1 segcd(k)
 14   continue
c   If no matching entry is found, warn the caller.
      if(.not.fnd) print *,'Brnset:  phase ',phlst(i),' not found.'
      go to 10
c
c   If the token is a keyword, find the matching generic branch names.
 12   j1=ncmpt(1,j)
      j2=ncmpt(2,j)
      do 15 j=j1,j2
      do 15 k=1,kseg
      if(cmdlst(j).ne.segcd(k)) go to 15
      l=nsgpt(k)
      segmsk(l)=.true.
c     print *,'Brnset:  cmdlst found - j k l segcd =',j,k,l,' ',
c    1 segcd(k)
 15   continue
 10   continue
c
c   Make the caller a list of the generic branch names selected.
c
 24   if(.not.prflg(3)) return
      fnd=.false.
      j2=0
c   Loop over segments.
      do 16 i=1,nseg
      if(.not.segmsk(i)) go to 16
c   If selected, find the associated generic branch names.
      j2=j2+1
      do 17 j1=j2,kseg
      if(nsgpt(j1).eq.i) go to 18
 17   continue
      print *,'Brnset:  Segment pointer (',i,') missing?'
      go to 16
 18   do 19 j2=j1,kseg
      if(nsgpt(j2).ne.i) go to 20
 19   continue
      j2=kseg+1
c   Print the result.
 20   j2=j2-1
      if(.not.fnd) print *,'Brnset:  the following phases have '//
     1 'been selected -'
      fnd=.true.
      print 102,i,(segcd(j),j=j1,j2)
 102  format(10x,i5,5(2x,a))
 16   continue
      return
      end
      subroutine depcor(nph)
      save
      include 'ttlim.inc'
      character*8 phcd
      logical noend,noext,segmsk,prnt
      double precision pm,zm,us,pt,tau,xlim,xbrn,dbrn,zs,pk,pu,pux,tauu,
     1 xu,px,xt,taut,coef,tauc,xc,tcoef,tp,ua,taua
      double precision tup(jrec),umod,zmod,tauus1(2),tauus2(2),xus1(2),
     1 xus2(2),ttau,tx,sgn,umin,dtol,u0,u1,z0,z1,fac,du
      common/umdc/pm(jsrc,2),zm(jsrc,2),ndex(jsrc,2),mt(2)
      common/tabc/us(2),pt(jout),tau(4,jout),xlim(2,jout),xbrn(jbrn,3),
     1 dbrn(jbrn,2),xn,pn,tn,dn,hn,jndx(jbrn,2),idel(jbrn,3),mbr1,mbr2
      common/brkc/zs,pk(jseg),pu(jtsm0,2),pux(jxsm,2),tauu(jtsm,2),
     1 xu(jxsm,2),px(jbrn,2),xt(jbrn,2),taut(jout),coef(5,jout),
     2 tauc(jtsm),xc(jxsm),tcoef(5,jbrna,2),tp(jbrnu,2),odep,
     3 fcs(jseg,3),nin,nph0,int0(2),ki,msrc(2),isrc(2),nseg,nbrn,ku(2),
     4 km(2),nafl(jseg,3),indx(jseg,2),kndx(jseg,2),iidx(jseg),
     5 jidx(jbrn),kk(jseg)
      common/pcdc/phcd(jbrn)
      common/pdec/ua(5,2),taua(5,2),deplim,ka
      common/prtflc/segmsk(jseg),prnt(2)
      equivalence (tauc,tup)
      data tol,dtol,deplim,ka,lpower/.01,1d-6,1.1,4,7/
c
c     write(10,*)'depcor:  nph nph0',nph,nph0
      if(nph.eq.nph0) go to 1
      nph0=nph
      us(nph)=umod(zs,isrc,nph)
c   If we are in a high slowness zone, find the slowness of the lid.
      umin=us(nph)
      ks=isrc(nph)
c     write(10,*)'ks us',ks,sngl(umin)
      do 2 i=1,ks
      if(pm(i,nph).gt.umin) go to 2
      umin=pm(i,nph)
 2    continue
c   Find where the source slowness falls in the ray parameter array.
      n1=ku(nph)+1
      do 3 i=2,n1
      if(pu(i,nph).gt.umin) go to 4
 3    continue
      k2=n1
      if(pu(n1,nph).eq.umin) go to 50
      call abort('Source slowness too large.')
 4    k2=i
c50   write(10,*)'k2 umin',k2,sngl(umin)
c
c   Read in the appropriate depth correction values.
c
 50   noext=.false.
      sgn=1d0
      if(msrc(nph).eq.0) msrc(nph)=1
c   See if the source depth coincides with a model sample
      ztol=xn*tol/(1.-xn*odep)
      if(dabs(zs-zm(ks+1,nph)).gt.ztol) go to 5
      ks=ks+1
      go to 6
 5    if(dabs(zs-zm(ks,nph)).gt.ztol) go to 7
c   If so flag the fact and make sure that the right integrals are
c   available.
 6    noext=.true.
      if(msrc(nph).eq.ks) go to 8
      call bkin(nin,ndex(ks,nph),ku(nph)+km(nph),tup)
      go to 11
c   If it is necessary to interpolate, see if appropriate integrals
c   have already been read in.
 7    if(msrc(nph).ne.ks+1) go to 9
      ks=ks+1
      sgn=-1d0
      go to 8
 9    if(msrc(nph).eq.ks) go to 8
c   If not, read in integrals for the model depth nearest the source
c   depth.
      if(dabs(zm(ks,nph)-zs).le.dabs(zm(ks+1,nph)-zs)) go to 10
      ks=ks+1
      sgn=-1d0
 10   call bkin(nin,ndex(ks,nph),ku(nph)+km(nph),tup)
c   Move the depth correction values to a less temporary area.
 11   do 31 i=1,ku(nph)
 31   tauu(i,nph)=tup(i)
      k=ku(nph)
      do 12 i=1,km(nph)
      k=k+1
      xc(i)=tup(k)
 12   xu(i,nph)=tup(k)
c     write(10,*)'bkin',ks,sngl(sgn),sngl(tauu(1,nph)),sngl(xu(1,nph))
c
c   Fiddle pointers.
c
 8    msrc(nph)=ks
c     write(10,*)'msrc sgn',msrc(nph),sngl(sgn)
      noend=.false.
      if(dabs(umin-pu(k2-1,nph)).le.dtol*umin) k2=k2-1
      if(dabs(umin-pu(k2,nph)).le.dtol*umin) noend=.true.
      if(msrc(nph).le.1.and.noext) msrc(nph)=0
      k1=k2-1
      if(noend) k1=k2
c     write(10,*)'noend noext k2 k1',noend,noext,k2,k1
      if(noext) go to 14
c
c   Correct the integrals for the depth interval [zm(msrc),zs].
c
      ms=msrc(nph)
      if(sgn)15,16,16
 16   u0=pm(ms,nph)
      z0=zm(ms,nph)
      u1=us(nph)
      z1=zs
      go to 17
 15   u0=us(nph)
      z0=zs
      u1=pm(ms,nph)
      z1=zm(ms,nph)
 17   mu=1
c     write(10,*)'u0 z0',sngl(u0),sngl(z0)
c     write(10,*)'u1 z1',sngl(u1),sngl(z1)
      do 18 k=1,k1
      call tauint(pu(k,nph),u0,u1,z0,z1,ttau,tx)
      tauc(k)=tauu(k,nph)+sgn*ttau
      if(dabs(pu(k,nph)-pux(mu,nph)).gt.dtol) go to 18
      xc(mu)=xu(mu,nph)+sgn*tx
c     write(10,*)'up x:  k mu',k,mu,sngl(xu(mu,nph)),sngl(xc(mu))
      mu=mu+1
 18   continue
      go to 39
c   If there is no correction, copy the depth corrections to working
c   storage.
 14   mu=1
      do 40 k=1,k1
      tauc(k)=tauu(k,nph)
      if(dabs(pu(k,nph)-pux(mu,nph)).gt.dtol) go to 40
      xc(mu)=xu(mu,nph)
c     write(10,*)'up x:  k mu',k,mu,sngl(xu(mu,nph)),sngl(xc(mu))
      mu=mu+1
 40   continue
c
c   Calculate integrals for the ray bottoming at the source depth.
c
 39   xus1(nph)=0d0
      xus2(nph)=0d0
      mu=mu-1
      if(dabs(umin-us(nph)).gt.dtol.and.dabs(umin-pux(mu,nph)).le.dtol)
     1  mu=mu-1
c   This loop may be skipped only for surface focus as range is not
c   available for all ray parameters.
      if(msrc(nph).le.0) go to 1
      is=isrc(nph)
      tauus2(nph)=0d0
      if(dabs(pux(mu,nph)-umin).gt.dtol.or.dabs(us(nph)-umin).gt.dtol)
     1  go to 48
c   If we happen to be right at a discontinuity, range is available.
      tauus1(nph)=tauc(k1)
      xus1(nph)=xc(mu)
c     write(10,*)'is ks tauus1 xus1',is,ks,sngl(tauus1(nph)),
c    1 sngl(xus1(nph)),'  *'
      go to 33
c   Integrate from the surface to the source.
 48   tauus1(nph)=0d0
      j=1
      if(is.lt.2) go to 42
      do 19 i=2,is
      call tauint(umin,pm(j,nph),pm(i,nph),zm(j,nph),zm(i,nph),ttau,tx)
      tauus1(nph)=tauus1(nph)+ttau
      xus1(nph)=xus1(nph)+tx
 19   j=i
c     write(10,*)'is ks tauus1 xus1',is,ks,sngl(tauus1(nph)),
c    1 sngl(xus1(nph))
 42   if(dabs(zm(is,nph)-zs).le.dtol) go to 33
c   Unless the source is right on a sample slowness, one more partial
c   integral is needed.
      call tauint(umin,pm(is,nph),us(nph),zm(is,nph),zs,ttau,tx)
      tauus1(nph)=tauus1(nph)+ttau
      xus1(nph)=xus1(nph)+tx
c     write(10,*)'is ks tauus1 xus1',is,ks,sngl(tauus1(nph)),
c    1 sngl(xus1(nph))
 33   if(pm(is+1,nph).lt.umin) go to 41
c   If we are in a high slowness zone, we will also need to integrate
c   down to the turning point of the shallowest down-going ray.
      u1=us(nph)
      z1=zs
      do 35 i=is+1,mt(nph)
      u0=u1
      z0=z1
      u1=pm(i,nph)
      z1=zm(i,nph)
      if(u1.lt.umin) go to 36
      call tauint(umin,u0,u1,z0,z1,ttau,tx)
      tauus2(nph)=tauus2(nph)+ttau
 35   xus2(nph)=xus2(nph)+tx
c36   write(10,*)'is ks tauus2 xus2',is,ks,sngl(tauus2(nph)),
c    1 sngl(xus2(nph))
 36   z1=zmod(umin,i-1,nph)
      if(dabs(z0-z1).le.dtol) go to 41
c   Unless the turning point is right on a sample slowness, one more
c   partial integral is needed.
      call tauint(umin,u0,umin,z0,z1,ttau,tx)
      tauus2(nph)=tauus2(nph)+ttau
      xus2(nph)=xus2(nph)+tx
c     write(10,*)'is ks tauus2 xus2',is,ks,sngl(tauus2(nph)),
c    1 sngl(xus2(nph))
c
c   Take care of converted phases.
c
 41   iph=mod(nph,2)+1
      xus1(iph)=0d0
      xus2(iph)=0d0
      tauus1(iph)=0d0
      tauus2(iph)=0d0
      go to (59,61),nph
 61   if(umin.gt.pu(ku(1)+1,1)) go to 53
c
c   If we are doing an S-wave depth correction, we may need range and
c   tau for the P-wave which turns at the S-wave source slowness.  This
c   would bd needed for sPg and SPg when the source is in the deep mantle.
c
      do 44 j=1,nbrn
      if((phcd(j)(1:2).ne.'sP'.and.phcd(j)(1:2).ne.'SP').or.
     1 px(j,2).le.0d0) go to 44
c     write(10,*)'Depcor:  j phcd px umin =',j,' ',phcd(j),px(j,1),
c    1 px(j,2),umin
      if(umin.ge.px(j,1).and.umin.lt.px(j,2)) go to 45
 44   continue
      go to 53
c
c   If we are doing an P-wave depth correction, we may need range and
c   tau for the S-wave which turns at the P-wave source slowness.  This
c   would be needed for pS and PS.
c
 59   do 60 j=1,nbrn
      if((phcd(j)(1:2).ne.'pS'.and.phcd(j)(1:2).ne.'PS').or.
     1 px(j,2).le.0d0) go to 60
c     write(10,*)'Depcor:  j phcd px umin =',j,' ',phcd(j),px(j,1),
c    1 px(j,2),umin
      if(umin.ge.px(j,1).and.umin.lt.px(j,2)) go to 45
 60   continue
      go to 53
c
c   Do the integral.
 45   j=1
c     write(10,*)'Depcor:  do pS or sP integral - iph =',iph
      do 46 i=2,mt(iph)
      if(umin.ge.pm(i,iph)) go to 47
      call tauint(umin,pm(j,iph),pm(i,iph),zm(j,iph),zm(i,iph),ttau,tx)
      tauus1(iph)=tauus1(iph)+ttau
      xus1(iph)=xus1(iph)+tx
 46   j=i
 47   z1=zmod(umin,j,iph)
      if(dabs(zm(j,iph)-z1).le.dtol) go to 53
c   Unless the turning point is right on a sample slowness, one more
c   partial integral is needed.
      call tauint(umin,pm(j,iph),umin,zm(j,iph),z1,ttau,tx)
      tauus1(iph)=tauus1(iph)+ttau
      xus1(iph)=xus1(iph)+tx
c     write(10,*)'is ks tauusp xusp',j,ks,sngl(tauus1(iph)),
c    1 sngl(xus1(iph))
c
 53   ua(1,nph)=-1d0
c     if(odep.ge.deplim.or.odep.le..1) go to 43
      if(odep.ge.deplim) go to 43
      do 57 i=1,nseg
      if(.not.segmsk(i)) go to 57
      if(nafl(i,1).eq.nph.and.nafl(i,2).eq.0.and.iidx(i).le.0) go to 58
 57   continue
      go to 43
c
c   If the source is very shallow, we will need to insert some extra
c   ray parameter samples into the up-going branches.
c
 58   du=amin1(1e-5+(odep-.4)*2e-5,1e-5)
c     write(10,*)'Add:  nph is ka odep du us =',nph,is,ka,odep,
c    1 sngl(du),sngl(us(nph))
      lp=lpower
      k=0
      do 56 l=ka,1,-1
      k=k+1
      ua(k,nph)=us(nph)-(l**lp)*du
      lp=lp-1
      taua(k,nph)=0d0
      j=1
      if(is.lt.2) go to 54
      do 55 i=2,is
      call tauint(ua(k,nph),pm(j,nph),pm(i,nph),zm(j,nph),zm(i,nph),
     1 ttau,tx)
      taua(k,nph)=taua(k,nph)+ttau
 55   j=i
c     write(10,*)'l k ua taua',l,k,sngl(ua(k,nph)),sngl(taua(k,nph))
 54   if(dabs(zm(is,nph)-zs).le.dtol) go to 56
c   Unless the source is right on a sample slowness, one more partial
c   integral is needed.
      call tauint(ua(k,nph),pm(is,nph),us(nph),zm(is,nph),zs,ttau,tx)
      taua(k,nph)=taua(k,nph)+ttau
c     write(10,*)'l k ua taua',l,k,sngl(ua(k,nph)),sngl(taua(k,nph))
 56   continue
      go to 43
c
c   Construct tau for all branches.
c
 1    mu=mu+1
 43   j=1
c     write(10,*)'mu',mu
c     write(10,*)'killer loop:'
      do 20 i=1,nseg
      if(.not.segmsk(i)) go to 20
c     write(10,*)'i iidx nafl nph',i,iidx(i),nafl(i,1),nph
      if(iidx(i).gt.0.or.iabs(nafl(i,1)).ne.nph.or.(msrc(nph).le.0.and.
     1 nafl(i,1).gt.0)) go to 20
c
      iph=nafl(i,2)
      kph=nafl(i,3)
c   Handle up-going P and S.
      if(iph.le.0) iph=nph
      if(kph.le.0) kph=nph
      sgn=isign(1,nafl(i,1))
      i1=indx(i,1)
      i2=indx(i,2)
c     write(10,*)'i1 i2 sgn iph',i1,i2,sngl(sgn),iph
      m=1
      do 21 k=i1,i2
      if(pt(k).gt.umin) go to 22
 23   if(dabs(pt(k)-pu(m,nph)).le.dtol) go to 21
      m=m+1
      go to 23
 21   tau(1,k)=taut(k)+sgn*tauc(m)
      k=i2
c     write(10,*)'k m',k,m
      go to 24
c22   write(10,*)'k m',k,m
 22   if(dabs(pt(k-1)-umin).le.dtol) k=k-1
      ki=ki+1
      kk(ki)=k
      pk(ki)=pt(k)
      pt(k)=umin
      fac=fcs(i,1)
c     write(10,*)'ki fac',ki,sngl(fac)
      tau(1,k)=fac*(tauus1(iph)+tauus2(iph)+tauus1(kph)+tauus2(kph))+
     1 sgn*tauus1(nph)
c     write(10,*)'&&&&& nph iph kph tauus1 tauus2 tau =',
c    1 nph,iph,kph,sngl(tauus1(1)),sngl(tauus1(2)),sngl(tauus2(1)),
c    2 sngl(tauus2(2)),sngl(tau(1,k))
 24   m=1
 26   if(jndx(j,1).ge.indx(i,1)) go to 25
      j=j+1
      go to 26
 25   jndx(j,2)=min0(jidx(j),k)
      if(jndx(j,1).lt.jndx(j,2)) go to 37
      jndx(j,2)=-1
      go to 20
c37   write(10,*)'j jndx jidx',j,jndx(j,1),jndx(j,2),jidx(j),' ',
c    1 phcd(j)
 37   do 30 l=1,2
 28   if(dabs(pux(m,nph)-px(j,l)).le.dtol) go to 27
      if(m.ge.mu) go to 29
      m=m+1
      go to 28
 27   xbrn(j,l)=xt(j,l)+sgn*xc(m)
c     write(10,*)'x up:  j l m  ',j,l,m
      go to 30
 29   xbrn(j,l)=fac*(xus1(iph)+xus2(iph)+xus1(kph)+xus2(kph))+
     1 sgn*xus1(nph)
c     write(10,*)'x up:  j l end',j,l
c     write(10,*)'&&&&& nph iph kph xus1 xus2 xbrn =',
c    1 nph,iph,kph,sngl(xus1(1)),sngl(xus1(2)),sngl(xus2(1)),
c    2 sngl(xus2(2)),sngl(xbrn(j,l))
 30   continue
      if(j.ge.nbrn) go to 20
      j=j+1
      if(jndx(j,1).le.k) go to 25
 20   continue
      return
      end
      subroutine depset(dep,usrc)
      save 
      include 'ttlim.inc'
      logical dop,dos,segmsk,prnt
      character*8 phcd
      real usrc(2)
      double precision pm,zm,us,pt,tau,xlim,xbrn,dbrn,zs,pk,pu,pux,tauu,
     1 xu,px,xt,taut,coef,tauc,xc,tcoef,tp
      common/umdc/pm(jsrc,2),zm(jsrc,2),ndex(jsrc,2),mt(2)
      common/tabc/us(2),pt(jout),tau(4,jout),xlim(2,jout),xbrn(jbrn,3),
     1 dbrn(jbrn,2),xn,pn,tn,dn,hn,jndx(jbrn,2),idel(jbrn,3),mbr1,mbr2
      common/brkc/zs,pk(jseg),pu(jtsm0,2),pux(jxsm,2),tauu(jtsm,2),
     1 xu(jxsm,2),px(jbrn,2),xt(jbrn,2),taut(jout),coef(5,jout),
     2 tauc(jtsm),xc(jxsm),tcoef(5,jbrna,2),tp(jbrnu,2),odep,
     3 fcs(jseg,3),nin,nph0,int0(2),ki,msrc(2),isrc(2),nseg,nbrn,ku(2),
     4 km(2),nafl(jseg,3),indx(jseg,2),kndx(jseg,2),iidx(jseg),
     5 jidx(jbrn),kk(jseg)
      common/pcdc/phcd(jbrn)
      common/prtflc/segmsk(jseg),prnt(2)
      data segmsk,prnt/jseg*.true.,2*.false./
c
      if(amax1(dep,.011).ne.odep) go to 1
      dop=.false.
      dos=.false.
      do 2 i=1,nseg
      if(.not.segmsk(i).or.iidx(i).gt.0) go to 2
      if(iabs(nafl(i,1)).le.1) dop=.true.
      if(iabs(nafl(i,1)).ge.2) dos=.true.
 2    continue
      if(.not.dop.and..not.dos) return
      go to 3
c
 1    nph0=0
      int0(1)=0
      int0(2)=0
      mbr1=nbrn+1
      mbr2=0
      dop=.false.
      dos=.false.
      do 4 i=1,nseg
      if(.not.segmsk(i)) go to 4
      if(iabs(nafl(i,1)).le.1) dop=.true.
      if(iabs(nafl(i,1)).ge.2) dos=.true.
 4    continue
      do 5 i=1,nseg
      if(nafl(i,2).gt.0.or.odep.lt.0.) go to 5
      ind=nafl(i,1)
      k=0
      do 15 j=indx(i,1),indx(i,2)
      k=k+1
 15   pt(j)=tp(k,ind)
 5    iidx(i)=-1
      do 6 i=1,nbrn
 6    jndx(i,2)=-1
      if(ki.le.0) go to 7
      do 8 i=1,ki
      j=kk(i)
 8    pt(j)=pk(i)
      ki=0
c   Sample the model at the source depth.
 7    odep=amax1(dep,.011)
      rdep=dep
      if(rdep.lt..011) rdep=0.
      zs=amin1(alog(amax1(1.-rdep*xn,1e-30)),0.)
      hn=1./(pn*(1.-rdep*xn))
      if(prnt(1).or.prnt(2)) write(10,100)dep
 100  format(/1x,'Depth =',f7.2/)
c
 3    if(nph0.gt.1) go to 12
      if(dop) call depcor(1)
      if(dos) call depcor(2)
      go to 14
 12   if(dos) call depcor(2)
      if(dop) call depcor(1)
c
c   Interpolate all tau branches.
c
 14   j=1
      do 9 i=1,nseg
      if(.not.segmsk(i)) go to 9
      nph=iabs(nafl(i,1))
c     print *,'i iidx nph msrc nafl =',i,iidx(i),nph,msrc(nph),nafl(i,1)
      if(iidx(i).gt.0.or.(msrc(nph).le.0.and.nafl(i,1).gt.0)) go to 9
      iidx(i)=1
      if(nafl(i,2).le.0) int=nafl(i,1)
      if(nafl(i,2).gt.0.and.nafl(i,2).eq.iabs(nafl(i,1)))
     1  int=nafl(i,2)+2
      if(nafl(i,2).gt.0.and.nafl(i,2).ne.iabs(nafl(i,1)))
     1  int=iabs(nafl(i,1))+4
      if(nafl(i,2).gt.0.and.nafl(i,2).ne.nafl(i,3)) int=nafl(i,2)+6
 11   if(jndx(j,1).ge.indx(i,1)) go to 10
      j=j+1
      go to 11
 10   idel(j,3)=nafl(i,1)
c     print *,'spfit:  j int =',j,int 
      call spfit(j,int)
      mbr1=min0(mbr1,j)
      mbr2=max0(mbr2,j)
      if(j.ge.nbrn) go to 9
      j=j+1
c     print *,'j jidx indx jndx =',j,jidx(j),indx(i,2),jndx(j,2)
      if(jidx(j).le.indx(i,2).and.jndx(j,2).gt.0) go to 10
 9    continue
c
c     write(10,*)'mbr1 mbr2',mbr1,mbr2
c     write(10,*)'msrc isrc odep zs us',msrc,isrc,odep,sngl(zs),
c    1 sngl(us(1)),sngl(us(2))
c     write(10,200)ki,(i,iidx(i),kk(i),pk(i),i=1,nseg)
c200  format(/10x,i5/(1x,3i5,f12.6))
c
      usrc(1)=us(1)/pn
      usrc(2)=us(2)/pn
      return
      end
c
      subroutine findtt(jb,x0,max,n,tt,dtdd,dtdh,dddp,phnm)
      save
      include 'ttlim.inc'
      character*(*) phnm(max)
      character*8 phcd
      character*67 msg
      dimension tt(max),dtdd(max),dtdh(max),dddp(max)
      double precision us,pt,tau,xlim,xbrn,dbrn
      double precision x,x0(3),p0,p1,arg,dp,dps,delp,tol,ps,deps
      common/tabc/us(2),pt(jout),tau(4,jout),xlim(2,jout),xbrn(jbrn,3),
     1 dbrn(jbrn,2),xn,pn,tn,dn,hn,jndx(jbrn,2),idel(jbrn,3),mbr1,mbr2
      common/pcdc/phcd(jbrn)
      data tol/3d-6/,deps/1d-10/
c
      nph=iabs(idel(jb,3))
      hsgn=isign(1,idel(jb,3))*hn
      dsgn=(-1.)**idel(jb,1)*dn
      dpn=-1./tn
      do 10 ij=idel(jb,1),idel(jb,2)
      x=x0(ij)
      dsgn=-dsgn
      if(x.lt.xbrn(jb,1).or.x.gt.xbrn(jb,2)) go to 12
      j=jndx(jb,1)
      is=j+1
      ie=jndx(jb,2)
      do 1 i=is,ie
      if(x.le.xlim(1,j).or.x.gt.xlim(2,j)) go to 8
      le=n
      p0=pt(ie)-pt(j)
      p1=pt(ie)-pt(i)
      delp=dmax1(tol*(pt(i)-pt(j)),1d-3)
      if(dabs(tau(3,j)).gt.1d-30) go to 2
      dps=(x-tau(2,j))/(1.5d0*tau(4,j))
      dp=dsign(dps*dps,dps)
      dp0=dp
      if(dp.lt.p1-delp.or.dp.gt.p0+delp) go to 9
      if(n.ge.max) go to 13
      n=n+1
      ps=pt(ie)-dp
      tt(n)=tn*(tau(1,j)+dp*(tau(2,j)+dps*tau(4,j))+ps*x)
      dtdd(n)=dsgn*ps
      dtdh(n)=hsgn*sqrt(abs(sngl(us(nph)*us(nph)-ps*ps)))
      dddp(n)=dpn*.75d0*tau(4,j)/dmax1(dabs(dps),deps)
      phnm(n)=phcd(jb)
      in=index(phnm(n),'ab')
      if(in.le.0) go to 8
      if(ps.le.xbrn(jb,3)) phnm(n)(in:)='bc'
      go to 8
 2    do 4 jj=1,2
      go to (5,6),jj
 5    arg=9d0*tau(4,j)*tau(4,j)+32d0*tau(3,j)*(x-tau(2,j))
      if(arg.ge.0d0) go to 3
      write(msg,100)arg
 100  format('Bad sqrt argument:',1pd11.2,'.')
      call warn(msg(1:30))
 3    dps=-(3d0*tau(4,j)+dsign(dsqrt(dabs(arg)),tau(4,j)))/(8d0*
     1 tau(3,j))
      dp=dsign(dps*dps,dps)
      dp0=dp
      go to 7
 6    dps=(tau(2,j)-x)/(2d0*tau(3,j)*dps)
      dp=dsign(dps*dps,dps)
 7    if(dp.lt.p1-delp.or.dp.gt.p0+delp) go to 4
      if(n.ge.max) go to 13
      n=n+1
      ps=pt(ie)-dp
      tt(n)=tn*(tau(1,j)+dp*(tau(2,j)+dp*tau(3,j)+dps*tau(4,j))+ps*x)
      dtdd(n)=dsgn*ps
      dtdh(n)=hsgn*sqrt(abs(sngl(us(nph)*us(nph)-ps*ps)))
      dddp(n)=dpn*(2d0*tau(3,j)+.75d0*tau(4,j)/dmax1(dabs(dps),deps))
      phnm(n)=phcd(jb)
      in=index(phnm(n),'ab')
      if(in.le.0) go to 4
      if(ps.le.xbrn(jb,3)) phnm(n)(in:)='bc'
 4    continue
 9    if(n.gt.le) go to 8
      write(msg,101)phcd(jb),x,dp0,dp,p1,p0
 101  format('Failed to find phase:  ',a,f8.1,4f7.4)
      call warn(msg)
 8    j=i
 1    continue
c
 12   if(x.lt.dbrn(jb,1).or.x.gt.dbrn(jb,2)) go to 10
      if(n.ge.max) go to 13
      j=jndx(jb,1)
      i=jndx(jb,2)
      dp=pt(i)-pt(j)
      dps=dsqrt(dabs(dp))
      n=n+1
      tt(n)=tn*(tau(1,j)+dp*(tau(2,j)+dp*tau(3,j)+dps*tau(4,j))+
     1 pt(j)*x)
      dtdd(n)=dsgn*sngl(pt(j))
      dtdh(n)=hsgn*sqrt(abs(sngl(us(nph)*us(nph)-pt(j)*pt(j))))
      dddp(n)=dpn*(2d0*tau(3,j)+.75d0*tau(4,j)/dmax1(dps,deps))
      ln=index(phcd(jb),' ')-1
      if(ln.le.0) ln=len(phcd(jb))
      phnm(n)=phcd(jb)(1:ln)//'diff'
 10   continue
      return
 13   write(msg,102)max
 102  format('More than',i3,' arrivals found.')
      call warn(msg(1:28))
      return
      end
      subroutine fitspl(i1,i2,tau,x1,xn,coef)
c
c $$$$$ calls only library routines $$$$$
c
c   Given ray parameter grid p;i (p sub i), i=1,2,...,n, corresponding
c   tau;i values, and x;1 and x;n (x;i = -dtau/dp|p;i); tauspl finds
c   interpolation I such that:  tau(p) = a;1,i + Dp * a;2,i + Dp**2 *
c   a;3,i + Dp**(3/2) * a;4,i where Dp = p;n - p and p;i <= p < p;i+1.
c   Interpolation I has the following properties:  1) x;1, x;n, and
c   tau;i, i=1,2,...,n are fit exactly, 2) the first and second
c   derivitives with respect to p are continuous everywhere, and
c   3) because of the paramaterization d**2 tau/dp**2|p;n is infinite.
c   Thus, interpolation I models the asymptotic behavior of tau(p)
c   when tau(p;n) is a branch end due to a discontinuity in the
c   velocity model.  Note that array a must be dimensioned at least
c   a(4,n) though the interpolation coefficients will be returned in
c   the first n-1 columns.  The remaining column is used as scratch
c   space and returned as all zeros.  Programmed on 16 August 1982 by
c   R. Buland.
c
      save
      double precision tau(4,i2),x1,xn,coef(5,i2),a(2,60),ap(3),b(60),
     1 alr,g1,gn
c
      if(i2-i1)13,1,2
 1    tau(2,i1)=x1
 13   return
 2    n=0
      do 3 i=i1,i2
      n=n+1
      b(n)=tau(1,i)
      do 3 j=1,2
 3    a(j,n)=coef(j,i)
      do 4 j=1,3
 4    ap(j)=coef(j+2,i2)
      n1=n-1
c
c   Arrays ap(*,1), a, and ap(*,2) comprise n+2 x n+2 penta-diagonal
c   matrix A.  Let x1, tau, and xn comprise corresponding n+2 vector b.
c   Then, A * g = b, may be solved for n+2 vector g such that
c   interpolation I is given by I(p) = sum(i=0,n+1) g;i * G;i(p).
c
c   Eliminate the lower triangular portion of A to form A'.  A
c   corresponding transformation applied to vector b is stored in
c   a(4,*).
      alr=a(1,1)/coef(3,i1)
      a(1,1)=1d0-coef(4,i1)*alr
      a(2,1)=a(2,1)-coef(5,i1)*alr
      b(1)=b(1)-x1*alr
      j=1
      do 5 i=2,n
      alr=a(1,i)/a(1,j)
      a(1,i)=1d0-a(2,j)*alr
      b(i)=b(i)-b(j)*alr
 5    j=i
      alr=ap(1)/a(1,n1)
      ap(2)=ap(2)-a(2,n1)*alr
      gn=xn-b(n1)*alr
      alr=ap(2)/a(1,n)
c   Back solve the upper triangular portion of A' for coefficients g;i.
c   When finished, storage g(2), a(4,*), g(5) will comprise vector g.
      gn=(gn-b(n)*alr)/(ap(3)-a(2,n)*alr)
      b(n)=(b(n)-gn*a(2,n))/a(1,n)
      j=n
      do 6 i=n1,1,-1
      b(i)=(b(i)-b(j)*a(2,i))/a(1,i)
 6    j=i
      g1=(x1-coef(4,i1)*b(1)-coef(5,i1)*b(2))/coef(3,i1)
c
      tau(2,i1)=x1
      is=i1+1
      ie=i2-1
      j=1
      do 7 i=is,ie
      j=j+1
 7    tau(2,i)=coef(3,i)*b(j-1)+coef(4,i)*b(j)+coef(5,i)*b(j+1)
      tau(2,i2)=xn
      return
      end
      function iupcor(phnm,dtdd,xcor,tcor)
      save
      include 'ttlim.inc'
      character*(*) phnm
      character*8 phcd
      double precision us,pt,tau,xlim,xbrn,dbrn,zs,pk,pu,pux,tauu,xu,
     1 px,xt,taut,coef,tauc,xc,tcoef,tp
      double precision x,dp,dps,ps,cn
      common/tabc/us(2),pt(jout),tau(4,jout),xlim(2,jout),xbrn(jbrn,3),
     1 dbrn(jbrn,2),xn,pn,tn,dn,hn,jndx(jbrn,2),idel(jbrn,3),mbr1,mbr2
      common/brkc/zs,pk(jseg),pu(jtsm0,2),pux(jxsm,2),tauu(jtsm,2),
     1 xu(jxsm,2),px(jbrn,2),xt(jbrn,2),taut(jout),coef(5,jout),
     2 tauc(jtsm),xc(jxsm),tcoef(5,jbrna,2),tp(jbrnu,2),odep,
     3 fcs(jseg,3),nin,nph0,int0(2),ki,msrc(2),isrc(2),nseg,nbrn,ku(2),
     4 km(2),nafl(jseg,3),indx(jseg,2),kndx(jseg,2),iidx(jseg),
     5 jidx(jbrn),kk(jseg)
      common/pcdc/phcd(jbrn)
      data oldep,jp,js/-1.,2*0/,cn/57.295779d0/
c
      iupcor=1
c     print *,'oldep odep',oldep,odep
      if(oldep.eq.odep) go to 1
      oldep=odep
c   Find the upgoing P branch.
c     print *,'mbr1 mbr2',mbr1,mbr2
      do 2 jp=mbr1,mbr2
c     print *,'jp phcd xbrn',jp,'  ',phcd(jp),xbrn(jp,1)
      if((phcd(jp).eq.'Pg'.or.phcd(jp).eq.'Pb'.or.phcd(jp).eq.'Pn'.or.
     1 phcd(jp).eq.'P').and.xbrn(jp,1).le.0d0) go to 3
 2    continue
      jp=0
c   Find the upgoing S branch.
 3    do 4 js=mbr1,mbr2
c     print *,'js phcd xbrn',js,'  ',phcd(js),xbrn(js,1)
      if((phcd(js).eq.'Sg'.or.phcd(js).eq.'Sb'.or.phcd(js).eq.'Sn'.or.
     1 phcd(js).eq.'S').and.xbrn(js,1).le.0d0) go to 1
 4    continue
      js=0
c
c1    print *,'jp js',jp,js
 1    if(phnm.ne.'P'.and.phnm.ne.'p') go to 5
      jb=jp
      if(jb)14,14,6
c
 5    if(phnm.ne.'S'.and.phnm.ne.'s') go to 13
      jb=js
      if(jb)14,14,6
c
 6    is=jndx(jb,1)+1
      ie=jndx(jb,2)
      ps=abs(dtdd)/dn
c     print *,'jb is ie dtdd dn ps',jb,is,ie,dtdd,dn,ps
      if(ps.lt.pt(is-1).or.ps.gt.pt(ie)) go to 13
      do 7 i=is,ie
c     print *,'i pt',i,pt(i)
      if(ps.le.pt(i)) go to 8
 7    continue
      go to 13
c
 8    j=i-1
      dp=pt(ie)-ps
      dps=dsqrt(dabs(dp))
      x=tau(2,j)+2d0*dp*tau(3,j)+1.5d0*dps*tau(4,j)
c     print *,'j pt dp dps x',j,pt(ie),dp,dps,x
      tcor=tn*(tau(1,j)+dp*(tau(2,j)+dp*tau(3,j)+dps*tau(4,j))+ps*x)
      xcor=cn*x
c     print *,'iupcor xcor tcor',iupcor,xcor,tcor
      return
c
 13   iupcor=-1
 14   xcor=0.
      tcor=0.
c     print *,'iupcor xcor tcor',iupcor,xcor,tcor
      return
      end
      subroutine pdecu(i1,i2,x0,x1,xmin,int,len)
      save
      include 'ttlim.inc'
      double precision us,pt,tau,xlim,xbrn,dbrn,ua,taua
      double precision x0,x1,xmin,dx,dx2,sgn,rnd,xm,axm,x,h1,h2,hh,xs
      common/tabc/us(2),pt(jout),tau(4,jout),xlim(2,jout),xbrn(jbrn,3),
     1 dbrn(jbrn,2),xn,pn,tn,dn,hn,jndx(jbrn,2),idel(jbrn,3),mbr1,mbr2
      common/pdec/ua(5,2),taua(5,2),deplim,ka
c
c     write(10,*)'Pdecu:  ua =',sngl(ua(1,int))
      if(ua(1,int).le.0d0) go to 17
c     write(10,*)'Pdecu:  fill in new grid'
      k=i1+1
      do 18 i=1,ka
      pt(k)=ua(i,int)
      tau(1,k)=taua(i,int)
 18   k=k+1
      pt(k)=pt(i2)
      tau(1,k)=tau(1,i2)
      go to 19
c
 17   is=i1+1
      ie=i2-1
      xs=x1
      do 11 i=ie,i1,-1
      x=xs
      if(i.ne.i1) go to 12
      xs=x0
      go to 14
 12   h1=pt(i-1)-pt(i)
      h2=pt(i+1)-pt(i)
      hh=h1*h2*(h1-h2)
      h1=h1*h1
      h2=-h2*h2
      xs=-(h2*tau(1,i-1)-(h2+h1)*tau(1,i)+h1*tau(1,i+1))/hh
 14   if(dabs(x-xs).le.xmin) go to 15
 11   continue
      len=i2
      return
 15   ie=i
      if(dabs(x-xs).gt..75d0*xmin.or.ie.eq.i2) go to 16
      xs=x
      ie=ie+1
 16   n=max0(idint(dabs(xs-x0)/xmin+.8d0),1)
      dx=(xs-x0)/n
      dx2=dabs(.5d0*dx)
      sgn=dsign(1d0,dx)
      rnd=0d0
      if(sgn.gt.0d0) rnd=1d0
      xm=x0+dx
      k=i1
      m=is
      axm=1d10
      do 1 i=is,ie
      if(i.lt.ie) go to 8
      x=xs
      go to 5
 8    h1=pt(i-1)-pt(i)
      h2=pt(i+1)-pt(i)
      hh=h1*h2*(h1-h2)
      h1=h1*h1
      h2=-h2*h2
      x=-(h2*tau(1,i-1)-(h2+h1)*tau(1,i)+h1*tau(1,i+1))/hh
 5    if(sgn*(x-xm).le.dx2) go to 2
      if(k.lt.m) go to 3
      do 4 j=m,k
 4    pt(j)=-1d0
 3    m=k+2
      k=i-1
      axm=1d10
 7    xm=xm+dx*idint((x-xm-dx2)/dx+rnd)
 2    if(dabs(x-xm).ge.axm) go to 1
      axm=dabs(x-xm)
      k=i-1
 1    continue
      if(k.lt.m) go to 9
      do 6 j=m,k
 6    pt(j)=-1d0
 9    k=i1
      do 10 i=is,i2
      if(pt(i).lt.0d0) go to 10
      k=k+1
      pt(k)=pt(i)
      tau(1,k)=tau(1,i)
 10   continue
 19   len=k
c     write(10,300)(i,pt(i),tau(1,i),i=i1,len)
c300  format(/(1x,i5,0pf12.6,1pd15.4))
      return
      end
      subroutine query(ia,log)
c
c $$$$$ calls tnoua $$$$$
c
c   Subroutine query scans character string ia (up to 78 characters) for
c   a question mark or a colon.  It prints the string up to and
c   including the flag character plus two blanks with no newline on the
c   standard output.  If the flag was a question mark, query reads the
c   users response.  If the response is 'y' or 'yes', log is set to
c   true.  If the response is 'n' or 'no', log is set to false.  Any
c   other response causes the question to be repeated.  If the flag was
c   a colon, query simply returns allowing user input on the same line.
c   If there is no question mark or colon, the last non-blank character
c   is treated as if it were a colon.  If the string is null or all
c   blank, query prints an astrisk and returns.  Programmed on 3
c   December 1979 by R. Buland.
c
      save
      logical log
      character*(*) ia
      character*81 ib
      character*4 ans
      nn=len(ia)
      log=.true.
      ifl=1
      k=0
c   Scan ia for flag characters or end-of-string.
      do 1 i=1,nn
      ib(i:i)=ia(i:i)
      if(ib(i:i).eq.':') go to 7
      if(ib(i:i).eq.'?') go to 3
      if(ib(i:i).eq.'\0') go to 5
      if(ib(i:i).ne.' ') k=i
 1    continue
c   If we fell off the end of the string, branch if there were any non-
c   blank characters.
 5    if(k.gt.0) go to 6
c   Handle a null or all blank string.
      i=1
      ib(i:i)='*'
      go to 4
c   Handle a string with no question mark or colon but at least one
c   non-blank character.
 6    i=k
c   Append two blanks and print the string.
 7    i=i+2
      ib(i-1:i-1)=' '
      ib(i:i)=' '
c   Tnoua prints the first i characters of ib without a newline.
 4    call tnoua(ib(1:i))
      if(ifl.gt.0) return
c   If the string was a yes-no question read the response.
      read 102,ans
 102  format(a4)
      call uctolc(4,ans,-1)
c   If the response is yes log is already set properly.
      if(ans.eq.'y   '.or.ans.eq.'yes ') return
c   If the response is no set log to false.  Otherwise repeat the
c   question.
      if(ans.ne.'n   '.and.ans.ne.'no  ') go to 4
      log=.false.
      return
 3    ifl=-ifl
      go to 7
      end
      subroutine r4sort(n,rkey,iptr)
c
c $$$$$ calls no other routine $$$$$
c
c   R4sort sorts the n elements of array rkey so that rkey(i),
c   i = 1, 2, 3, ..., n are in asending order.  R4sort is a trivial
c   modification of ACM algorithm 347:  "An efficient algorithm for
c   sorting with minimal storage" by R. C. Singleton.  Array rkey is
c   sorted in place in order n*alog2(n) operations.  Coded on
c   8 March 1979 by R. Buland.  Modified to handle real*4 data on
c   27 September 1983 by R. Buland.
c
      save
      dimension rkey(n),iptr(n),il(10),iu(10)
c   Note:  il and iu implement a stack containing the upper and
c   lower limits of subsequences to be sorted independently.  A
c   depth of k allows for n<=2**(k+1)-1.
      if(n.le.0) return
      do 1 i=1,n
 1    iptr(i)=i
      if(n.le.1) return
      r=.375
      m=1
      i=1
      j=n
c
c   The first section interchanges low element i, middle element ij,
c   and high element j so they are in order.
c
 5    if(i.ge.j) go to 70
 10   k=i
c   Use a floating point modification, r, of Singleton's bisection
c   strategy (suggested by R. Peto in his verification of the
c   algorithm for the ACM).
      if(r.gt..58984375) go to 11
      r=r+.0390625
      go to 12
 11   r=r-.21875
 12   ij=i+(j-i)*r
      if(rkey(iptr(i)).le.rkey(iptr(ij))) go to 20
      it=iptr(ij)
      iptr(ij)=iptr(i)
      iptr(i)=it
 20   l=j
      if(rkey(iptr(j)).ge.rkey(iptr(ij))) go to 39
      it=iptr(ij)
      iptr(ij)=iptr(j)
      iptr(j)=it
      if(rkey(iptr(i)).le.rkey(iptr(ij))) go to 39
      it=iptr(ij)
      iptr(ij)=iptr(i)
      iptr(i)=it
 39   tmpkey=rkey(iptr(ij))
      go to 40
c
c   The second section continues this process.  K counts up from i and
c   l down from j.  Each time the k element is bigger than the ij
c   and the l element is less than the ij, then interchange the
c   k and l elements.  This continues until k and l meet.
c
 30   it=iptr(l)
      iptr(l)=iptr(k)
      iptr(k)=it
 40   l=l-1
      if(rkey(iptr(l)).gt.tmpkey) go to 40
 50   k=k+1
      if(rkey(iptr(k)).lt.tmpkey) go to 50
      if(k.le.l) go to 30
c
c   The third section considers the intervals i to l and k to j.  The
c   larger interval is saved on the stack (il and iu) and the smaller
c   is remapped into i and j for another shot at section one.
c
      if(l-i.le.j-k) go to 60
      il(m)=i
      iu(m)=l
      i=k
      m=m+1
      go to 80
 60   il(m)=k
      iu(m)=j
      j=l
      m=m+1
      go to 80
c
c   The fourth section pops elements off the stack (into i and j).  If
c   necessary control is transfered back to section one for more
c   interchange sorting.  If not we fall through to section five.  Note
c   that the algorighm exits when the stack is empty.
c
 70   m=m-1
      if(m.eq.0) return
      i=il(m)
      j=iu(m)
 80   if(j-i.ge.11) go to 10
      if(i.eq.1) go to 5
      i=i-1
c
c   The fifth section is the end game.  Final sorting is accomplished
c   (within each subsequence popped off the stack) by rippling out
c   of order elements down to their proper positions.
c
 90   i=i+1
      if(i.eq.j) go to 70
      if(rkey(iptr(i)).le.rkey(iptr(i+1))) go to 90
      k=i
      kk=k+1
      ib=iptr(kk)
 100  iptr(kk)=iptr(k)
      kk=k
      k=k-1
      if(rkey(ib).lt.rkey(iptr(k))) go to 100
      iptr(kk)=ib
      go to 90
      end
      subroutine retrns(lu)
c
c $$$$$ calls no other routine $$$$$
c
c   Subroutine retrns closes (disconnects) logical unit lu from the
c   calling program.  Programmed on 3 December 1979 by R. Buland.
c
      save
      close(unit=lu)
      return
      end
      subroutine spfit(jb,int)
      save
      include 'ttlim.inc'
      character*3 disc
      character*8 phcd
      logical newgrd,makgrd,segmsk,prnt
c     logical log
      double precision pm,zm,us,pt,tau,xlim,xbrn,dbrn,zs,pk,pu,pux,tauu,
     1 xu,px,xt,taut,coef,tauc,xc,tcoef,tp
      double precision pmn,dmn,dmx,hm,shm,thm,p0,p1,tau0,tau1,x0,x1,pe,
     1 pe0,spe0,scpe0,pe1,spe1,scpe1,dpe,dtau,dbrnch,cn,x180,x360,dtol,
     2 ptol,xmin
      common/umdc/pm(jsrc,2),zm(jsrc,2),ndex(jsrc,2),mt(2)
      common/tabc/us(2),pt(jout),tau(4,jout),xlim(2,jout),xbrn(jbrn,3),
     1 dbrn(jbrn,2),xn,pn,tn,dn,hn,jndx(jbrn,2),idel(jbrn,3),mbr1,mbr2
      common/brkc/zs,pk(jseg),pu(jtsm0,2),pux(jxsm,2),tauu(jtsm,2),
     1 xu(jxsm,2),px(jbrn,2),xt(jbrn,2),taut(jout),coef(5,jout),
     2 tauc(jtsm),xc(jxsm),tcoef(5,jbrna,2),tp(jbrnu,2),odep,
     3 fcs(jseg,3),nin,nph0,int0(2),ki,msrc(2),isrc(2),nseg,nbrn,ku(2),
     4 km(2),nafl(jseg,3),indx(jseg,2),kndx(jseg,2),iidx(jseg),
     5 jidx(jbrn),kk(jseg)
      common/pcdc/phcd(jbrn)
      common/prtflc/segmsk(jseg),prnt(2)
      data dbrnch,cn,x180,x360,xmin,dtol,ptol/2.5307274d0,57.295779d0,
     1 3.1415927d0,6.2831853d0,3.92403d-3,1d-6,2d-6/
c
      if(prnt(1)) write(10,102)
      i1=jndx(jb,1)
      i2=jndx(jb,2)
c     write(10,*)'Spfit:  jb i1 i2 pt =',jb,i1,i2,sngl(pt(i1)),
c    1 sngl(pt(i2))
      if(i2-i1.gt.1.or.dabs(pt(i2)-pt(i1)).gt.ptol) go to 14
      jndx(jb,2)=-1
      return
 14   newgrd=.false.
      makgrd=.false.
      if(dabs(px(jb,2)-pt(i2)).gt.dtol) newgrd=.true.
c     write(10,*)'Spfit:  px newgrd =',sngl(px(jb,2)),newgrd
      if(.not.newgrd) go to 10
      k=mod(int-1,2)+1
      if(int.ne.int0(k)) makgrd=.true.
c     write(10,*)'Spfit:  int k int0 makgrd =',int,k,int0(k),makgrd
      if(int.gt.2) go to 12
c     call query('Enter xmin:',log)
c     read *,xmin
c     xmin=xmin*xn
      xmin=xn*amin1(amax1(2.*odep,2.),25.)
c     write(10,*)'Spfit:  xmin =',xmin,xmin/xn
      call pdecu(i1,i2,xbrn(jb,1),xbrn(jb,2),xmin,int,i2)
      jndx(jb,2)=i2
 12   nn=i2-i1+1
      if(makgrd) call tauspl(1,nn,pt(i1),tcoef(1,1,k))
c     write(10,301,iostat=ios)jb,k,nn,int,newgrd,makgrd,
c    1 xbrn(jb,1),xbrn(jb,2),(i,pt(i-1+i1),tau(1,i-1+i1),
c    2 (tcoef(j,i,k),j=1,5),i=1,nn)
c301  format(/1x,4i3,2l3,2f12.8/(1x,i5,0p2f12.8,1p5d10.2))
      call fitspl(1,nn,tau(1,i1),xbrn(jb,1),xbrn(jb,2),tcoef(1,1,k))
      int0(k)=int
      go to 11
 10   call fitspl(i1,i2,tau,xbrn(jb,1),xbrn(jb,2),coef)
 11   pmn=pt(i1)
      dmn=xbrn(jb,1)
      dmx=dmn
      mxcnt=0
      mncnt=0
c     call appx(i1,i2,xbrn(jb,1),xbrn(jb,2))
c     write(10,300)(i,pt(i),(tau(j,i),j=1,3),i=i1,i2)
c300  format(/(1x,i5,4f12.6))
      pe=pt(i2)
      p1=pt(i1)
      tau1=tau(1,i1)
      x1=tau(2,i1)
      pe1=pe-p1
      spe1=dsqrt(dabs(pe1))
      scpe1=pe1*spe1
      j=i1
      is=i1+1
      do 2 i=is,i2
      p0=p1
      p1=pt(i)
      tau0=tau1
      tau1=tau(1,i)
      x0=x1
      x1=tau(2,i)
      dpe=p0-p1
      dtau=tau1-tau0
      pe0=pe1
      pe1=pe-p1
      spe0=spe1
      spe1=dsqrt(dabs(pe1))
      scpe0=scpe1
      scpe1=pe1*spe1
      tau(4,j)=(2d0*dtau-dpe*(x1+x0))/(.5d0*(scpe1-scpe0)-1.5d0*spe1*
     1 spe0*(spe1-spe0))
      tau(3,j)=(dtau-dpe*x0-(scpe1+.5d0*scpe0-1.5d0*pe1*spe0)*tau(4,j))/
     1 (dpe*dpe)
      tau(2,j)=(dtau-(pe1*pe1-pe0*pe0)*tau(3,j)-(scpe1-scpe0)*tau(4,j))/
     1 dpe
      tau(1,j)=tau0-scpe0*tau(4,j)-pe0*(pe0*tau(3,j)+tau(2,j))
      xlim(1,j)=dmin1(x0,x1)
      xlim(2,j)=dmax1(x0,x1)
      if(xlim(1,j).ge.dmn) go to 5
      dmn=xlim(1,j)
      pmn=pt(j)
      if(x1.lt.x0) pmn=pt(i)
 5    disc=' '
      if(dabs(tau(3,j)).le.1d-30) go to 4
      shm=-.375d0*tau(4,j)/tau(3,j)
      hm=shm*shm
      if(shm.le.0d0.or.(hm.le.pe1.or.hm.ge.pe0)) go to 4
 7    thm=tau(2,j)+shm*(2d0*shm*tau(3,j)+1.5d0*tau(4,j))
      xlim(1,j)=dmin1(xlim(1,j),thm)
      xlim(2,j)=dmax1(xlim(2,j),thm)
      if(thm.ge.dmn) go to 6
      dmn=thm
      pmn=pe-hm
 6    disc='max'
      if(tau(4,j).lt.0d0) disc='min'
      if(disc.eq.'max') mxcnt=mxcnt+1
      if(disc.eq.'min') mncnt=mncnt+1
 4    if(prnt(1)) write(10,100,iostat=ios)disc,j,pt(j),
     1 (tau(k,j),k=1,4),(cn*xlim(k,j),k=1,2)
 100  format(1x,a,i5,f10.6,1p4e10.2,0p2f7.2)
      dmx=dmax1(dmx,xlim(2,j))
 2    j=i
c     if(prnt(1)) write(10,100,iostat=ios)'   ',j,pt(j)
      xbrn(jb,1)=dmn
      xbrn(jb,2)=dmx
      xbrn(jb,3)=pmn
      idel(jb,1)=1
      idel(jb,2)=1
      if(xbrn(jb,1).gt.x180) idel(jb,1)=2
      if(xbrn(jb,2).gt.x180) idel(jb,2)=2
      if(xbrn(jb,1).gt.x360) idel(jb,1)=3
      if(xbrn(jb,2).gt.x360) idel(jb,2)=3
      if(int.gt.2) go to 1
      phcd(jb)=phcd(jb)(1:1)
      i=jb
      do 8 j=1,nbrn
      i=mod(i,nbrn)+1
      if(phcd(i)(1:1).eq.phcd(jb).and.phcd(i)(2:2).ne.'P'.and.
     1 (pe.ge.px(i,1).and.pe.le.px(i,2))) go to 9
 8    continue
      go to 1
 9    phcd(jb)=phcd(i)
      if(dabs(pt(i2)-pt(jndx(i,1))).le.dtol) phcd(jb)=phcd(i-1)
 1    if(prnt(1).and.prnt(2)) write(10,102)
 102  format()
      if(dbrn(jb,1).le.0d0) go to 3
      dbrn(jb,1)=dmx
      dbrn(jb,2)=dbrnch
      if(prnt(2)) write(10,101,iostat=ios)phcd(jb),
     1 (jndx(jb,k),k=1,2),(cn*xbrn(jb,k),k=1,2),xbrn(jb,3),
     2 (cn*dbrn(jb,k),k=1,2),(idel(jb,k),k=1,3),int,newgrd,makgrd
 101  format(1x,a,2i5,2f8.2,f8.4,2f8.2,4i3,2l2)
      go to 15
 3    if(prnt(2)) write(10,103,iostat=ios)phcd(jb),
     1 (jndx(jb,k),k=1,2),(cn*xbrn(jb,k),k=1,2),xbrn(jb,3),
     2 (idel(jb,k),k=1,3),int,newgrd,makgrd
 103  format(1x,a,2i5,2f8.2,f8.4,16x,4i3,2l2)
 15   if(mxcnt.gt.mncnt.or.mncnt.gt.mxcnt+1)
     1 call warn('Bad interpolation on '//phcd(jb))
      return
      end
      subroutine tabin(in,modnam)
      include 'ttlim.inc'
      character*(*) modnam
c     logical log
      character*8 phcd,phdif(6)
      double precision pm,zm,us,pt,tau,xlim,xbrn,dbrn,zs,pk,pu,pux,tauu,
     1 xu,px,xt,taut,coef,tauc,xc,tcoef,tp
c
      common/umdc/pm(jsrc,2),zm(jsrc,2),ndex(jsrc,2),mt(2)
      common/tabc/us(2),pt(jout),tau(4,jout),xlim(2,jout),xbrn(jbrn,3),
     1 dbrn(jbrn,2),xn,pn,tn,dn,hn,jndx(jbrn,2),idel(jbrn,3),mbr1,mbr2
      common/brkc/zs,pk(jseg),pu(jtsm0,2),pux(jxsm,2),tauu(jtsm,2),
     1 xu(jxsm,2),px(jbrn,2),xt(jbrn,2),taut(jout),coef(5,jout),
     2 tauc(jtsm),xc(jxsm),tcoef(5,jbrna,2),tp(jbrnu,2),odep,
     3 fcs(jseg,3),nin,nph0,int0(2),ki,msrc(2),isrc(2),nseg,nbrn,ku(2),
     4 km(2),nafl(jseg,3),indx(jseg,2),kndx(jseg,2),iidx(jseg),
     5 jidx(jbrn),kk(jseg)
      common/pcdc/phcd(jbrn)
      data tauc,xc/jtsm*0d0,jxsm*0d0/
c
      nin=in
      phdif(1)='P'
      phdif(2)='S'
      phdif(3)='pP'
      phdif(4)='sP'
      phdif(5)='pS'
      phdif(6)='sS'
c++
      call asnag1(nin,-1,1,'Enter model name:',modnam)
c++
      read(nin) nasgr,nl,len2,xn,pn,tn,mt,nseg,nbrn,ku,km,fcs,nafl,
     1 indx,kndx
      read(nin) pm,zm,ndex
      read(nin) pu,pux
      read(nin) phcd,px,xt,jndx
      read(nin) pt,taut
      read(nin) coef
      call retrns(nin)
c
      nb=index(modnam,' ')-1
      if(nb.le.0) nb=len(modnam)
      call dasign(nin,-1,modnam(1:nb)//'.tbl',nasgr)
c
      do 11 nph=1,2
 11   pu(ku(nph)+1,nph)=pm(1,nph)
c
c     write(10,*)'nasgr nl len2',nasgr,nl,len2
c     write(10,*)'nseg nbrn mt ku km',nseg,nbrn,mt,ku,km
c     write(10,*)'xn pn tn',xn,pn,tn
c     write(10,200)(i,(ndex(i,j),pm(i,j),zm(i,j),j=1,2),i=1,mt(2))
c200  format(/(1x,i3,i7,2f12.6,i7,2f12.6))
c     write(10,201)(i,(pu(i,j),j=1,2),i=1,ku(2)+1)
c201  format(/(1x,i3,2f12.6))
c     write(10,201)(i,(pux(i,j),j=1,2),i=1,km(2))
c     write(10,202)(i,(nafl(i,j),j=1,3),(indx(i,j),j=1,2),(kndx(i,j),
c    1 j=1,2),(fcs(i,j),j=1,3),i=1,nseg)
c202  format(/(1x,i3,7i5,3f5.0))
c     cn=180./3.1415927
c     write(10,203)(i,(jndx(i,j),j=1,2),(px(i,j),j=1,2),(cn*xt(i,j),
c    1 j=1,2),phcd(i),i=1,nbrn)
c203  format(/(1x,i3,2i5,2f12.6,2f12.2,2x,a))
c     write(10,204)(i,pt(i),taut(i),(coef(j,i),j=1,5),i=1,jout)
c204  format(/(1x,i5,0p2f12.6,1p5d10.2))
c
      tn=1./tn
      dn=3.1415927/(180.*pn*xn)
      odep=-1.
      ki=0
      msrc(1)=0
      msrc(2)=0
      k=1
      do 3 i=1,nbrn
      jidx(i)=jndx(i,2)
      do 4 j=1,2
 4    dbrn(i,j)=-1d0
 8    if(jndx(i,2).le.indx(k,2)) go to 7
      k=k+1
      go to 8
 7    if(nafl(k,2).gt.0) go to 9
      ind=nafl(k,1)
      l=0
      do 10 j=jndx(i,1),jndx(i,2)
      l=l+1
 10   tp(l,ind)=pt(j)
 9    if(nafl(k,1).gt.0.and.(phcd(i)(1:1).eq.'P'.or.
     1 phcd(i)(1:1).eq.'S')) go to 3
      do 5 j=1,6
      if(phcd(i).eq.phdif(j)) go to 6
 5    continue
      go to 3
 6    dbrn(i,1)=1d0
      phdif(j)=' '
 3    continue
c     write(10,205)(i,phcd(i),(dbrn(i,j),j=1,2),jidx(i),i=1,nbrn)
c205  format(/(1x,i5,2x,a,2f8.2,i5))
c     write(10,206)(i,(tp(i,j),j=1,2),i=1,jbrnu)
c206  format(/(1x,i5,2f12.6))
      return
      end
      subroutine tauint(ptk,ptj,pti,zj,zi,tau,x)
      save
c
c $$$$$ calls warn $$$$$
c
c   Tauint evaluates the intercept (tau) and distance (x) integrals  for
c   the spherical earth assuming that slowness is linear between radii
c   for which the model is known.  The partial integrals are performed
c   for ray slowness ptk between model radii with slownesses ptj and pti
c   with equivalent flat earth depths zj and zi respectively.  The partial
c   integrals are returned in tau and x.  Note that ptk, ptj, pti, zj, zi,
c   tau, and x are all double precision.
c
      character*71 msg
      double precision ptk,ptj,pti,zj,zi,tau,x
      double precision xx,b,sqk,sqi,sqj,sqb
c
      if(dabs(zj-zi).le.1d-9) go to 13
      if(dabs(ptj-pti).gt.1d-9) go to 10
      if(dabs(ptk-pti).le.1d-9) go to 13
      b=dabs(zj-zi)
      sqj=dsqrt(dabs(ptj*ptj-ptk*ptk))
      tau=b*sqj
      x=b*ptk/sqj
      go to 4
 10   if(ptk.gt.1d-9.or.pti.gt.1d-9) go to 1
c   Handle the straight through ray.
      tau=ptj
      x=1.5707963267948966d0
      go to 4
 1    b=ptj-(pti-ptj)/(dexp(zi-zj)-1d0)
      if(ptk.gt.1d-9) go to 2
      tau=-(pti-ptj+b*dlog(pti/ptj)-b*dlog(dmax1((ptj-b)*pti/
     1 ((pti-b)*ptj),1d-30)))
      x=0d0
      go to 4
 2    if(ptk.eq.pti) go to 3
      if(ptk.eq.ptj) go to 11
      sqk=ptk*ptk
      sqi=dsqrt(dabs(pti*pti-sqk))
      sqj=dsqrt(dabs(ptj*ptj-sqk))
      sqb=dsqrt(dabs(b*b-sqk))
      if(sqb.gt.1d-30) go to 5
      xx=0d0
      x=ptk*(dsqrt(dabs((pti+b)/(pti-b)))-dsqrt(dabs((ptj+b)/
     1 (ptj-b))))/b
      go to 6
 5    if(b*b.lt.sqk) go to 7
      xx=dlog(dmax1((ptj-b)*(sqb*sqi+b*pti-sqk)/((pti-b)*
     1 (sqb*sqj+b*ptj-sqk)),1d-30))
      x=ptk*xx/sqb
      go to 6
 7    xx=dasin(dmax1(dmin1((b*pti-sqk)/(ptk*dabs(pti-b)),1d0),-1d0))-
     1 dasin(dmax1(dmin1((b*ptj-sqk)/(ptk*dabs(ptj-b)),1d0),-1d0))
      x=-ptk*xx/sqb
 6    tau=-(sqi-sqj+b*dlog((pti+sqi)/(ptj+sqj))-sqb*xx)
      go to 4
 3    sqk=pti*pti
      sqj=dsqrt(dabs(ptj*ptj-sqk))
      sqb=dsqrt(dabs(b*b-sqk))
      if(b*b.lt.sqk) go to 8
      xx=dlog(dmax1((ptj-b)*(b*pti-sqk)/((pti-b)*(sqb*sqj+b*ptj-sqk)),
     1 1d-30))
      x=pti*xx/sqb
      go to 9
 8    xx=dsign(1.5707963267948966d0,b-pti)-dasin(dmax1(dmin1((b*ptj-
     1 sqk)/(pti*dabs(ptj-b)),1d0),-1d0))
      x=-pti*xx/sqb
 9    tau=-(b*dlog(pti/(ptj+sqj))-sqj-sqb*xx)
      go to 4
 11   sqk=ptj*ptj
      sqi=dsqrt(dabs(pti*pti-sqk))
      sqb=dsqrt(dabs(b*b-sqk))
      if(b*b.lt.sqk) go to 12
      xx=dlog(dmax1((ptj-b)*(sqb*sqi+b*pti-sqk)/((pti-b)*(b*ptj-sqk)),
     1 1d-30))
      x=ptj*xx/sqb
      go to 14
 12   xx=dasin(dmax1(dmin1((b*pti-sqk)/(ptj*dabs(pti-b)),1d0),-1d0))-
     1 dsign(1.5707963267948966d0,b-ptj)
      x=-ptj*xx/sqb
 14   tau=-(b*dlog((pti+sqi)/ptj)+sqi-sqb*xx)
c
c   Handle various error conditions.
c
 4    if(x.ge.-1d-10) go to 15
      write(msg,100)ptk,ptj,pti,tau,x
 100  format('Bad range: ',1p5d12.4)
      call warn(msg)
 15   if(tau.ge.-1d-10) go to 16
      write(msg,101)ptk,ptj,pti,tau,x
 101  format('Bad tau: ',1p5d12.4)
      call warn(msg(1:69))
 16   return
c   Trap null integrals and handle them properly.
 13   tau=0d0
      x=0d0
      return
      end
      subroutine tauspl(i1,i2,pt,coef)
c
c $$$$$ calls only library routines $$$$$
c
c   Given ray parameter grid pt;i (pt sub i), i=i1,i1+1,...,i2, tauspl
c   determines the i2-i1+3 basis functions for interpolation I such
c   that:
c
c      tau(p) = a;1,i + Dp * a;2,i + Dp**2 * a;3,i + Dp**(3/2) * a;4,i
c
c   where Dp = pt;n - p, pt;i <= p < pt;i+1, and the a;j,i's are
c   interpolation coefficients.  Rather than returning the coefficients,
c   a;j,i, which necessarily depend on tau(pt;i), i=i1,i1+1,...,i2 and
c   x(pt;i) (= -d tau(p)/d p | pt;i), i=i1,i2, tauspl returns the
c   contribution of each basis function and its derivitive at each
c   sample.  Each basis function is non-zero at three grid points,
c   therefore, each grid point will have contributions (function values
c   and derivitives) from three basis functions.  Due to the basis
c   function normalization, one of the function values will always be
c   one and is not returned in array coef with the other values.
c   Rewritten on 23 December 1983 by R. Buland.
c
      save
      double precision pt(i2),coef(5,i2)
      double precision del(5),sdel(5),deli(5),d3h(4),d1h(4),dih(4),
     1 d(4),ali,alr,b3h,b1h,bih,th0p,th2p,th3p,th2m
c
      n2=i2-i1-1
      if(n2.le.-1) return
      is=i1+1
c
c   To achieve the requisite stability, proceed by constructing basis
c   functions G;i, i=0,1,...,n+1.  G;i will be non-zero only on the
c   interval [p;i-2,p;i+2] and will be continuous with continuous first
c   and second derivitives.  G;i(p;i-2) and G;i(p;i+2) are constrained
c   to be zero with zero first and second derivitives.  G;i(p;i) is
c   normalized to unity.
c
c   Set up temporary variables appropriate for G;-1.  Note that to get
c   started, the ray parameter grid is extrapolated to yeild p;i, i=-2,
c   -1,0,1,...,n.
      del(2)=pt(i2)-pt(i1)+3d0*(pt(is)-pt(i1))
      sdel(2)=dsqrt(dabs(del(2)))
      deli(2)=1d0/sdel(2)
      m=2
      do 1 k=3,5
      del(k)=pt(i2)-pt(i1)+(5-k)*(pt(is)-pt(i1))
      sdel(k)=dsqrt(dabs(del(k)))
      deli(k)=1d0/sdel(k)
      d3h(m)=del(k)*sdel(k)-del(m)*sdel(m)
      d1h(m)=sdel(k)-sdel(m)
      dih(m)=deli(k)-deli(m)
 1    m=k
      l=i1-1
      if(n2.le.0) go to 10
c   Loop over G;i, i=0,1,...,n-3.
      do 2 i=1,n2
      m=1
c   Update temporary variables for G;i-1.
      do 3 k=2,5
      del(m)=del(k)
      sdel(m)=sdel(k)
      deli(m)=deli(k)
      if(k.ge.5) go to 3
      d3h(m)=d3h(k)
      d1h(m)=d1h(k)
      dih(m)=dih(k)
 3    m=k
      l=l+1
      del(5)=pt(i2)-pt(l+1)
      sdel(5)=dsqrt(dabs(del(5)))
      deli(5)=1d0/sdel(5)
      d3h(4)=del(5)*sdel(5)-del(4)*sdel(4)
      d1h(4)=sdel(5)-sdel(4)
      dih(4)=deli(5)-deli(4)
c   Construct G;i-1.
      ali=1d0/(.125d0*d3h(1)-(.75d0*d1h(1)+.375d0*dih(1)*del(3))*
     1 del(3))
      alr=ali*(.125d0*del(2)*sdel(2)-(.75d0*sdel(2)+.375d0*del(3)*
     1 deli(2)-sdel(3))*del(3))
      b3h=d3h(2)+alr*d3h(1)
      b1h=d1h(2)+alr*d1h(1)
      bih=dih(2)+alr*dih(1)
      th0p=d1h(1)*b3h-d3h(1)*b1h
      th2p=d1h(3)*b3h-d3h(3)*b1h
      th3p=d1h(4)*b3h-d3h(4)*b1h
      th2m=dih(3)*b3h-d3h(3)*bih
c   The d;i's completely define G;i-1.
      d(4)=ali*((dih(1)*b3h-d3h(1)*bih)*th2p-th2m*th0p)/((dih(4)*b3h-
     1 d3h(4)*bih)*th2p-th2m*th3p)
      d(3)=(th0p*ali-th3p*d(4))/th2p
      d(2)=(d3h(1)*ali-d3h(3)*d(3)-d3h(4)*d(4))/b3h
      d(1)=alr*d(2)-ali
c   Construct the contributions G;i-1(p;i-2) and G;i-1(p;i).
c   G;i-1(p;i-1) need not be constructed as it is normalized to unity.
      coef(1,l)=(.125d0*del(5)*sdel(5)-(.75d0*sdel(5)+.375d0*deli(5)*
     1 del(4)-sdel(4))*del(4))*d(4)
      if(i.ge.3) coef(2,l-2)=(.125d0*del(1)*sdel(1)-(.75d0*sdel(1)+
     1 .375d0*deli(1)*del(2)-sdel(2))*del(2))*d(1)
c   Construct the contributions -dG;i-1(p)/dp | p;i-2, p;i-1, and p;i.
      coef(3,l)=-.75d0*(sdel(5)+deli(5)*del(4)-2d0*sdel(4))*d(4)
      if(i.ge.2) coef(4,l-1)=-.75d0*((sdel(2)+deli(2)*del(3)-
     1 2d0*sdel(3))*d(2)-(d1h(1)+dih(1)*del(3))*d(1))
      if(i.ge.3) coef(5,l-2)=-.75d0*(sdel(1)+deli(1)*del(2)-
     1 2d0*sdel(2))*d(1)
 2    continue
c   Loop over G;i, i=n-2,n-1,n,n+1.  These cases must be handled
c   seperately because of the singularities in the second derivitive
c   at p;n.
 10   do 4 j=1,4
      m=1
c   Update temporary variables for G;i-1.
      do 5 k=2,5
      del(m)=del(k)
      sdel(m)=sdel(k)
      deli(m)=deli(k)
      if(k.ge.5) go to 5
      d3h(m)=d3h(k)
      d1h(m)=d1h(k)
      dih(m)=dih(k)
 5    m=k
      l=l+1
      del(5)=0d0
      sdel(5)=0d0
      deli(5)=0d0
c   Construction of the d;i's is different for each case.  In cases
c   G;i, i=n-1,n,n+1, G;i is truncated at p;n to avoid patching across
c   the singularity in the second derivitive.
      if(j.lt.4) go to 6
c   For G;n+1 constrain G;n+1(p;n) to be .25.
      d(1)=2d0/(del(1)*sdel(1))
      go to 9
c   For G;i, i=n-2,n-1,n, the condition dG;i(p)/dp|p;i = 0 has been
c   substituted for the second derivitive continuity condition that
c   can no longer be satisfied.
 6    alr=(sdel(2)+deli(2)*del(3)-2d0*sdel(3))/(d1h(1)+dih(1)*del(3))
      d(2)=1d0/(.125d0*del(2)*sdel(2)-(.75d0*sdel(2)+.375d0*deli(2)*
     1 del(3)-sdel(3))*del(3)-(.125d0*d3h(1)-(.75d0*d1h(1)+.375d0*
     2 dih(1)*del(3))*del(3))*alr)
      d(1)=alr*d(2)
      if(j-2)8,7,9
c   For G;n-1 constrain G;n-1(p;n) to be .25.
 7    d(3)=(2d0+d3h(2)*d(2)+d3h(1)*d(1))/(del(3)*sdel(3))
      go to 9
c   No additional constraints are required for G;n-2.
 8    d(3)=-((d3h(2)-d1h(2)*del(4))*d(2)+(d3h(1)-d1h(1)*del(4))*
     1 d(1))/(d3h(3)-d1h(3)*del(4))
      d(4)=(d3h(3)*d(3)+d3h(2)*d(2)+d3h(1)*d(1))/(del(4)*sdel(4))
c   Construct the contributions G;i-1(p;i-2) and G;i-1(p;i).
 9    if(j.le.2) coef(1,l)=(.125d0*del(3)*sdel(3)-(.75d0*sdel(3)+.375d0*
     1 deli(3)*del(4)-sdel(4))*del(4))*d(3)-(.125d0*d3h(2)-(.75d0*
     2 d1h(2)+.375d0*dih(2)*del(4))*del(4))*d(2)-(.125d0*d3h(1)-(.75d0*
     3 d1h(1)+.375d0*dih(1)*del(4))*del(4))*d(1)
      if(l-i1.gt.1) coef(2,l-2)=(.125d0*del(1)*sdel(1)-(.75d0*sdel(1)+
     1 .375d0*deli(1)*del(2)-sdel(2))*del(2))*d(1)
c   Construct the contributions -dG;i-1(p)/dp | p;i-2, p;i-1, and p;i.
      if(j.le.2) coef(3,l)=-.75d0*((sdel(3)+deli(3)*del(4)-
     1 2d0*sdel(4))*d(3)-(d1h(2)+dih(2)*del(4))*d(2)-(d1h(1)+
     2 dih(1)*del(4))*d(1))
      if(j.le.3.and.l-i1.gt.0) coef(4,l-1)=0d0
      if(l-i1.gt.1) coef(5,l-2)=-.75d0*(sdel(1)+deli(1)*del(2)-
     1 2d0*sdel(2))*d(1)
 4    continue
      return
      end
      subroutine trtm(delta,max,n,tt,dtdd,dtdh,dddp,phnm)
      save
      include 'ttlim.inc'
      character*(*) phnm(max)
      character*8 ctmp(60)
      dimension tt(max),dtdd(max),dtdh(max),dddp(max),tmp(60,4),
     1 iptr(60)
      double precision us,pt,tau,xlim,xbrn,dbrn
      double precision x(3),cn,dtol,pi,pi2
      common/tabc/us(2),pt(jout),tau(4,jout),xlim(2,jout),xbrn(jbrn,3),
     1 dbrn(jbrn,2),xn,pn,tn,dn,hn,jndx(jbrn,2),idel(jbrn,3),mbr1,mbr2
      data cn,dtol,atol,pi,pi2/.017453292519943296d0,1d-6,.005,
     1 3.1415926535897932d0,6.2831853071795865d0/
c
      n=0
      if(mbr2.le.0) return
      x(1)=dmod(dabs(cn*delta),pi2)
      if(x(1).gt.pi) x(1)=pi2-x(1)
      x(2)=pi2-x(1)
      x(3)=x(1)+pi2
      if(dabs(x(1)).gt.dtol) go to 9
      x(1)=dtol
      x(3)=-10d0
 9    if(dabs(x(1)-pi).gt.dtol) go to 7
      x(1)=pi-dtol
      x(2)=-10d0
 7    do 1 j=mbr1,mbr2
 1    if(jndx(j,2).gt.0) call findtt(j,x,max,n,tmp,tmp(1,2),tmp(1,3),
     1 tmp(1,4),ctmp)
      if(n-1)3,4,5
 4    iptr(1)=1
      go to 6
 5    call r4sort(n,tmp,iptr)
 6    k=0
      do 2 i=1,n
      j=iptr(i)
      if(k.le.0) go to 8
      if(phnm(k).eq.ctmp(j).and.abs(tt(k)-tmp(j,1)).le.atol) go to 2
 8    k=k+1
      tt(k)=tmp(j,1)
      dtdd(k)=tmp(j,2)
      dtdh(k)=tmp(j,3)
      dddp(k)=tmp(j,4)
      phnm(k)=ctmp(j)
 2    continue
      n=k
 3    return
      end
      subroutine uctolc(n,ia,ifl)
c
c $$$$$ calls gchar and schar $$$$$
c
c   Subroutine uctolc converts the first n characters in string ia from
c   upper case to lower case.  If ifl<0 all characters are converted.
c   Otherwise characters enclosed by single quotes are left unchanged.
c   Programmed on 21 January by R. Buland.
c
      save
      character*1 ia(n)
      data nfl/1/
      if(ifl.lt.0) nfl=1
c   Scan the string.
      do 1 i=1,n
      if(ifl.lt.0) go to 2
c   Look for single quotes.
      if(ia(i).eq.'''') nfl=-nfl
c   If we are in a quoted string skip the conversion.
      if(nfl.lt.0) go to 1
c   Do the conversion.
 2    if(ichar(ia(i)).ge.65.and.ichar(ia(i)).le.90)
     1 ia(i)=char(ichar(ia(i))+32)
 1    continue
      return
      end
      double precision function umod(zs,isrc,nph)
      save
      include 'ttlim.inc'
      character*31 msg
      double precision pm,zm,us,pt,tau,xlim,xbrn,dbrn
      double precision zs,uend,dtol,zmod
      dimension isrc(2)
      common/umdc/pm(jsrc,2),zm(jsrc,2),ndex(jsrc,2),mt(2)
      common/tabc/us(2),pt(jout),tau(4,jout),xlim(2,jout),xbrn(jbrn,3),
     1 dbrn(jbrn,2),xn,pn,tn,dn,hn,jndx(jbrn,2),idel(jbrn,3),mbr1,mbr2
      data dtol/1d-6/
c
      m1=mt(nph)
      do 1 i=2,m1
      if(zm(i,nph).le.zs) go to 2
 1    continue
      dep=(1d0-dexp(zs))/xn
      write(msg,100)dep
      write(6,100)dep
 100  format('Source depth (',f6.1,') too deep.')
      call abort(msg)
 2    if(dabs(zs-zm(i,nph)).le.dtol.and.dabs(zm(i,nph)-zm(i+1,nph)).le.
     1 dtol) go to 3
      j=i-1
      isrc(nph)=j
      umod=pm(j,nph)+(pm(i,nph)-pm(j,nph))*(dexp(zs-zm(j,nph))-1d0)/
     1 (dexp(zm(i,nph)-zm(j,nph))-1d0)
      return
 3    isrc(nph)=i
      umod=pm(i+1,nph)
      return
c
      entry zmod(uend,js,nph)
      i=js+1
      zmod=zm(js,nph)+dlog(dmax1((uend-pm(js,nph))*(dexp(zm(i,nph)-
     1 zm(js,nph))-1d0)/(pm(i,nph)-pm(js,nph))+1d0,1d-30))
      return
      end

      complex function lpbptf_b(f)
c
c ...... compute 17-23 sec Butterworth 10PBP Transfer Function
c
      complex*8 citf
c
c     include some useful stuff
c
      include 'numerical.h'
c
      ns = 10
      wc2 = tpi/17.
      wc3 = 1.1*wc2
      wc1 = tpi/23.
      wc0 = wc1/1.1
      wc = f
c
      if(wc.le.wc0) then
        citf = cmplx(0.,0.)
      elseif(wc.lt.wc1) then
        arg = pi*(wc-wc0)/(wc1-wc0)
        q = 0.5*(1.-cos(arg))
        citf = cmplx(q,0.)
      elseif(wc.le.wc2) then
        citf = cmplx(1.,0.)
      elseif(wc.lt.wc3) then
        arg = pi*(wc3-wc)/(wc3-wc2)
        q = 0.5*(1.-cos(arg))
        citf = cmplx(q,0.)
      else
        citf = cmplx(0.,0.)
      endif
c
      lpbptf_b = citf 
c
      return
      end

      SUBROUTINE demean_noise(A,ns,N)
C
c	demean uses the pre-signal noise estimate
c	(from pt 1 to point ns) to determine the 
c	the mean value and removes the mean from
c     the entire time series.
c
c     based on routine demean
C                                                    
      INTEGER*4 N,I,ns
      DIMENSION A(*)
c
      XM=0.
      DO 1 I=1,ns
 1      XM=XM+A(I)
      XM=XM/ns
c
      DO 2 I=1,N
 2      A(I)=A(I)-XM
      RETURN
      END

      subroutine fetch_coord(io_res,filen,stat,slat,slon,sele,iere)
c
c     subroutine will find coordinates for station stat
c
c     input:
c     	io_res- io unit to open
c     	filen - coordinate file to be read
c     	stat  - 4 character station name
c     output:
c     	slat  - station latitude
c     	slon  - station longitude
c     	sele  - station elevation
c     	iere  - integer error flag
c           	= 0 for recovered coordinates
c           	= 999 for no coordinates found
c
      character*(*) stat
      character*4 cstat
      character*(*) filen
	real*4 slat, slon, sele
	real*4 clat, clon, cele
      integer*4 io_res, iere
c
c     Initialize
c
      iere = 0
c
      open(io_res,file=filen)
c
c     Loop over file until the correct one is found
c
100   continue
      read(io_res,101,end=105) cstat, clat, clon, cele
c
      if (cstat(4:4) .eq. '_') then
        cstat(4:4) =  ' '
      endif
c
c     compare station name, channel and date 
c
      if (cstat .eq. stat) then
c
c       match!
c
        slat = clat
        slon = clon
        sele = cele
        go to 110
      else
        go to 100
      end if
c
c     error exit
c
105   continue
      iere = 999
      close(io_res)
      return
c
c     sucessful completion exit
c
110   continue
      iere = 0
      close(io_res)
      return
c
c     format statements
c
101   format(a4,1x,f8.4,1x,f9.4,1x,f6.1)
c
      end

c
c
c
      subroutine sort(n, array, nindex)
c
c     subroutine to sort array in increasing order
c     and store the index of order in nindex
c
c     taken from Numerical Recipes, Press et al., p. 233
c
      real*4 array(*)
      integer*4 nindex(*)
c
c     check for a single number
c
      if (n .eq. 1) then
        nindex(1) = 1
        return
      endif
c
      do j = 1, n
        nindex(j) = j
      end do
      l = (n/2) + 1
      ir = n
  10  continue
      if (l .gt. 1) then
        l = l - 1
        ndt = nindex(l)
        q = array(ndt)
      else
        ndt = nindex(ir)
        q = array(ndt)
        nindex(ir) = nindex(1)
        ir = ir - 1
        if (ir .eq. 1) then
          nindex(1) = ndt
          return
        endif
      endif
      i = l
      j = l + l
  20  if (j .le. ir) then
        if (j .lt. ir) then
          if(array(nindex(j)) .lt. array(nindex(j+1))) j = j + 1
        endif
        if (q .lt. array(nindex(j))) then
          nindex(i) = nindex(j)
          i = j
          j = j + j
        else
          j = ir + 1
        endif
        go to 20
      endif
      nindex(i) = ndt
      go to 10
      end

C
      SUBROUTINE RLTR(A,B,N,ISN)
C   RLTR IS A SINGLE PRECISION VERSION OF REALTR. ALL INTEGERS ARE
C   32 BITS AND ALL FLOATING POINT VARIABLES ARE 32 BITS. RLTR
C   IS INTENDED FOR USE ON THE apollo AT SIO.
C   VARIABLES RE AND IM IN REALTR HAVE BEEN RENAMED XX AND YY IN RLTR.
C
C
C TITLE - REALTR = REAL TRANSFORM
C     FOURIER TRANSFORM OF REAL SERIES FROM OUTPUT OF FFT
C
C
C                     ---ABSTRACT---
C              SUBROUTINE REALTR (A,B,N,ISN)
C              IF ISN=1, THIS SUBROUTINE COMPLETES THE FOURIER TRANS-
C              FORM OF 2*N REAL DATA VALUES, WHERE THE ORIGINAL DATA
C              VALUES ARE STORED ALTERNATELY IN ARRAYS A AND B, AND ARE
C              FIRST TRANSFORMED BY A COMPLEX FOURIER TRANSFORM OF
C              DIMENSION N.
C              THE COSINE COEFFICIENTS ARE IN A(1),A(2),...A(N+1) AND
C              THE SINE COEFFICIENTS ARE IN B(1),B(2),...B(N+1).
C              A TYPICAL CALLING SEQUENCE IS
C              CALL FFT (A,B,N,1)
C              CALL REALTR (A,B,N,1)
C              THE RESULTS SHOULD BE MULTIPLIED BY 0.5/N TO GIVE THE
C              USUAL SCALING OF COEFFICIENTS.
C              IF ISN=1, THE INVERSE TRANSFORMATION IS DONE, THE
C              FIRST STEP IN EVALUATING A REAL FOURIER SERIES.
C              A TYPICAL CALLING SEQUENCE IS
C              CALL REALTR (A,B,N,-1)
C              CALL FFT (A,B,N,-1)
C              THE RESULTS SHOULD BE MULTIPLIED BY 0.5 TO GIVE THE
C              USUAL SCALING, AND THE TIME DOMAIN RESULTS ALTERNATE
C              IN ARRAYS A AND B, I.E. A(1),B(1), A(2),B(2),
C              ...A(N),B(N).
C              THE DATA MAY ALTERNATIVELY BE STORED IN A SINGLE
C              COMPLEX ARRAY A, THEN THE MAGNITUDE OF ISN CHANGED TO
C              TWO TO GIVE THE CORRECT INDEXING INCREMENT AND A(2)
C              USED TO PASS THE INITIAL ADDRESS FOR THE SEQUENCE OF
C              IMAGINARY VALUES,E.G.
C              CALL FFT(A,A(2),N,2)
C              CALL REALTR(A,A(2),N,2)
C              IN THIS CASE, THE COSINE AND SINE COEFFICIENTS
C              ALTERNATE IN A.
C
      IMPLICIT INTEGER*4(I-N)
c     DIMENSION A(1),B(1)
      DIMENSION A(*),B(*)
      IF(N .LE. 1) RETURN
      INC=ISN
      IF(INC.LT.0) INC=-INC
      NK = N * INC + 2
      NH = NK / 2
      SD = 3.1415926535898/(2.*N)
      CD = 2. * SIN(SD)**2
      SD = SIN(SD+SD)
      SN = 0.
      IF(ISN .GT. 0) GO TO 10
      CN = -1.
      SD = -SD
      GO TO 20
 10   CN = 1.
      A(NK-1) = A(1)
      B(NK-1) = B(1)
 20   DO 30 J=1,NH,INC
      K = NK - J
      AA = A(J) + A(K)
      AB = A(J) - A(K)
      BA = B(J) + B(K)
      BB = B(J) - B(K)
      XX = CN * BA + SN * AB
      YY = SN * BA - CN * AB
      B(K) = YY - BB
      B(J) = YY + BB
      A(K) = AA - XX
      A(J) = AA + XX
      AA = CN - (CD * CN + SD * SN)
      SN = (SD * CN - CD * SN) + SN
 30   CN = AA
C
      RETURN
      END

	subroutine est_ground(head,d1,dw,rdist,io_out,iere)
c
c     subroutine for estimation of ground motion
c
c     input:  
c             stat   - station name
c             chan   - channel name
c             npts   - number of points in timeseries
c             dt     - sample spacing in sec
c             d1     - data array
c             dw     - spectral array
c             rdist  - distance from hypocenter to station in km
c                      =0 if not specified
c             io_out - unit number for writing
c     output:  
c             iere   - error return code
c
      parameter (maxdur = 4)
      parameter (maxp  = 65536)
c
c     include files for header and time
c
      include '/usr/local/include/qlib2.inc'
      record /INT_TIME/ t1_time
      record /EXT_TIME/ t2_time
	include 'station_hdr.inc'
c
      real*4 d1(*), d2(maxp)
      real*4 dt, hstep, totint
      real*4 amax_vel, pmax_vel
      real*4 amax_acc, pmax_acc
      real*4 amax_dsp, pmax_dsp
      integer*4 npts, io_out, iere
      double precision dt1
      integer*4 imax_vel, imax_acc, imax_dsp
      complex*8 dw(*)
      character*3 chan
      character*4 stat
      logical lexist
c
      real*4 gd(maxdur), sd(maxdur)
      integer*4 id(maxdur), npd(maxdur,2)
c
      data gd /0.05, 0.10, 0.20, 0.50/
c
c     acceleration of gravity in m/s/s
c
      grav = 9.81
c
c     initialize error return
c
      iere = 0
c
c     set variables for ground motion parameters 
c
      ind = 21
      ind2 = 6
      fl = 0.0
      fh = 0.1
	np = 0
c
      stat  = head.station_id
      chan  = head.channel_id
      npts  = head.num_pts
      dt  = 1.0/head.sample_rate
c
c     remove instrument to velocity and hipass with a phaseless Butterworth
c
      call coinst2(npts,dt,ind,ind2,d1,dw,np,fl,fh,iere)
      if (iere .ne. 0) then
        return
      end if
c
c     find the velocity maximum (m/s) and its period
c
      call amaxper(npts,dt,d1,amax_vel,pmax_vel,imax_vel)
c
c     differentiate velocity to acceleration
c
      hstep = dt
      do kk = 1, npts - 1
        d2(kk+1) = (d1(kk+1) - d1(kk))/hstep
      end do
      d2(1) = 0.0
c
c     find the acceleration maximum (m/s/s) and its period
c
      call amaxper(npts-1,dt,d2,amax_acc,pmax_acc,imax_acc)
c
c     since we are here, determine the duration of strong shaking
c
      do kk = 1, maxdur
        id(kk) = 0
        npd(kk,1) = 0
        npd(kk,2) = 0
        do ii = 1, npts-1
          a = abs(d2(ii)/grav)
          if (a .ge. gd(kk)) then
            id(kk) = id(kk) + 1
            if (id(kk) .eq. 1) then
              npd(kk,1) = ii
            end if
            npd(kk,2) = ii
          end if
        end do
        if (id(kk) .ne. 0) then
          kpts = npd(kk,2) - npd(kk,1) + 1
          sd(kk) = kpts*dt
        else
          sd(kk) = 0.0
        end if
      end do
c
c     integrate velocity to displacement
c
      hstep = 0.5*dt
      totint = 0.0
      do kk = 1, npts - 1
        totint = totint + hstep*(d1(kk) + d1(kk+1))
        d2(kk) = totint
      end do
c
c     find the displacement maximum (m) and its period
c
      call amaxper(npts-1,dt,d2,amax_dsp,pmax_dsp,imax_dsp)
c
c     convert the measurements to millimeters from meters
c
      amax_dsp = amax_dsp * 1000.
      amax_vel = amax_vel * 1000.
      amax_acc = amax_acc * 1000.
c
c     output file for PGA,PGV,PGD
c
      call klen(stat,kk)
      inquire(file='ground.wave',exist=lexist)
      if (lexist) then
        open(unit=io_out,file='ground.wave',fileopt='eof')
      else
        open(unit=io_out,file='ground.wave')
        write(io_out,'(a2)') '# '
        write(io_out,'(a)') '#Stat Com  Nt  Val  Azi Dip  Year Doy Hr Mn
     . Sc    Ms         Amax    Freq(hz)    Lat      Lon     Dist(km)'
      end if
      dt1 = imax_acc * dble(dt)
      call f_add_dtime(head.begtime, dt1, t1_time)
      call f_int_to_ext(t1_time,t2_time)
      write(io_out,200) stat(1:kk), chan, head.network_id,' PGA ',
     .  head.azi, head.dip, t2_time.year, t2_time.doy, 
     .  t2_time.hour, t2_time.minute, t2_time.second, 
     .  int(t2_time.usec/usecs_per_tick),
     .  amax_acc, 1.0/pmax_acc, head.slat, head.slon, rdist
c
      dt1 = imax_vel * dble(dt)
      call f_add_dtime(head.begtime, dt1, t1_time)
      call f_int_to_ext(t1_time,t2_time)    
      write(io_out,200) stat(1:kk), chan, head.network_id,' PGV ',
     .  head.azi, head.dip, t2_time.year, t2_time.doy,
     .  t2_time.hour, t2_time.minute, t2_time.second,
     .  int(t2_time.usec/usecs_per_tick),
     .  amax_vel, 1.0/pmax_vel, head.slat, head.slon, rdist
c
      dt1 = imax_dsp * dble(dt)
      call f_add_dtime(head.begtime, dt1, t1_time)
      call f_int_to_ext(t1_time,t2_time)    
      write(io_out,200) stat(1:kk), chan, head.network_id,' PGD ',
     .  head.azi, head.dip, t2_time.year, t2_time.doy,
     .  t2_time.hour, t2_time.minute, t2_time.second,
     .  int(t2_time.usec/usecs_per_tick),
     .  amax_dsp, 1.0/pmax_dsp, head.slat, head.slon, rdist
c
200   format(1x,a4,1x,a3,1x,a4,a5,
     .  f4.0,1x,f4.0,1x,i4,1x,i3,1x,
     .  i2,1x,i2,1x,i2,1x,i5,1x,
     .  2f12.5,f7.3,1x,f8.3,1x,f12.5)
      close(io_out)
c
c     output file for shaking
c
      inquire(file='shake.wave',exist=lexist)
      if (lexist) then
        open(unit=io_out,file='shake.wave',fileopt='eof')
      else
        open(unit=io_out,file='shake.wave')
        write(io_out,'(a2)') '# '
        write(io_out,'(a)') '#Stat Com  Nt  Val  Azi Dip  Year Doy Hr Mn
     . Sc    Ms      5%    10%    25%    50%    Lat      Lon     Dist(km
     .)'
      end if
      write(io_out,250) stat(1:kk), chan, head.network_id,' SHAK',
     .  head.azi, head.dip, t2_time.year, t2_time.doy,
     .  t2_time.hour, t2_time.minute, t2_time.second,
     .  int(t2_time.usec/usecs_per_tick),
     .  sd(1), sd(2), sd(3), sd(4), head.slat, head.slon, rdist
c
250   format(1x,a4,1x,a3,1x,a4,a5,
     .  f4.0,1x,f4.0,1x,i4,1x,i3,1x,
     .  i2,1x,i2,1x,i2,1x,i5,1x,
     .  4f7.3,f7.3,1x,f8.3,1x,f12.5)
      close(io_out)
c
c     all done
c
      return
      end

c23456789012345678901234567890123456789012345678901234567890123456789012
c
      subroutine ttimes(zs,delta,plist,n,tt,dtdd,dtdh,dddp,phcd)
c
c     zs - source depth (km)
c     delta - distance in degrees
c     plist - phase request
c    
c     n - number of phases
c     tt - array of travel times
c     dtdd - array of d time /d distance values
c     dtdh - array of d time /d depth values
c     dddp - array of d distane /d ray parameter values
c     phcd - array of phase names
c
      save
      parameter (nphase=60)
c
      logical prnt(3), lprem
      character*8 phcd(nphase),phlst(1), plist, plast
      character*40 modnam
      real*4 tt(nphase),dtdd(nphase),dtdh(nphase),dddp(nphase)
      real*4 usrc(2)
c
      data plast /' '/
c
      common /t_slow/ usrc
      common /t_model/ lprem
c
      in = 1
c
      if (lprem) then
        modnam = '/usr/contrib/data/iaspei_91/prem'
      else
        modnam = '/usr/contrib/data/iaspei_91/iasp91'
      end if
c
      do ii = 1, 3
        prnt(ii) = .false.
      end do
      do ii = 1, nphase
        tt(ii) = 0.0
        dtdd(ii) = 0.0
        dtdh(ii) = 0.0
        dddp(ii) = 0.0
        phcd(ii) = ' '
      end do
      usrc(1) = 0.0
      usrc(2) = 0.0
      phlst(1) = plist
      n = 0
      nc = 1
c
      if (plast .ne. plist) then
        close(in)
        call tabin(in,modnam)
        call brnset(nc,phlst,prnt)
        plast = plist
      endif
c 
      call depset(zs,usrc)
c 
      call trtm(delta,nphase,n,tt,dtdd,dtdh,dddp,phcd)
c
      end

      complex function ulp(w)
c
c     compute BKS ultra-long period Transfer Function
c 
c     w is angular frequency in rad/s
c
      complex*8 cz(2),cp(7), ck, s, t
c
c     poles and zero of Benioff response
c
      data ck /(9.46127E+17,0.)/
      data cz /2*(0.,0.)/
      data cp / (-4.398230E-02, 4.487092E-02),
     2          (-4.398230E-02,-4.487092E-02),
     3          (-4.854028E+01,-1.493916E+02),
     4          (-4.854028E+01, 1.493916E+02),
     5          (-1.270801E+02,-9.232909E+01),
     6          (-1.270801E+02, 9.232909E+01),
     7          (-1.570796E+02, 0.000000E+00)/
c
      s = cmplx(0.,w)
c
      t = ck
c
c     loop over common zeros and poles
c
      do ii = 1, 2
        t = t * ((s - cz(ii))/(s - cp(ii)))
      end do
c
c     loop over remaining poles
c
      do ii = 3, 7
        t = t / (s - cp(ii))
      end do
c
      ulp = t
c
      return
      end

      program redi_wave
c
c     Program takes input time series and performs various operations
c	Command line driven
c
c     redi_wave -w -g -r -v [-l lat lon -t time] file1 .... filen
c
c     -w computes Wood Anderson amplitude
c     -g computes ground acceleration, velocity, and displacement
c     -e computes energy magnitude - requires 3-C data
c     -p computes characteristic function and picks - requires 3-C data
c     -r computes ramp function
c
c     -l inputs event location (lat, lon in decimal degrees)
c     -t inputs event origin time
c     -d inputs event depth (in km)
c
c     -f inputs filter information (npole, fl, fh in hz)
c
c     -coord inputs file for instrument coordinates
c     -resp inputs file for instrument response
c
c     -v sets the verbose output option
c     -s sets the save flag
c
      include '/usr/local/include/qlib2.inc'
c
c     maxp is the dimension of the data array
c     maxp2 is the dimension of the array for the fft
c     maxps is the parameter for the maximum request
c     -- this is the data array to be doubled to the next power of 2
c     maxfl is the parameter for the maximum number of files
c
      parameter (maxp  = 65536)
      parameter (maxp2 = 32768)
      parameter (maxps = 32767)
      parameter (maxfl = 75)
      parameter (mphase = 60)
c
c structure for sdr header
c
      include 'station_hdr.inc'
      include 'pick_hdr.inc'
c
      integer*4 idata(maxp)
      real*4 d1(maxp)
      complex*8 dw(maxp2)
c
      real*4 dt
      real*4 slat, slon, sele
      real*4 elat, elon, edep
      real*4 fl0, fh0
      real*4 dtr, dtc
      real*4 tip(mphase),pip(mphase),dtdh(mphase),dddp(mphase)
	real*4 pi, deg2km, deg2rad
      real*8 td1, td2
      integer*4 it1s, it1t, it2s, it2t
      integer*4 npts, iflag, nfile, ierr, icomp
      integer*4 ifile(maxfl), np0, idc
      integer*4 ic(3)
      character*1 cid
      character*3 chan, chan_iem
      character*4 stat, stat_iem
      character*8 plist, slist, phip(mphase)
      character*256 fileo(maxfl), filen, argv
      character*256 file_coord, file_resp, file_sens
      character*256 file_save, file_pick
      logical lwood, lground, lresp, lexist, lloc, ltime, lverbose
      logical lenergy, ldep, lsave, lpick, lramp, l3, lsignal
      logical parse_date, lclip
c
      external myhandler, parse_date
c
      record /INT_TIME/ org_time, time_iem, t1_time, t2_time,
     .  p_time
      record /EXT_TIME/ ext_time
      record /PICK/ pick(100),iasp(100)
c
c     common blocks
c
      common /filter/ np0, fl0, fh0
c
c     data arrays
c
      data io /6/
      data io_out /7/
      data io_save /8/
      data io_in /2/
      data nfile /0/
      data lwood,lground,lresp,lexist,lloc,ltime,lverbose /7*.false./
      data lenergy, lpick, lramp, l3, ldep, lclip /6*.false./
      data icomp /0/
      data file_coord /'/home/redi/stat/bdsn.stat.all'/
      data file_resp /'/home/redi/stat/bdsn.resp'/
c     data file_resp /'/usr/contrib/data/bdsn/instr.resp'/
      data file_sens /'/usr/contrib/data/bdsn/instr.sens'/
      data file_pick /'pickfile.pf'/
      data np0,fl0,fh0 /0, 0.0, 0.0/
      data plist,slist /'P','S'/
      data ipick,itime /0,0/
      data s2n /0.0/
c
c     turn on ieee error handling
c
c     ie = ieee_handler ('set', 'all', myhandler)
c
c     conversion from degrees to km
c
      rnk = 6371.0
      pi = 4.0*atan(1.0)
      deg2rad = pi/180.
      deg2km = rnk * deg2rad
c
c     get command line arguments
c
      inum = iargc()
      if (inum .eq. 0 .or. inum .eq. 1) then
        write(io,*)' redi_wave {-w -g -r} [-l lat lon -t time] '
        write(io,*)'           {-v -s} file1 .... filen'
        write(io,*)' -w          computes WA amplitude'
        write(io,*)' -g          computes ground motion'
        write(io,*)' -r          computes ramp function'
        write(io,*)' -e          computes energy magnitude'
        write(io,*)'               {requires -l and -d and 3-comp data}'
        write(io,*)' -p          computes characteristic function'
        write(io,*)'               {requires 3-comp data}'
        write(io,*)' '
        write(io,*)' -n s/n      input signal/noise ratio for testing'
        write(io,*)' -t time     input event origin time'
        write(io,*)' -l lat lon  input event location'
        write(io,*)' -d depth    input event depth'
        write(io,*)' '
        write(io,*)' -f np fl fh input filter parameters'
        write(io,*)' -c dtr dtc  input chr/detector parameters'
        write(io,*)' '
        write(io,*)' -coord      input station coordinate file'
        write(io,*)' -resp       input station response file'
        write(io,*)' '
        write(io,*)' -pick       input pickfile'
        write(io,*)' '
        write(io,*)' -v          verbose output option'
        write(io,*)' -s          save output data'
        write(io,*)' file1...    input SDR format file(s)'
        write(io,*)' '
        stop
      else
        i = 1
c
c       This large do while loops over the command line arguments
c
        do while (i .le. inum)
c
cccc      Check for options
c
          call getarg(i,argv)
          if (argv .eq. '-w') then
            lwood = .true.
          elseif (argv .eq. '-g') then
            lground = .true.
          elseif (argv .eq. '-e') then
            lenergy = .true.
            l3 = .true.
          elseif (argv .eq. '-p') then
            lpick = .true.
            l3 = .true.
          elseif (argv .eq. '-r') then
            lramp = .true.
            l3 = .true.
          elseif (argv .eq. '-v') then
            lverbose = .true.
          elseif (argv .eq. '-s') then
            lsave = .true.
          elseif (argv .eq. '-n') then
            i = i + 1
            call getarg(i,argv)
            call cipnum(argv, s2n, iflag)
            if (iflag .ne. 0) then
              write(io,'(a)') '  Redi_wave - Unable to decode S/N ratio'
              call exit(1)
            end if
            lsignal = .true.
          elseif (argv .eq. '-l') then
            i = i + 1
            call getarg(i,argv)
            call cipnum(argv, elat, iflag)
            if (iflag .ne. 0) then
              write(io,'(a)') '  Redi_wave - Unable to decode latitude'
              call exit(1)
            end if
            i = i + 1
            call getarg(i,argv)
            call cipnum(argv, elon, iflag)
            if (iflag .ne. 0) then
              write(io,'(a)') '  Redi_wave - Unable to decode longitude'
              call exit(1)
            end if
		if (lverbose) then
		  write(io,*)' Coordinates: ', elat, elon
		end if
            lloc = .true.
          elseif (argv .eq. '-t') then
            i = i + 1
            call getarg(i,argv)
            ltime = f_parse_date(org_time, argv)
            if (.not. ltime) then
              write(io,'(a)') '  Redi_wave - Unable to decode time'
              call exit(1)
            end if
		if (lverbose) then
		  write(io,*) ' Time: ', org_time.year, org_time.second, 
     &          org_time.usec
		end if
          elseif (argv .eq. '-d') then
            i = i + 1
            call getarg(i,argv)
            call cipnum(argv, edep, iflag)
            if (iflag .ne. 0) then
              write(io,'(a)') '  Redi_wave - Unable to decode depth'
              call exit(1)
            end if
		if (lverbose) then
		  write(io,*)' Depth: ', edep
		end if
            ldep = .true.
          elseif (argv .eq. '-f') then
            i = i + 1
            call getarg(i,argv)
            call cipnum(argv, rnum, iflag)
            if (iflag .ne. 0) then
              write(io,'(a)') '  Redi_wave - Unable to decode np0'
              call exit(1)
            end if
            np0 = rnum
            i = i + 1
            call getarg(i,argv)
            call cipnum(argv, fl0, iflag)
            if (iflag .ne. 0) then
              write(io,'(a)') '  Redi_wave - Unable to decode fl'
              call exit(1)
            end if
            i = i + 1 
            call getarg(i,argv)  
            call cipnum(argv, fh0, iflag) 
            if (iflag .ne. 0) then 
              write(io,'(a)') '  Redi_wave - Unable to decode fh'
              call exit(1) 
            end if 
		if (lverbose) then
		  write(io,*)' Filter: ', np0, fl0, fh0
		end if
          elseif (argv .eq. '-c') then
            i = i + 1
            call getarg(i,argv)
            call cipnum(argv, rnum, iflag)
            if (iflag .ne. 0) then
              write(io,'(a)') '  Redi_wave - Unable to decode chr'
              call exit(1)
            end if
            idc = rnum
            i = i + 1
            call getarg(i,argv)
            call cipnum(argv, dtr, iflag)
            if (iflag .ne. 0) then
              write(io,'(a)') '  Redi_wave - Unable to decode dtr'
              call exit(1)
            end if
            i = i + 1
            call getarg(i,argv)
            call cipnum(argv, dtc, iflag)
            if (iflag .ne. 0) then
              write(io,'(a)') '  Redi_wave - Unable to decode dtc'
              call exit(1)
            end if
            if (lverbose) then
              write(io,*)' Characteristic function: ', idc
              write(io,*)' Detection constants: ', dtr, dtc
            end if
          elseif (argv .eq. '-coord') then
            i = i + 1
            call getarg(i,argv)
            file_coord = argv
            if (lverbose) then
              call klen(file_coord,kc)
              write(io,*)' Coordinate file: ', file_coord(1:kc)
            end if
          elseif (argv .eq. '-pick') then
            i = i + 1
            call getarg(i,argv)
            file_pick = argv
            if (lverbose) then
              call klen(file_pick,kc)
              write(io,*)' Pick file: ', file_pick(1:kc)
            end if
          elseif (argv .eq. '-resp') then
            i = i + 1
            call getarg(i,argv)
            file_resp = argv
            if (lverbose) then
              call klen(file_resp,kc)
              write(io,*)' Response file: ', file_resp(1:kc)
            end if
          else
c
c           get a list of all the file names
c
            nfile = nfile + 1
            if (nfile .gt. maxfl) then
              nfile = nfile - 1
              write(io,*)'  Redi_wave - too many data files'
            else
              fileo(nfile) = argv
            end if
          end if
          i = i + 1
        end do
      end if
c
      if (nfile .eq. 0) then
        write(io,*) '  Redi_wave - no input data files '
        call exit(1)
      end if
c
c     sort the files names
c
      call sort_c(nfile,fileo,ifile)
c
c     tell us what to expect
c
      if (lverbose) then
        write(io,*) ' '
        if (lwood) then
          write(io,'(a)') '  Computing Wood-Anderson synthetics'
        end if
        if (lground) then
          write(io,'(a)') '  Computing ground motion values'
        end if
        if (l3) then
          if (lenergy) then
            write(io,'(a)') '  Computing energy magnitude'
          end if
          if (lpick) then
            write(io,'(a)') '  Computing characteristic function'
          end if
          if (lramp) then
            write(io,'(a)') '  Computing ramp growth rate'
          end if
        end if
      end if
c
c     Now begin processing data
c
      if (lverbose) then
          write(io,*) ' '
          write(io,*) ' Looping over files'
      end if
      do jj = 1, nfile
        lclip = .false.
        filen = fileo(ifile(jj))
        call klen(filen,kf)
        if (lverbose) then
          write(io,*) ' ',filen(1:kf)
        end if
c
c       read data in  - the data is originally integer
c
        call sdr_read(filen,maxps,idata,head,ierr)
        if (ierr .ge. 999) then
          write(io,*) '  Redi_wave - error opening file ',ierr
          go to 999
        end if
        stat  = head.station_id
        chan  = head.channel_id
        npts  = head.num_pts
        dt  = 1.0/head.sample_rate
c
c       check for clipping - stolen from Bob
c
        call check_clip(chan,npts,idata,ierr)
        if (ierr .ne. 0) then
          write(io,*) '  Redi_wave - data may be clipped ',ierr
          if (.not. lramp) then
            go to 999
          else
            write(io,*) '  Using data anyway'
            lclip = .true.
          end if
        end if
c
c       get instrument information
c
        inquire(file=file_coord,exist=lexist)
	  if (.not. lexist) then
          write(io,*) '  Redi_wave - coordinate file does not exist'
          go to 999
        end if
c
        call fetch_coord(io_in,file_coord,stat,slat,slon,sele,ierr)
	  head.slat = slat
	  head.slon = slon
	  head.sele = sele
        if (ierr .ne. 0) then
          write(io,*) '  Redi_wave - error with coordinates ',ierr
          go to 999
        end if
c
        if (lramp) then
          inquire(file=file_sens,exist=lexist)
  	    if (.not. lexist) then
            write(io,*) '  Redi_wave - sensitivity file does not exist'
            go to 999
          end if
          call fetch_sens(io_in,file_sens,head,ierr) 
          if (ierr .ne. 0) then
            write(io,*) '  Redi_wave - error with sensitivity ',ierr
            go to 999
          end if
        end if
c
        inquire(file=file_resp,exist=lexist)
	  if (.not. lexist) then
          write(io,*) '  Redi_wave - response file does not exist'
          go to 999
        end if
        call fetch_response(io_in,file_resp,head,ierr)
        if (ierr .ne. 0) then
          write(io,*) '   Redi_wave - error with response ',ierr
          go to 999
        end if
c
c       read the pickfile, if it exists
c
        inquire(file=file_pick,exist=lexist)
        if (lexist) then 
          call fetch_pick(io_in,file_pick,head,pick,ipick,ierr) 
          if (ierr .ne. 0) then
            write(io,*) '   Redi_wave - error reading pickfile', ierr
          end if
c
          if (lverbose) then
            do ip = 1, ipick
              call f_int_to_ext(pick(ip).ptime,ext_time)
              write(io,*) pick(ip).pid,' ',
     .        ext_time.year, ext_time.doy, ext_time.hour,
     .        ext_time.minute, ext_time.second, ext_time.usec
            end do
          end if
c
        end if
c
c       calculate the epicentral distance, azimuth, and focal distance
c
        if (lloc) then
          call azimth(elat,elon,slat,slon,delta,azim,bazim)
          dist = delta * deg2km
          if (ldep) then
            rdist = sqrt(dist*dist + edep*edep)
          end if
        else
          delta = 0.0
          dist = 0.0
          rdist = 0.0
        end if
c 
c       calculate some travel times 
c 
        if (lenergy .or. lramp) then
        if (lloc .and. ltime .and. ldep) then 
          call ttimes(edep,delta,plist,nip,tip,pip,dtdh,dddp,phip) 
          t1 = tip(1) 
          it1s = int(t1)  
          it1t = (t1 - it1s)*usecs_per_sec  
          call f_add_time(org_time, it1s, it1t, t1_time)  
          iasp(1).pid = phip(1)
          iasp(1).ptime = t1_time
c
          call ttimes(edep,delta,slist,nip,tip,pip,dtdh,dddp,phip)
          t1 = tip(1)
          it1s = int(t1)
          it1t = (t1 - it1s)*usecs_per_sec
          call f_add_time(org_time, it1s, it1t, t1_time)
          iasp(2).pid = phip(1)
          iasp(2).ptime = t1_time
c
          itime = 2
        end if 
        end if 
c
c       check for signal to noise ratio
c
c       if (lsignal) then
c         call check_s2n(head,idata,iasp,ierr)
c         if (ierr .ne. 0) then
c           write(io,*) '  Redi_wave - data may be clipped ',ierr
c           go to 999
c         end if
c       end if
c
c       extract desired window length in some cases
c
        if (lenergy .or. lramp) then
          t1 = -30.
          t2 = 60.
          it1s = int(t1)
          it1t = (t1 - it1s)*usecs_per_sec
          it2s = int(t2)
          it2t = (t2 - it2s)*usecs_per_sec
c
          if (lverbose) then
            call f_int_to_ext(head.begtime,ext_time)
            write(io,*) ' Before window extraction: ',
     .        stat,' ',chan,' ',head.num_pts,
     .        ext_time.year, ext_time.doy, ext_time.hour,
     .        ext_time.minute, ext_time.second, ext_time.usec
          end if
c
          if (ipick .ne. 0) then
            call f_add_time(pick(1).ptime, it1s, it1t, t1_time)
            call f_add_time(pick(1).ptime, it2s, it2t, t2_time)
            call extra_window(head,idata,t1_time,t2_time,ierr)
          elseif (itime .ne. 0) then
            call f_add_time(iasp(1).ptime, it1s, it1t, t1_time)
            call f_add_time(iasp(1).ptime, it2s, it2t, t2_time)
            call extra_window(head,idata,t1_time,t2_time,ierr)
          else
            write(io,*) '  Redi_wave - unable to extract window'
          end if
50        continue
          if (ierr .ne. 0) then
            write(io,*) '  Redi_wave - insufficient data ',ierr
            go to 999
          else
            npts = head.num_pts
          end if
          if (lverbose) then 
            call f_int_to_ext(head.begtime,ext_time) 
            write(io,*) ' After window extraction:  ',
     .        stat,' ',chan,' ',head.num_pts,
     .      ext_time.year, ext_time.doy, ext_time.hour, 
     .      ext_time.minute, ext_time.second, ext_time.usec 
          end if 
        end if
c
c       check length of timeseries for arrivals of interest
c
        if (lwood .or. lground) then
          if (lloc .and. ltime) then
            call check_window(head.begtime,head.endtime,org_time,
     .        dist,ierr)
            if (ierr .ne. 0) then
              write(io,*) '  Redi_wave - insufficient window ',ierr
              go to 999
            end if
          end if
        end if
c
c       check length of timeseries for FFT
c
        n2 = ipow(npts*2)
        if (n2 .gt. maxp) then
          write(io,*) '  Redi_wave - FFT exceeded '
          go to 999
        end if  
c
c       summarize what we know about this data
c
c       if (lverbose) then
c         write(io,*) stat, ' ', chan, ' ', npts, ' ',dt
c         write(io,*) head.slat,' ',head.slon,' ',head.sele
c         write(io,*) head.azi,' ',head.dip,' ',head.iunit
c         write(io,*) head.ds,' ',head.gain
c         write(io,*) head.npoles,' ',head.nzeros
c       endif
c
c ********************************************************************
c We are through with preparations - now let's do something
c ********************************************************************
c
c       Calculate Wood Anderson response
c
        if (lwood) then
          do ii = 1, npts
            d1(ii) = idata(ii)
          end do
          call est_wood(head,d1,dw,io_out,ierr)
          if (ierr .ne. 0) then
            write(io,*) '  Redi_wave - error in WA est ',ierr
            go to 999
          end if
          if (lsave) then
            file_save = filen(1:kf)//'.wood'
            call save_to_ascii(head,d1,io_save,file_save,ierr)
          end if
        end if
c
c       Calculate ground displacement/velocity/acceleration
c
        if (lground) then
          do ii = 1, npts
            d1(ii) = idata(ii)
          end do
c
c         changed from dist to rdist 9/23/98
c
          call est_ground(head,d1,dw,rdist,io_out,ierr)
          if (ierr .ne. 0) then
            write(io,*) '  Redi_wave - error in GM est ',ierr
            go to 999
          end if
          if (lsave) then
            file_save = filen(1:kf)//'.ground'
            call save_to_ascii(head,d1,io_save,file_save,ierr)
          end if
        end if
c
c       Calculate response spectra
c
        if (lresp) then
          write(io,*) '  Redi_wave - option not implemented'
        end if
ccccc
c
c       These options require 3 component data
c       -- do the overhead now in common
c
       if (l3) then
c
          if (icomp .ne. 0) then
            if (stat .eq. stat_iem) then
              if (chan(1:2) .eq. chan_iem(1:2)) then
                td1 = f_tdiff(head.begtime, time_iem)
                if (td1 .eq. 0.d0) then
                  icomp = icomp + 1
                  go to 1000
                end if
              end if
            end if
            write(io,*) '  Redi_wave - unexpected channel ',td1
          end if
c
c         try again
c
          icomp = 1
          stat_iem = stat
          chan_iem = chan
          time_iem = head.begtime
          do kk = 1, 3
            ic(kk) = 0
          end do
c
1000      continue
          cid = chan(3:3)
          if (cid .eq. 'Z' .or. cid .eq. '1') then
            ic(1) = ic(1) + 1
          elseif (cid .eq. 'N' .or. cid .eq. '2') then
            ic(2) = ic(2) + 1
          elseif (cid .eq. 'E' .or. cid .eq. '3') then
            ic(3) = ic(3) + 1
          end if
c
c         Calculate energy magnitude
c
          if (lenergy) then
            do ii = 1, npts
              d1(ii) = idata(ii)
            end do
            call est_energy(head,d1,dw,dist,icomp,ic,io_out,ierr)
            if (ierr .ne. 0) then
              write(io,*) '  Redi_wave - error in EN est ',ierr
              go to 399
            end if
            if (lsave) then
               file_save = filen(1:kf)//'.energy'
              call save_to_ascii(head,d1,io_save,file_save,ierr)
            end if
399         continue
          end if
c
c         Calculate characteristic function and pick arrivals
c
          if (lpick) then
c            do ii = 1, npts
c              d1(ii) = idata(ii)
c            end do
c            if (idc .eq. 0) then
c              idc = 1
c              dtr = 9.
c              dtc = 15.
c            end if
c            call est_cfr(head,idc,dtr,dtc,d1,dw,icomp,ic,
c     .          file_pick,io_out,ierr)
c            if (ierr .ne. 0) then
c              write(io,*) '  Redi_wave - error in CF est ',ierr
c              go to 499
c            end if
c            if (lsave) then
c              file_save = filen(1:kf)//'.pick'
c              call save_to_ascii(head,d1,io_save,file_save,ierr)
c            end if
c499         continue
          end if
c
c         Calculate ramp function and parameters
c
          if (lramp) then
            if (ipick .eq. 0) then
              write(io,*) '  Redi_wave - tt required'
              go to 599
            end if
            do ii = 1, npts
              d1(ii) = idata(ii)
            end do
            td1 = 0.d0
            td2 = 0.d0
c
c           use the first pick only - so assume it is good
c
            ip = 1
            p_time = pick(ip).ptime
c           call est_ramp(head,d1,p_time,dist,icomp,ic,lclip,
c     .          io_out,ierr)
            if (ierr .ne. 0) then
              write(io,*) '  Redi_wave - error in RF est ',ierr
              go to 599
            end if
c           if (lsave) then
c             file_save = filen(1:kf)//'.ramp'
c             call save_to_ascii(head,d1,io_save,file_save,ierr)
c           end if
599         continue
          end if
c
c         reinitialize the variables if we are through
c
          if (icomp .ge. 3) then
            icomp = 0
            do kk = 1, 3
              ic(kk) = 0
            end do
          end if
c
c       end of if statement over 3 component data
c
        end if
c
999     continue
c
c       end of loop over stuff with filen
c
       end do
c
       stop
       end

C
      SUBROUTINE FFTL(X,N,NDIR,DT,IERR)
C   SINGLE PRECISION DRIVER FOR AN FFT. ALL INTEGERS ARE
C   32 BITS AND ALL FLOATING POINT VARIABLES ARE 32 BITS. FFTL IS
C   INTENDED FOR USE ON THE apollo AT SIO.
C
C $$$$$ CALLS FFT AND REALTR $$$$$
C
C   IF IABS(NDIR).EQ.1 FFTL FOURIER TRANSFORMS THE N POINT REAL TIME
C   SERIES IN ARRAY X.  THE RESULT OVERWRITES X STORED AS
C   (N+2)/2 COMPLEX NUMBERS (NON-NEGATIVE FREQUENCIES ONLY).  IF
C   IABS(NDIR).EQ.2 FFTL FOURIER TRANSFORMS THE (N+2)/2 COMPLEX FOURIER
C   COEFFICIENTS (NON-NEGATIVE FREQUENCIES ONLY) IN ARRAY X
C   (ASSUMING THE SERIES IS HERMITIAN).  THE RESULTING N POINT REAL
C   TIME SERIES OVERWRITES X.  IF NDIR.GT.0 THE FORWARD TRANSFORM USES
C   THE SIGN CONVENTION EXP(I*W*T).  IF NDIR.LT.0 THE FORWARD TRANSFORM
C   USES THE SIGN CONVENTION EXP(-I*W*T).  THE FORWARD TRANSFORM IS
C   NORMALIZED SUCH THAT A SINE WAVE OF UNIT AMPLITUDE IS TRANSFORMED
C   INTO DELTA FUNCTIONS OF UNIT AMPLITUDE.  THE BACKWARDS TRANSFORM IS
C   NORMALIZED SUCH THAT TRANSFORMING FORWARD AND THEN BACK RECOVERS
C   THE ORIGINAL SERIES.  IERR IS NORMALLY ZERO.  IF IERR.EQ.1 THEN FFT
C   HAS NOT BEEN ABLE TO FACTOR THE SERIES.  HOWEVER, X HAS BEEN
C   SCRAMBLED BY REALTR.  NOTE THAT IF N IS ODD THE LAST POINT WILL NOT
C   BE USED IN THE TRANSFORM.
C
C                                                     -RPB
C
C  THE SCALING IN FFTL DIFFERS FROM THAT IN THE USUAL FFTL ON THE PRIME.
C  THE FORWARD TRANSFORM IS SPECTRUM(W)=DT*SUM(0,N-1)X(J)*EXP(-I*W*J*DT)
C  THE SPACING IN W IS 2*PI/(N*DT)
C                                                     -ALL
C
      IMPLICIT INTEGER*4(I-N)
c     DIMENSION X(1)
      DIMENSION X(*)
      N2=N/2
      IDIR=NDIR
      IF(IDIR.LT.0) IDIR=-IDIR
      GO TO (1,2),IDIR
C   DO FORWARD TRANSFORM (IE. TIME TO FREQUENCY).
 1    CALL FFT(X,X(2),N2,N2,N2,2,IERR)
      CALL RLTR(X,X(2),N2,2)
      N1=2*N2+2
C     SCALE=1./N
      SCALE=0.5*DT
      IF(NDIR.GT.0) GO TO 3
      DO 5 I=4,N,2
 5    X(I)=-X(I)
      GO TO 3
C   DO BACKWARD TRANSFORM (IE. FREQUENCY TO TIME).
 2    IF(NDIR.GT.0) GO TO 6
      DO 7 I=4,N,2
 7    X(I)=-X(I)
 6    X(2)=0.
      N1=2*N2
      X(N1+2)=0.
      CALL RLTR(X,X(2),N2,-2)
      CALL FFT(X,X(2),N2,N2,N2,-2,IERR)
C     SCALE=.5
      SCALE=1./(N*DT)
C   NORMALIZE THE TRANSFORM.
 3    DO 4 I=1,N1
 4    X(I)=SCALE*X(I)
      RETURN
      END

	subroutine check_window(beg_time,end_time,org_time,dist,iere)
c
c     subroutine to check window length
c
c     input:  
c             beg_time - data begin time
c             end_time - data end time
c             org_time - orgin time
c             dist - distance from this data to event in km
c     output:  
c             iere   - error return code
c                      998 if window begins too late
c                      999 if window ends too early
c                      0 otherwise
c
      include '/usr/local/include/qlib2.inc'
      record /INT_TIME/ beg_time, end_time, org_time, t1_time, t2_time
      record /EXT_TIME/ ext_time
c
      character*256 cval
      integer*4 iere, it1s, it2s, it1t, it2t
      real*4 dist, t1, t2
      real*8 td1, td2
ccccc
c
       data xmax_speed /4.5/
       data xmin_speed_0 /2.5/
       data xmin_speed_1 /2.0/
c
c     initialize error return
c
      iere = 0
c
c     check distance for necessary windows - these numbers from redi.config
c     and extract_seis.c
c
c      /* Compute end time. */
c     if (dist_km <= 100) tdif = dist_km / Min_Speed_0;
c     else tdif = dist_km / Min_Speed_1;
c
c	setenv  REDI_EVENT_MIN_SPEED_0          2.0
c 	setenv  REDI_EVENT_MIN_SPEED_1          1.8
c	setenv  REDI_EVENT_MAX_SPEED            8.5
c
cccccc
c     96/05/28 - new cda software means less slop in requests
c
c      t1 = dist/xmax_speed - 5.0
c      if (dist .le. 100.) then
c        t2 = dist/xmin_speed_0 + 5.0
c      else
c        t2 = dist/xmin_speed_1 + 5.0
c      end if
cccccc
c    96/09/22 - pick up the enviroment variables directly
c
c      call getenv('REDI_EVENT_MAX_SPEED',cval)
c      call cipnum(cval, xmax_speed, iflag)
c      if (iflag .ne. 0) then
c        iere = 998
c        return
c      end if
c      call getenv('REDI_EVENT_MIN_SPEED_0',cval)
c      call cipnum(cval, xmin_speed_0, iflag)
c      if (iflag .ne. 0) then
c        iere = 998
c        return
c      end if
c      call getenv('REDI_EVENT_MIN_SPEED_1',cval)
c      call cipnum(cval, xmin_speed_1, iflag)
c      if (iflag .ne. 0) then
c        iere = 998
c        return
c      end if
c
      t1 = dist/xmax_speed
      if (dist .le. 100.) then
        t2 = dist/xmin_speed_0
      else
        t2 = dist/xmin_speed_1
      end if
cccccc
      it1s = int(t1)
      it1t = (t1 - it1s)*ticks_per_sec
      it2s = int(t2)
      it2t = (t2 - it2s)*ticks_per_sec
c
c     compute the bounding times by adding t1 and t2 to org_time
c                                    
      call f_add_time(org_time, it1s, it1t, t1_time)
      call f_add_time(org_time, it2s, it2t, t2_time)
c
c     compare time series begin and end times with this window
c
      td1 = f_tdiff(beg_time, t1_time)
      td2 = f_tdiff(end_time, t2_time)
c
c     call f_int_to_ext(org_time,ext_time)
c     print*, 'Org time: ',ext_time.year, ext_time.doy, ext_time.hour,
c    .         ext_time.minute, ext_time.second, ext_time.ticks
c     call f_int_to_ext(beg_time,ext_time)
c     print*, 'Beg time: ',ext_time.year, ext_time.doy, ext_time.hour,
c    .         ext_time.minute, ext_time.second, ext_time.ticks
c     call f_int_to_ext(t1_time,ext_time)
c     print*, 'T1  time: ',ext_time.year, ext_time.doy, ext_time.hour,
c    .         ext_time.minute, ext_time.second, ext_time.ticks
c     call f_int_to_ext(end_time,ext_time)
c     print*, 'End time: ',ext_time.year, ext_time.doy, ext_time.hour,
c    .         ext_time.minute, ext_time.second, ext_time.ticks
c     call f_int_to_ext(t2_time,ext_time)
c     print*, 'T2  time: ',ext_time.year, ext_time.doy, ext_time.hour,
c    .         ext_time.minute, ext_time.second, ext_time.ticks
c
      if (td1 .gt. 0.d0) then
        iere = 998
        return
      end if
      if (td2 .lt. 0.d0) then
        iere = 999
        return
      end if
c
      return
      end

      complex function response(w,itype)
c
c     resp calculates the actual response curve for a
c       given set of poles and zeros
c
c     the poles and zeros are expected to be stored in the
c       common block instr
c
c     w is circular frequency in rad/sec
c     itype specifies the desired response
c
c     itype = 0: default units
c             1: displacement response
c             2: velocity response
c             3: acceleration response
c
c     assumes the exp(-iwt) transform convention
c
      common /instr/ iunit, ds, gain, npoles, nzeros, poles(60)
c
      integer*4 iunit, npoles, nzeros
      real*4 ds, gain
      complex*8 poles(60)
c
      integer*4 iaction
      real*4 a0
      complex*8 s, t
c
c     decide what to do
c
      if (itype .eq. 0) then
c
c       don't do anything
c
        iaction = 0
c
      else
c
c       figure it out
c
        iaction = iunit - (itype - 1)
c
      end if
c
c     check for zero divide
c
      if ((w .eq. 0.) .and. (iaction .ne. 0))then
        w = .0001
      endif
c
      s = cmplx(0.0,w)
c
c     scale the instrument response by the digitial sensitivity and gain
c
      a0 = ds * gain
      t = cmplx(a0,0.0)
c
      icom = min1(npoles,nzeros)
c
c     loop over common zeros and poles
c
      do ii = 1, icom
        jj = npoles + ii
        t = t * ((s - poles(jj))/(s - poles(ii)))
      end do
c
c     loop over extra poles or zeros
c
      if (npoles .gt. icom) then
        do ii = icom + 1, npoles
          t = t / (s - poles(ii))
        end do
      else
        do ii = icom + 1, nzeros
          jj = npoles + ii
          t = t * (s - poles(jj))
        end do
      end if
c
c     determine type of response
c
      if (iaction .eq. 0) then
        response = t
      else
        response = t * (s)**iaction
      endif
c
c     return
c
      return
      end

      subroutine lfit (nord, ndat, xx, dd, sigma, lsig, mm, ss, chi2)
c
c     subroutine to perform a general linear least squares fit
c     order of fit determined by user
c
c     nord = order (2 = line, etc)
c     ndat = number of points in inversion
c     xx = array of basis function
c     dd = array of data
c     sigma = array of errors
c     lsig = true if the errrors are independent
c     mm = estimated parameters
c     ss = errors
c     chi2 - misfit
c
      parameter (npmax = 65536)
      parameter (ncol = 5)
c
      real*4 xx(*), dd(*), sigma(*), mm(*), ss(*)
      real*4 am(npmax,ncol), u(npmax,ncol), v(ncol,ncol)
      real*4 w(ncol), cov(ncol,ncol)
      real*4 data(npmax), xm(ncol), sum, chi2
c
      logical lsig
c
c     index controls the svd operation
c
      index = 1
c
c     alpha is the ls damping parameter
c
      alpha = 0.0
c
      if (nord .gt. ncol) then
        print*,' parameter ncol exceeded in lfit'
        return
      elseif (ndat .gt. npmax) then
        print*,' parameter npmax exceeded in lfit'
        return
      endif
c
      nfil = ndat
c
c     form the A or design matrix - weighted by the input errors
c
      if (nord .gt. 0) then
        ninv = nord
        do ii = 1, nfil
          s = 1.0/sigma(ii)
          do jj = 1, nord
            am(ii,jj) = s*(xx(ii)**(jj-1))
          end do
          data(ii) = s*dd(ii)
cccc
c         print*, ii, s, am(ii,1), am(ii,2), data(ii)
cccc
        end do 
      else
        ninv = 1
        do ii = 1, nfil
          s = 1.0/sigma(ii)
          am(ii,1) = s*(xx(ii)**(abs(nord)-1))
          data(ii) = s*dd(ii)
        end do
      endif
c
c     compute singular value decomposition 
c
      call svd1(npmax,ncol,nfil,ninv,am,u,v,w,index)
c
c     preform backsubstitution
c
      call inv(npmax,ncol,nfil,ninv,u,v,w,data,xm,alpha,cov)
c
c     evaluate the chi-square
c
      chi2 = 0.0
      if (nord .gt. 0) then
        do ii = 1, nfil
          sum = 0.0
          do jj = 1, ninv
            sum = sum + xm(jj)*(xx(ii)**(jj-1))
          end do
          chi2 = chi2 + ((data(ii) - sum)/sigma(ii))**2
        end do
      else
        do ii = 1, nfil
          ax = xm(1)*(xx(ii)**(abs(nord)-1))
          chi2 = chi2 + ((data(ii) - ax)/sigma(ii))**2
        end do
      end if
c
c     test whether the errors are independent
c
      if (lsig) then 
        do ii = 1, ninv
          ss(ii) = sqrt(cov(ii,ii))
          mm(ii) = xm(ii)
        end do
      else
        scale = sqrt(chi2/(nfil-ninv))
        do ii = 1, ninv
          ss(ii) = sqrt(cov(ii,ii))*scale
          mm(ii) = xm(ii)
        end do
      endif
c
c     all done! - go home!
c
      return
      end

	subroutine coinst2(npts,dt,ind,ind2,c1,cw,np,fl,fh,ierr)
c
c     subroutine for Fourier Domain operations in process_waveform
c
c     input:  
c             npts   - number of points in timeseries
c             dt     - sample spacing in sec
c             ind    - type of instrument operation to perform
c                 1 - Benioff 100 kg
c                 2 - 17s-23s 10 pole Butterworth
c                 3 - Wood Anderson
c                 4 - ULP instrument
c                 5 - SP WWSSN instrument
c                 6 - LP WWSSN instrument
c                 7 - LP HGLP instrument
c                 8 - Nominal STS1 response
c                 9 - Benioff 14kg 
c                10 - ASRO LP response
c                11 - STS2 LP response
c                20 - deconvolve to displacement
c                21 - deconvolve to velocity
c                22 - deconvolve to acceleration
c             ind2  - type of filter operation to perform
c                 1 - apply 6 pole Butterworth bandpass filter between fl and fh
c                 2 - apply 6 pole Butterworth phaseless bandpass filter between fl and fh
c                 3 - apply 6 pole Butterworth lowpass  filter with cutoff fl
c                 4 - apply 6 pole Butterworth phaseless lowpass  filter with cutoff fl
c                 5 - apply 6 pole Butterworth hipass   filter with cutoff fh
c                 6 - apply 6 pole Butterworth phaseless hipass   filter with cutoff fh
c                 7 - apply np pole Butterworth bandpass filter between fl and fh
c             c1    - input and output timeseries
c             cw    - input and output dummy array for storing spectra
c             np    - input number of poles of option 7
c             fl    - input low  freq corner of Butterworth filters (input in Hz)
c             fh    - input high freq corner of Butterworth filters (input in Hz)
c             ierr  - error return code
c
      real*4 c1(*)
c
	real*4 raw
      complex*8 cw(*), aw, rw, response
      complex*8 ben100, lpbptf_b, wood
      complex*8 ulp, wwsp, wwlp
      complex*8 hglp, sts1, ben14, asro, sts2
      complex*8 lobwth, hibwth, bpbwth, butter
c
      integer*4 ipow
c
c     compute useful numbers
c
      include 'numerical.h'
c
      io = 6
c
c     initialize error flag
c
      ierr = 0
c
c     detrend/deman
c
c     call detrend(c1, npts, dt, c1)
c
      call demean(c1, npts)
c
c     taper
c
c     call taper(c1, npts, 10.0)
c
      call taper(c1, npts, 5.0)
c
c     compute the number of points
c
c      Seistool option
c        n2 = ipow(npts)
c
       n2 = ipow(npts*2)
c
c     frequency increment & number of frequency samples
c
      dw = tpi / (float(n2) * dt)
      nt2h = (n2 + 2) / 2
c
c     zero excess points
c
      do ii = npts + 1,  n2
        c1(ii) = 0.0
      end do
c
c     forward transform
c
      ierr = 0
      call fftl (c1, n2, -1, dt, ierr)
      if (ierr .ne. 0) then
        ierr = 2
        write(io,*) 'Error in forward transform'
        return
      endif
c
c     form complex array
c
      do ii = 1, nt2h
        jj = 2*(ii - 1) + 1
        cw(ii) = cmplx(c1(jj),c1(jj+1))
      end do
c
c     Perform instrument operations
c
      itype = 1
      if (ind .eq. 0) then
c       write(io,*) 'No Instrument operations'
      elseif (ind .eq. 1) then
c
c      convolve with the Benioff 100kg response
c
        cw(1) = (0.0,0.0)
        do ii = 2, nt2h
          f = float(ii - 1)*dw
          rw = response(f, itype)
          aw = ben100(f)    
          cw(ii) = cw(ii) * (aw/rw)
        end do
      elseif (ind .eq. 2) then
c 
c      convolve with a 20 s filter
c 
        cw(1) = (0.0,0.0)
        do ii = 2, nt2h 
          f = float(ii - 1)*dw
          rw = response(f, itype)
          aw = lpbptf_b(f)
          cw(ii) = cw(ii)*(aw/rw)
        end do
      elseif (ind .eq. 3) then
c 
c      convolve with the Wood Anderson response
c 
        cw(1) = (0.0,0.0)
        do ii = 2, nt2h 
          f = float(ii - 1)*dw
          rw = response(f, itype)
          aw = wood(f)    
          cw(ii) = cw(ii)*(aw/rw)
        end do
      elseif (ind .eq. 4) then
c
c      convolve with the ULP response
c
        cw(1) = (0.0,0.0)
        do ii = 2, nt2h
          f = float(ii - 1)*dw
          rw = response(f, itype)
          aw = ulp(f)
          cw(ii) = cw(ii)*(aw/rw)
        end do
      elseif (ind .eq. 5) then
c
c      convolve with the SP WWSSN response
c
        cw(1) = (0.0,0.0)
        do ii = 2, nt2h
          f = float(ii - 1)*dw
          rw = response(f, itype)
          aw = wwsp(f)
          cw(ii) = cw(ii)*(aw/rw)
        end do
      elseif (ind .eq. 6) then
c
c      convolve with the LP WWSSN response
c
        cw(1) = (0.0,0.0)
        do ii = 2, nt2h
          f = float(ii - 1)*dw
          rw = response(f, itype)
          aw = wwlp(f)
          cw(ii) = cw(ii)*(aw/rw)
        end do
      elseif (ind .eq. 7) then
c
c      convolve with the LP HGLP response
c
        cw(1) = (0.0,0.0)
        do ii = 2, nt2h
          f = float(ii - 1)*dw
          rw = response(f, itype)
          aw = hglp(f)
          cw(ii) = cw(ii)*(aw/rw)
        end do
      elseif (ind .eq. 8) then
c
c      convolve with the nominal STS1 response
c
        cw(1) = (0.0,0.0)
        do ii = 2, nt2h
          f = float(ii - 1)*dw
          rw = response(f, itype)
          aw = sts1(f)
          cw(ii) = cw(ii)*(aw/rw)
        end do
      elseif (ind .eq. 9) then
c
c      convolve with a Benioff 14 kg
c
        cw(1) = (0.0,0.0) 
        do ii = 2, nt2h 
          f = float(ii - 1)*dw 
          rw = response(f, itype) 
          aw = ben14(f)    
          cw(ii) = cw(ii)*(aw/rw) 
        end do 
      elseif (ind .eq. 10) then
c          
c      convolve with a ASRO LP response
c
        cw(1) = (0.0,0.0)
        do ii = 2, nt2h
          f = float(ii - 1)*dw
          rw = response(f, itype)
          aw = asro(f)
          cw(ii) = cw(ii)*(aw/rw)
        end do
      elseif (ind .eq. 11) then
c
c      convolve with a STS2 LP response
c
        cw(1) = (0.0,0.0)
        do ii = 2, nt2h
          f = float(ii - 1)*dw
          rw = response(f, itype)
          aw = sts2(f)
          cw(ii) = cw(ii)*(aw/rw)
        end do
      elseif (ind .gt. 11 .and. ind .lt. 20) then
        write(io,*) 'Non-existent response'
        ierr = 1
        return
c
c     remove the instrument only - no reconvolution
c
      elseif (ind .eq. 20) then
c
c      remove instrument to displacement
c
        itype = 1
        cw(1) = (0.0,0.0)
        do ii = 2, nt2h
          f = float(ii - 1)*dw
          rw = response(f, itype)
          cw(ii) = cw(ii) / rw
        end do
      elseif (ind .eq. 21) then 
c 
c      remove instrument to velocity
c 
        itype = 2 
        cw(1) = (0.0,0.0) 
        do ii = 2, nt2h 
          f = float(ii - 1)*dw 
          rw = response(f, itype) 
          cw(ii) = cw(ii) / rw 
        end do 
      elseif (ind .eq. 22) then 
c 
c      remove instrument to acceleration
c 
        itype = 3 
        cw(1) = (0.0,0.0) 
        do ii = 2, nt2h 
          f = float(ii - 1)*dw 
          rw = response(f, itype) 
          cw(ii) = cw(ii) / rw 
        end do 
      elseif (ind .ge. 23) then
        write(io,*) 'Unknown option'
        ierr = 1
        return
      end if
c
c     Check for filter operations
c
      wl = fl*tpi
      wh = fh*tpi
      if (ind2 .eq. 0) then
c       write(io,*) 'No filtering'
      elseif (ind2 .eq. 1) then
c
c     apply a 6 pole bandpass Butterworth filter
c
        do ii = 1, nt2h
          f = float(ii - 1)*dw
          cw(ii) = cw(ii)*bpbwth(f, wl, wh)
        end do
      elseif (ind2 .eq. 2) then
c
c     apply a 6 pole bandpass phaseless Butterworth filter
c
        do ii = 1, nt2h
          f = float(ii - 1)*dw
          aw = bpbwth (f, wl, wh)
          raw = aw * conjg(aw)
          cw(ii) = cw(ii)*sqrt(raw)
        end do
      elseif (ind2 .eq. 3) then
c
c     apply a 6 pole lowpass Butterworth filter
c
        do ii = 1, nt2h
          f = float(ii - 1)*dw
          cw(ii) = cw(ii)*lobwth(f, wl)
        end do
      elseif (ind2 .eq. 4) then
c
c     apply a 6 pole lowpass phaseless Butterworth filter
c
        do ii = 1, nt2h  
          f = float(ii - 1)*dw
          aw = lobwth (f, wl)
          raw = aw * conjg(aw)
          cw(ii) = cw(ii)*sqrt(raw)
        end do    
      elseif (ind2 .eq. 5) then
c
c     apply a 6 pole hipass Butterworth filter
c
        do ii = 1, nt2h
          f = float(ii - 1)*dw
          cw(ii) = cw(ii)*hibwth(f, wh)
        end do
      elseif (ind2 .eq. 6) then  
c
c     apply a 6 pole hipass phaseless Butterworth filter
c
        do ii = 1, nt2h
          f = float(ii - 1)*dw
          aw = hibwth (f, wh)
          raw = aw * conjg(aw)
          cw(ii) = cw(ii)*sqrt(raw)
        end do
      elseif (ind2 .eq. 7) then
c
c     apply a np pole bandpass Butterworth filter
c
        do ii = 1, nt2h
          f = float(ii - 1)*dw
          cw(ii) = cw(ii)*butter(f,wl,wh,np)
        end do
c
      elseif (ind2 .ge. 8) then
        write(io,*) 'Unknown option'
        ierr = 1
        return
      end if
c
c     reform the complex array into a real
c
      do ii = 1, nt2h 
        jj = 2*(ii - 1) + 1 
        c1(jj) = real(cw(ii))
        c1(jj+1) = aimag(cw(ii))
      end do 
c
c     inverse transform filtered function
c
      ierr = 0
      call fftl (c1, n2, -2, dt, ierr)
      if (ierr .ne. 0) then
        ierr = 2
        write(io,*) 'Error in forward transform'
        return
      endif
c
c     all done
c
      return
      end
c

      SUBROUTINE TAPER(A,LEN,PER)
C
C  TAPER INPUT SERIES WITH A PER% COS**2 TAPER
C  PER=100 IS A FULL TAPER
C
      real*4 PER
      real*4 A(*)
c
      FL=FLOAT(LEN)
      FP=PER*.005
      FLS=FP*FL
      FLM=FL-FLS
      DO 1 I=1,LEN
    1 A(I)=A(I)*BPCOS(FLOAT(I),0.,FLS,FLM,FL)
      a(1) = 0.0
      a(len) = 0.0
      RETURN
      END

	subroutine find_azm(i0,i1,npa,azx,aaox,azm,seazm,aaoim,seaaoim)
c
c ...... calculate az and aoi of phase onset
c ...... based on a Bob program
c
c
	real*4 azx(*),aaox(*)
	real*4 az(1000),aaoi(1000)
c
	npa= i1 - (i0 + 1) + 1
	npa2=npa/2
c
      do ii = 1, npa
        kk = i0 + 1 + ii - 1
        az(ii) = azx(kk)
        aaoi(ii) = aaox(kk)
      end do
c
c ...... find median and quartile limits for az & aaoi
c
	do 4 i=1,npa-1
	  do 3 j=i+1,npa
	    if(az(j).lt.az(i)) then
	      azt=az(i)
	      az(i)=az(j)
	      az(j)=azt
	    endif
	    if(aaoi(j).lt.aaoi(i)) then
	      aaoit=aaoi(i)
	      aaoi(i)=aaoi(j)
	      aaoi(j)=aaoit
	    endif
    3   continue
    4 continue
c
	npa2=npa/2
	if(npa2.lt.1) npa2=1
	azm=az(npa2)
	if(azm.lt.0.) then
	  azm=azm+360.
	elseif(azm.gt.360.) then
	  azm=azm-360.
	endif
	aaoim=aaoi(npa2)
	if(npa.ge.4) then
	  npa1=npa/4
	  npa3=(3*npa)/4
	  seazm=(az(npa3)-az(npa1))/2.
	  seazm=abs(seazm)
	  seaaoim=(aaoi(npa3)-aaoi(npa1))/2.
	  seaaoim=abs(seaaoim)
	endif
c
	return
	end

      subroutine save_to_ascii(head,d1,io_save,file_save,iere)
c
c     include files for header and time
c
      include '/usr/local/include/qlib2.inc'
      record /EXT_TIME/ t2_time
      include 'station_hdr.inc'
c
      real*4 d1(*), dt
      integer*4 io_save, iere
      character*(*) file_save
c
      iere = 0
c
c     open output file
c
      open(io_save,file=file_save,access='append')
      call f_int_to_ext(head.begtime,t2_time)
      a0 = 0.0
      do ii = 1, head.num_pts
        if (abs(d1(ii)) .gt. a0) then
          a0 = d1(ii)
        end if
      end do
c
c     write header
c
      dt  = 1.0/head.sample_rate
      write(io_save,100) head.station_id, head.channel_id, 
     .  head.network_id,
     .  dt, head.num_pts, head.azi, head.dip, a0,
     .  t2_time.year, t2_time.doy, t2_time.hour,
     .  t2_time.minute, t2_time.second, 
     .  int(t2_time.usec/usecs_per_tick),
     .  head.desc
c
c     write data
c
      do ii = 1, head.num_pts
        write(io_save,200) ii, d1(ii)/a0
      end do
c
c     close the file
c
      close(io_save)
c
c     format statements
c
100   format(a4,1x,a3,1x,a2,1x,
     .  f5.3,1x,i6,1x,f4.0,1x,f4.0,1x,e12.5,1x,
     .  i4,1x,i3,1x,i2,1x,i2,1x,i2,1x,i5,
     .  1x, a32)
200   format(i6,1x,f12.5)
c
c     all done
c
      return
      end

      subroutine ciptok( typbuf,ibp,token )
c
c   purpose:
c      To take a typed in string of characters and break it
c      up into smaller strings called tokens. Tokens are
c      fields delimited by blanks or commas. Multiple or
c      redundant blanks are treated as one blank however
c      two successive commas will result in a blank token
c      being returned to the calling program whether are not
c      there are blanks in between them.
c
c   args:
c      typbuf      buffer containing the string to be parsed
c      ibp         buffer pointer ( 0 or -> delimiter )
c      token       token found ( or eoi for end of input )
c
c   versions and revisions:
c      for UNIVAC R.Goff Sept. 1981
c      for VAX/UNIX R.Goff Dec. 1981
c
      character*(*) typbuf,token
      character*1 olddel
c
c   see that buffer pointer is in bounds
c
      l  =  len( typbuf )
      if( ibp .lt. 0 ) then
        ibp  =  0
        token  =  ' '
        return
      end if
      if( ibp .ge. l ) then
        ibp  =  l
        token  =  'eoi'
        return
      end if
c
c   pick up old delimiter
c
      olddel  =  ' '
      if( ibp .gt. 0 ) olddel  =  typbuf( ibp:ibp )
c
c   skip white space
c
100   ibp  =  ibp + 1
      if( typbuf(ibp:ibp) .ne. ' ' ) go to 200
      if( ibp .lt. l ) go to 100
c
c   end of buffer - token = 'eoi'
c
150   token  =  'eoi'
      return
c
c   check for two commas
c
200   if( typbuf(ibp:ibp) .ne. ',' ) go to 300
      if( olddel .eq. ',' ) then
        token  =  ' '
        return
      end if
      olddel  =  ','
      if( ibp .ge. l ) go to 150
      go to 100
c
c   copy token to output
c
300   ist  =  ibp
400   ibp  =  ibp + 1
      if( typbuf(ibp:ibp) .eq. ' ' ) go to 500
      if( typbuf(ibp:ibp) .eq. ',' ) go to 500
      if( ibp .lt. l ) go to 400
      token  =  typbuf( ist:l )
      return
500   token  =  typbuf( ist:ibp-1 )
      return
      end

	subroutine extra_window(head,id1,t1_time,t2_time,ierr)
c
c     subroutine to check window length
c
c     input:  
c             head    - station/channel header
c             id1      - data array
c             t1_time - desired start time
c             t2_time - desired end time
c     output:  
c             ierr   - error return code
c                      998 if window begins too late
c                      999 if window ends too early
c                      0 otherwise
c
      include '/usr/local/include/qlib2.inc'
      include 'station_hdr.inc'
c
      record /INT_TIME/ beg_time, end_time, t1_time, t2_time
      record /EXT_TIME/ ext_time
c
      integer*4 ierr, npts
      integer*4 id1(*)
      real*4 dt
      real*8 td1, td2
c
c     initialize error return
c
      ierr = 0
c
      npts  = head.num_pts
      dt  = 1.0/head.sample_rate
      beg_time = head.begtime
      end_time = head.endtime
c
c     assume that t2 is later than t1
c
      td1 = f_tdiff(t1_time,beg_time)
      if (td1 .lt. 0.d0) then
        ierr = 998
        return
      end if
      td2 = f_tdiff(end_time, t2_time)
      if (td2 .lt. 0.d0) then
        ierr = 999
        return
      end if
c
c     data brackets the desired time window
c
      td2 = f_tdiff(t2_time,beg_time)
c
      t1 = td1/usecs_per_sec
      t2 = td2/usecs_per_sec
      n1 = int(t1/dt) + 1
      n2 = int(t2/dt) + 1
c
      kk = 0
      do jj = n1, n2
        kk = kk + 1
        id1(kk) = id1(jj)
      end do
c
      head.begtime = t1_time
      head.endtime = t2_time
      head.num_pts = kk
c
c     all done
c
      return
      end

      COMPLEX FUNCTION HIBWTH(W,W0)
C
C $$$$$ CALLS ONLY LIBRARY ROUTINES $$$$$
C
C   HIBWTH RETURNS THE COMPLEX FORWARD TRANSFER FUNCTION OF A SIX POLE
C   BUTTERWORTH FILTER AS A FUNCTION OF ANGULAR FREQUENCY W.  THIS
C   FILTER IS A HIGH PASS WITH A CORNER AT W0 AND A ROLLOFF OF ABOUT
C   36 DB/OCTAVE.  A FOURIER TRANSFORM CONVENTION OF
C   F(W) = INT F(T)*EXP(-IWT)*DT IS ASSUMED.
C
C                                                     -ALL
      COMPLEX S
      DATA A1,A2,A3/3.863703305,7.464101615,9.141620173/
      W=AMAX1(1.E-2,W)
      S=CMPLX(0.,W/W0)
      S=1./S
      S=S*(A1+S*(A2+S*(A3+S*(A2+S*(A1+S)))))+1
      HIBWTH=1./S
      RETURN
      END

      complex function butter(f,fl,fh,npole)
c
c ...... bandpass filter  (nPBP Butterworth Filter)
c
c        convolve with npole Butterworth Bandpass filter
c
c        stolen from Seisgram - 10/28/92
c        - 6 pole output compared with subroutine bpbw
c          Pretty good, although slight differences exist
c
c        where -
c          f     - frequency of evaluation in rad/s
c          fl    - low frequency corner in rad/s
c          fh    - high frequency corner in rad/s
c          npole - number of poles in filter at each corner
c                  (not more than 20)
c
      integer*4 npole
      complex*8 sph(20),spl(20)
      complex*8 c0, c1,cjw
      complex*8 cph,cpl
c
c     include some useful stuff
c
      pi = 4.*atan(1.0)
c
      nop = npole-2*(npole/2)
      nepp = npole/2
      c0 = cmplx(0.,0.)
      c1 = cmplx(1.,0.)
      w = f
      wch = fh
      wcl = fl
      np = 0
      if (w .eq. 0.0) then
        butter = c0
        return
      end if
      if (nop.gt.0) then
        np = np+1
        sph(np) = c1
      endif
      if (nepp.gt.0) then
        do i = 1, nepp
          ak = 2.*sin((2.*float(i)-1.)*pi/(2.*float(npole)))
          ar = 0.5*ak*wch
          ai = 0.5*wch*sqrt(4.-ak*ak)
          np = np+1
          sph(np) = cmplx(-ar,-ai)
          np = np+1
          sph(np) = cmplx(-ar,+ai)
        end do
      endif
      np = 0
      if (nop.gt.0) then
        np = np+1
        spl(np) = c1
      endif
      if (nepp.gt.0) then
        do i = 1, npole/2
          ak = 2.*sin((2.*float(i)-1.)*pi/(2.*float(npole)))
          ar = 0.5*ak*wcl
          ai = 0.5*wcl*sqrt(4.-ak*ak)
          np = np+1
          spl(np) = cmplx(-ar,-ai)
          np = np+1
          spl(np) = cmplx(-ar,+ai)
        end do
      endif
      cjw = cmplx(0.,-w)
      cph = c1
      cpl = c1
      do j = 1, npole
        cph = cph*sph(j)/(sph(j)+cjw)
        cpl = cpl*cjw/(spl(j)+cjw)
      end do
      butter = cph*cpl
c
      return
      end

      subroutine inv(npmax,ncol,nfil,ninv,u,v,w,d,x,alpha,cov)
c
c     performs backsubstitution, given svd decomposition
c
c     single precision version
c
      parameter (ncolm=550)
c
      real*4 u(npmax,ncol), v(ncol,ncol), w(ncol)
      real*4 cov(ncol,ncol)
      real*4 d(npmax), x(ncol)
      real*4 wmax, wmin, s, alpha
      real*4 w2(ncolm), temp(ncolm)
c
c     check array bounds
c
      if (ncol .gt. ncolm) then
        print*,' array bound ncolm exceeded in inv'
      end if
c
c     zero the x and temp arrays for good measure
c
      do i = 1, ncol
        x(i) = 0.0
        temp(i) = 0.0
      end do
c
c     set threshold for smallest eigenvalues
c
      wmax = 0.0
      do j = 1, ninv
        if (w(j) .gt. wmax) then 
          wmax = w(j)
        endif
      end do
      wmin = wmax*1.0e-5
      do j = 1, ninv
        if (w(j) .lt. wmin) then 
          print*,' zeroing a column # ',j,w(j)
          w(j) = 0.0
        endif
      end do
c
c     perform back substitution
c
      do j = 1, ninv
        s = 0.0
        if (w(j) .ne. 0.0) then
          do i = 1, nfil
            s = s + u(i,j)*d(i)
          end do
          s = s*(w(j)/(w(j)**2 + alpha))
        endif
        temp(j) = s
      end do
      do j = 1, ninv
        s = 0.0
        do jj = 1, ninv
          s = s + v(j,jj)*temp(jj)
        end do
        x(j) = s 
      end do
c       
c     estimate the variance associated with this model
c
c     form the square of the singular values
c
      do j = 1, ninv
        w2(j) = 0.d0
        if ((w(j) + alpha) .ne. 0.0) then
          s = w(j)**2
          w2(j) = s / (s + alpha)**2
        endif
      end do
c
c     now form the variance matrix
c
      do ii = 1, ninv
        do jj = 1, ii
          s = 0.0
          do kk = 1, ninv
            s = s + v(ii,kk)*v(jj,kk)*w2(kk)
          end do
          cov(ii,jj) = s
          cov(jj,ii) = s
        end do
      end do
c
      return
      end

	subroutine sdr_read(file,maxp,data,head,iere)
c
	implicit none
 	include "/usr/local/include/qlib2.inc"
c structure for output header
	include 'station_hdr.inc'

	character*(*) file
	integer data(*)
	integer maxp
	integer iere

	integer kfile, icode, io

	double precision THRESHOLD
	parameter (THRESHOLD = .5)

	record /DATA_HDR/ hdr, hdr1
	record /INT_TIME/ endtime
	record /EXT_TIME/ et1, et2
	integer fp, nreq, nread, n, date_fmt, i
	integer seconds, usecs, islew
	double precision slew, thresh

c external functions and subroutines
	integer iargc
	external getarg, iargc
	integer lnblnk
	external lnblnk 
c functions in most fortran libraries.
	double precision tslew
	external tslew
c functions in library fio.
	integer ifopen, ifclose
	external ifopen, ifclose

c initialize
      iere = 0
	io = 6

c determine length of file name
	kfile = lnblnk(file)
	
c open file
	fp = ifopen (file, "r")
	if (fp .lt. 0) then
		write(io,*) "Error opening file", file(1:kfile)
                icode = ifclose(fp)
		iere = 1000
		return
	endif

c set number of requested data points.
c NOTE -- buffer must be large enough to handle this many points.
	nreq = maxp

c read first block, and establish station, channel and timing thresholds.
	date_fmt = 0
	slew = 0
	nread = 0
	n = f_read_ms (hdr, data(nread+1), nreq, fp)
	if (n .gt. 0) then
		call f_copy_data_hdr (hdr1, hdr)
		call f_time_interval2 (1, hdr.sample_rate, 
     1			hdr.sample_rate_mult, seconds, usecs)
		thresh = (seconds * USECS_PER_SEC + usecs) * THRESHOLD
	else
		write(io,*) "Error reading first block ",file(1:kfile)
                icode = ifclose(fp)
		iere = 999
		return
	endif

c update number of points remaining and continue read more blocks.
c check to ensure the data stream is for the came station and channel,
c and check for time tears.
	do while ((n .gt. 0))
	    nread = nread + n
	    nreq = nreq - n
	    if (nreq .gt. 0) then
		call f_delete_blockette (hdr, -1)
		n = f_read_ms (hdr, data(nread+1), nreq, fp)
		if (n .gt. 0) then
		    if (hdr1.station_id .ne. hdr.station_id .or.
     1			hdr1.network_id .ne. hdr.network_id .or.
     2			hdr1.channel_id .ne. hdr.channel_id) then
			write (io,*) "Data block for wrong channel ",
     1				file(1:kfile)
			iere = 997
			goto 100
		    endif
		    slew = tslew(hdr1.begtime, hdr.begtime, nread,
     1			hdr.sample_rate, hdr.sample_rate_mult)
		    if (abs(slew) .gt. thresh) then
			write (io,*) "Unacceptable time slew ",file(1:kfile)
			write (io,120) nread, slew, thresh
			iere = 998
			goto 100
		    endif
		endif
	    else
		n = 0
	    endif
	end do


c we are finished reading data. check for error reading data.
100	if (n .lt. -1) then
		write(io,*) "Error reading file", file(1:kfile)
		iere = 999
	endif
	
c output data points.
c convert times to printable forms.
c as an example, convert times to strings and to ext_time.
c	call f_int_to_ext(hdr1.begtime, et1)
c	call f_time_to_str(hdr1.begtime, date_fmt, s1)

c compute ending time (eg expected time of next data point).
	call f_time_interval2 (nread, hdr.sample_rate, 
     1		hdr.sample_rate_mult, seconds, usecs)
	call f_add_time(hdr1.begtime, seconds, usecs, endtime)
	call f_int_to_ext(endtime, et2)
c	call f_time_to_str(endtime, date_fmt, s2)

c output header and data
	islew = slew

c put header together for return
      head.station_id = hdr1.station_id
      head.channel_id = hdr1.channel_id
      head.network_id = hdr1.network_id
      head.begtime = hdr1.begtime
      head.endtime = endtime
      head.num_pts = nread
      head.sample_rate = hdr1.sample_rate
      head.slew = slew
      head.thresh = thresh

c error checking
c	write (*,*) "station ", 
c     1		hdr1.station_id(1:lnblnk(hdr1.station_id)),
c     2		" channel ",
c     3		hdr1.channel_id(1:lnblnk(hdr1.channel_id)),
c     4		" time ", s1(1:lnblnk(s1)),
c     5		" points ", nread, " slew ", islew
c	do i = 1, nread
c		write (*,*) data(i)
c	end do

	call f_delete_blockette (hdr, -1)
	call f_delete_blockette (hdr1, -1)
	i = ifclose (fp)
120	format("Time error after ", i, " points -- slew ",f6.0, " gt", f4.0)
	end
c
c function to compute the total time slew from the beginning of data
c
	double precision function tslew (begtime, newtime, npts, rate, mult)
	implicit none
 	include "/usr/local/include/qlib2.inc"
	record /INT_TIME/ begtime, newtime
	integer npts, rate, mult
	double precision f_tdiff
	record /INT_TIME/ exptime
	integer seconds, usecs

	call f_time_interval2 (npts, rate, mult, seconds, usecs)
	call f_add_time(begtime, seconds, usecs, exptime)
	tslew = f_tdiff(newtime, exptime)
	return
	end

      SUBROUTINE FFT(A,B,NTOT,N,NSPAN,ISN,IERR)
C    FFT IS A SINGLE PRECISION VERSION OF SINGLETON'S FFT
C    PROCEDURE. ALL INTEGERS ARE 32 BITS. ALL FLOATING POINT
C    VARIABLES ARE 32 BITS. FFT IS INTENDED FOR USE ON THE
C    apollo AT SIO.
C  MULTIVARIATE COMPLEX FOURIER TRANSFORM, COMPUTED IN PLACE
C    USING MIXED-RADIX FAST FOURIER TRANSFORM ALGORITHM.
C  BY R. C. SINGLETON, STANFORD RESEARCH INSTITUTE, SEPT. 1968
C  ARRAYS A AND B ORIGINALLY HOLD THE REAL AND IMAGINARY
C    COMPONENTS OF THE DATA, AND RETURN THE REAL AND
C    IMAGINARY COMPONENTS OF THE RESULTING FOURIER COEFFICIENTS.
C  MULTIVARIATE DATA IS INDEXED ACCORDING TO THE FORTRAN
C    ARRAY ELEMENT SUCCESSOR FUNCTION, WITHOUT LIMIT
C    ON THE NUMBER OF IMPLIED MULTIPLE SUBSCRIPTS.
C    THE SUBROUTINE IS CALLED ONCE FOR EACH VARIATE.
C    THE CALLS FOR A MULTIVARIATE TRANSFORM MAY BE IN ANY ORDER.
C  NTOT IS THE TOTAL NUMBER OF COMPLEX DATA VALUES.
C  N IS THE DIMENSION OF THE CURRENT VARIABLE.
C  NSPAN/N IS THE SPACING OF CONSECUTIVE DATA VALUES
C    WHILE INDEXING THE CURRENT VARIABLE.
C  THE INTEGER IERR IS AN ERROR RETURN INDICATOR. IT IS NORMALLY ZERO, BUT IS
C  SET TO 1 IF THE NUMBER OF TERMS CANNOT BE FACTORED IN THE SPACE AVAILABLE. IF
C  IT IS PERMISSIBLE THE APPROPRIATE ACTION AT THIS STAGE IS TO  ENTER FFT
C  AGAIN AFTER HAVING REDUCED THE LENGTH OF THE SERIES BY ONE TERM
C  THE SIGN OF ISN DETERMINES THE SIGN OF THE COMPLEX
C    EXPONENTIAL, AND THE MAGNITUDE OF ISN IS NORMALLY ONE.
C  A TRI-VARIATE TRANSFORM WITH A(N1,N2,N3), B(N1,N2,N3)
C    IS COMPUTED BY
C      CALL FFT(A,B,N1*N2*N3,N1,N1,1)
C      CALL FFT(A,B,N1*N2*N3,N2,N1*N2,1)
C      CALL FFT(A,B,N1*N2*N3,N3,N1*N2*N3,1)
C  FOR A SINGLE-VARIATE TRANSFORM,
C    NTOT = N = NSPAN = (NUMBER OF COMPLEX DATA VALUES), E.G.
C      CALL FFT(A,B,N,N,N,1)
C  WITH MOST FORTRAN COMPILERS THE DATA CAN ALTERNATIVELY BE
C    STORED IN A SINGLE COMPLEX ARRAY A, THEN THE MAGNITUDE OF ISN
C    CHANGED TO TWO TO GIVE THE CORRECT INDEXING INCREMENT AND A(2)
C    USED TO PASS THE INITIAL ADDRESS FOR THE SEQUENCE OF IMAGINARY
C    VALUES, E.G.
C      CALL FFT(A,A(2),NTOT,N,NSPAN,2)
C  ARRAYS AT(MAXF), CK(MAXF), BT(MAXF), SK(MAXF), AND NP(MAXP)
C    ARE USED FOR TEMPORARY STORAGE.  IF THE AVAILABLE STORAGE
C    IS INSUFFICIENT, THE PROGRAM IS TERMINATED BY THE ERROR RETURN OPTION
C    MAXF MUST BE .GE. THE MAXIMUM PRIME FACTOR OF N.
C    MAXP MUST BE .GT. THE NUMBER OF PRIME FACTORS OF N.
C    IN ADDITION, IF THE SQUARE-FREE PORTION K OF N HAS TWO OR
C    MORE PRIME FACTORS, THEN MAXP MUST BE .GE. K-1.
C  ARRAY STORAGE IN NFAC FOR A MAXIMUM OF 11 PRIME FACTORS OF N.
C  IF N HAS MORE THAN ONE SQUARE-FREE FACTOR, THE PRODUCT OF THE
C    SQUARE-FREE FACTORS MUST BE .LE. 210.  (2**5*7=210)
      IMPLICIT INTEGER*4(I-N)
c     DIMENSION A(1),B(1)
      DIMENSION A(*),B(*)
      DIMENSION NFAC(11),NP(209)
C  ARRAY STORAGE FOR MAXIMUM PRIME FACTOR OF 23
      DIMENSION AT(23),CK(23),BT(23),SK(23)
      EQUIVALENCE (I,II)
C  THE FOLLOWING TWO CONSTANTS SHOULD AGREE WITH THE ARRAY DIMENSIONS.
      MAXF=23
      MAXP=209
      IERR=0
      IF(N .LT. 2) RETURN
      INC=ISN
      C72=0.30901699437494
      S72=0.95105651629515
      S120=0.86602540378443
      RAD=6.2831853071796
      IF(ISN .GE. 0) GO TO 10
      S72=-S72
      S120=-S120
      RAD=-RAD
      INC=-INC
   10 NT=INC*NTOT
      KS=INC*NSPAN
      KSPAN=KS
      NN=NT-INC
      JC=KS/N
      RADF=RAD*(JC*0.5)
      I=0
      JF=0
C  DETERMINE THE FACTORS OF N
      M=0
      K=N
      GO TO 20
   15 M=M+1
      NFAC(M)=4
      K=K/16
   20 IF(K-(K/16)*16 .EQ. 0) GO TO 15
      J=3
      JJ=9
      GO TO 30
   25 M=M+1
      NFAC(M)=J
      K=K/JJ
   30 IF(MOD(K,JJ) .EQ. 0) GO TO 25
      J=J+2
      JJ=J**2
      IF(JJ .LE. K) GO TO 30
      IF(K .GT. 4) GO TO 40
      KT=M
      NFAC(M+1)=K
      IF(K .NE. 1) M=M+1
      GO TO 80
   40 IF(K-(K/4)*4 .NE. 0) GO TO 50
      M=M+1
      NFAC(M)=2
      K=K/4
   50 KT=M
      J=2
   60 IF(MOD(K,J) .NE. 0) GO TO 70
      M=M+1
      NFAC(M)=J
      K=K/J
   70 J=((J+1)/2)*2+1
      IF(J .LE. K) GO TO 60
   80 IF(KT .EQ. 0) GO TO 100
      J=KT
   90 M=M+1
      NFAC(M)=NFAC(J)
      J=J-1
      IF(J .NE. 0) GO TO 90
C  COMPUTE FOURIER TRANSFORM
  100 SD=RADF/(KSPAN)
      CD=2.*SIN(SD)**2
      SD=SIN(SD+SD)
      KK=1
      I=I+1
      IF(NFAC(I) .NE. 2) GO TO 400
C  TRANSFORM FOR FACTOR OF 2 (INCLUDING ROTATION FACTOR)
      KSPAN=KSPAN/2
      K1=KSPAN+2
  210 K2=KK+KSPAN
      AK=A(K2)
      BK=B(K2)
      A(K2)=A(KK)-AK
      B(K2)=B(KK)-BK
      A(KK)=A(KK)+AK
      B(KK)=B(KK)+BK
      KK=K2+KSPAN
      IF(KK .LE. NN) GO TO 210
      KK=KK-NN
      IF(KK .LE. JC) GO TO 210
      IF(KK .GT. KSPAN) GO TO 800
  220 C1=1.-CD
      S1=SD
  230 K2=KK+KSPAN
      AK=A(KK)-A(K2)
      BK=B(KK)-B(K2)
      A(KK)=A(KK)+A(K2)
      B(KK)=B(KK)+B(K2)
      A(K2)=C1*AK-S1*BK
      B(K2)=S1*AK+C1*BK
      KK=K2+KSPAN
      IF(KK .LT. NT) GO TO 230
      K2=KK-NT
      C1=-C1
      KK=K1-K2
      IF(KK .GT. K2) GO TO 230
      AK=CD*C1+SD*S1
      S1=(SD*C1-CD*S1)+S1
      C1=C1-AK
      KK=KK+JC
      IF(KK .LT. K2) GO TO 230
      K1=K1+INC+INC
      KK=(K1-KSPAN)/2+JC
      IF(KK .LE. JC+JC) GO TO 220
      GO TO 100
C  TRANSFORM FOR FACTOR OF 3 (OPTIONAL CODE)
  320 K1=KK+KSPAN
      K2=K1+KSPAN
      AK=A(KK)
      BK=B(KK)
      AJ=A(K1)+A(K2)
      BJ=B(K1)+B(K2)
      A(KK)=AK+AJ
      B(KK)=BK+BJ
      AK=-0.5*AJ+AK
      BK=-0.5*BJ+BK
      AJ=(A(K1)-A(K2))*S120
      BJ=(B(K1)-B(K2))*S120
      A(K1)=AK-BJ
      B(K1)=BK+AJ
      A(K2)=AK+BJ
      B(K2)=BK-AJ
      KK=K2+KSPAN
      IF(KK .LT. NN) GO TO 320
      KK=KK-NN
      IF(KK .LE. KSPAN) GO TO 320
      GO TO 700
C  TRANSFORM FOR FACTOR OF 4
  400 IF(NFAC(I) .NE. 4) GO TO 600
      KSPNN=KSPAN
      KSPAN=KSPAN/4
  410 C1=1.
      S1=0
  420 K1=KK+KSPAN
      K2=K1+KSPAN
      K3=K2+KSPAN
      AKP=A(KK)+A(K2)
      AKM=A(KK)-A(K2)
      AJP=A(K1)+A(K3)
      AJM=A(K1)-A(K3)
      A(KK)=AKP+AJP
      AJP=AKP-AJP
      BKP=B(KK)+B(K2)
      BKM=B(KK)-B(K2)
      BJP=B(K1)+B(K3)
      BJM=B(K1)-B(K3)
      B(KK)=BKP+BJP
      BJP=BKP-BJP
      IF(ISN .LT. 0) GO TO 450
      AKP=AKM-BJM
      AKM=AKM+BJM
      BKP=BKM+AJM
      BKM=BKM-AJM
      IF(S1 .EQ. 0) GO TO 460
  430 A(K1)=AKP*C1-BKP*S1
      B(K1)=AKP*S1+BKP*C1
      A(K2)=AJP*C2-BJP*S2
      B(K2)=AJP*S2+BJP*C2
      A(K3)=AKM*C3-BKM*S3
      B(K3)=AKM*S3+BKM*C3
      KK=K3+KSPAN
      IF(KK .LE. NT) GO TO 420
  440 C2=CD*C1+SD*S1
      S1=(SD*C1-CD*S1)+S1
      C1=C1-C2
      C2=C1**2-S1**2
      S2=2.*C1*S1
      C3=C2*C1-S2*S1
      S3=C2*S1+S2*C1
      KK=KK-NT+JC
      IF(KK .LE. KSPAN) GO TO 420
      KK=KK-KSPAN+INC
      IF(KK .LE. JC) GO TO 410
      IF(KSPAN .EQ. JC) GO TO 800
      GO TO 100
  450 AKP=AKM+BJM
      AKM=AKM-BJM
      BKP=BKM-AJM
      BKM=BKM+AJM
      IF(S1 .NE. 0) GO TO 430
  460 A(K1)=AKP
      B(K1)=BKP
      A(K2)=AJP
      B(K2)=BJP
      A(K3)=AKM
      B(K3)=BKM
      KK=K3+KSPAN
      IF(KK .LE. NT) GO TO 420
      GO TO 440
C  TRANSFORM FOR FACTOR OF 5 (OPTIONAL CODE)
  510 C2=C72**2-S72**2
      S2=2.*C72*S72
  520 K1=KK+KSPAN
      K2=K1+KSPAN
      K3=K2+KSPAN
      K4=K3+KSPAN
      AKP=A(K1)+A(K4)
      AKM=A(K1)-A(K4)
      BKP=B(K1)+B(K4)
      BKM=B(K1)-B(K4)
      AJP=A(K2)+A(K3)
      AJM=A(K2)-A(K3)
      BJP=B(K2)+B(K3)
      BJM=B(K2)-B(K3)
      AA=A(KK)
      BB=B(KK)
      A(KK)=AA+AKP+AJP
      B(KK)=BB+BKP+BJP
      AK=AKP*C72+AJP*C2+AA
      BK=BKP*C72+BJP*C2+BB
      AJ=AKM*S72+AJM*S2
      BJ=BKM*S72+BJM*S2
      A(K1)=AK-BJ
      A(K4)=AK+BJ
      B(K1)=BK+AJ
      B(K4)=BK-AJ
      AK=AKP*C2+AJP*C72+AA
      BK=BKP*C2+BJP*C72+BB
      AJ=AKM*S2-AJM*S72
      BJ=BKM*S2-BJM*S72
      A(K2)=AK-BJ
      A(K3)=AK+BJ
      B(K2)=BK+AJ
      B(K3)=BK-AJ
      KK=K4+KSPAN
      IF(KK .LT. NN) GO TO 520
      KK=KK-NN
      IF(KK .LE. KSPAN) GO TO 520
      GO TO 700
C  TRANSFORM FOR ODD FACTORS
  600 K=NFAC(I)
      KSPNN=KSPAN
      KSPAN=KSPAN/K
      IF(K .EQ. 3) GO TO 320
      IF(K .EQ. 5) GO TO 510
      IF(K .EQ. JF) GO TO 640
      JF=K
      S1=RAD/(K)
      C1=COS(S1)
      S1=SIN(S1)
      IF(JF .GT. MAXF) GO TO 998
      CK(JF)=1.
      SK(JF)=0.
      J=1
  630 CK(J)=CK(K)*C1+SK(K)*S1
      SK(J)=CK(K)*S1-SK(K)*C1
      K=K-1
      CK(K)=CK(J)
      SK(K)=-SK(J)
      J=J+1
      IF(J .LT. K) GO TO 630
  640 K1=KK
      K2=KK+KSPNN
      AA=A(KK)
      BB=B(KK)
      AK=AA
      BK=BB
      J=1
      K1=K1+KSPAN
  650 K2=K2-KSPAN
      J=J+1
      AT(J)=A(K1)+A(K2)
      AK=AT(J)+AK
      BT(J)=B(K1)+B(K2)
      BK=BT(J)+BK
      J=J+1
      AT(J)=A(K1)-A(K2)
      BT(J)=B(K1)-B(K2)
      K1=K1+KSPAN
      IF(K1 .LT. K2) GO TO 650
      A(KK)=AK
      B(KK)=BK
      K1=KK
      K2=KK+KSPNN
      J=1
  660 K1=K1+KSPAN
      K2=K2-KSPAN
      JJ=J
      AK=AA
      BK=BB
      AJ=0.
      BJ=0.
      K=1
  670 K=K+1
      AK=AT(K)*CK(JJ)+AK
      BK=BT(K)*CK(JJ)+BK
      K=K+1
      AJ=AT(K)*SK(JJ)+AJ
      BJ=BT(K)*SK(JJ)+BJ
      JJ=JJ+J
      IF(JJ .GT. JF) JJ=JJ-JF
      IF(K .LT. JF) GO TO 670
      K=JF-J
      A(K1)=AK-BJ
      B(K1)=BK+AJ
      A(K2)=AK+BJ
      B(K2)=BK-AJ
      J=J+1
      IF(J .LT. K) GO TO 660
      KK=KK+KSPNN
      IF(KK .LE. NN) GO TO 640
      KK=KK-NN
      IF(KK .LE. KSPAN) GO TO 640
C  MULTIPLY BY ROTATION FACTOR (EXCEPT FOR FACTORS OF 2 AND 4)
  700 IF(I .EQ. M) GO TO 800
      KK=JC+1
  710 C2=1.-CD
      S1=SD
  720 C1=C2
      S2=S1
      KK=KK+KSPAN
  730 AK=A(KK)
      A(KK)=C2*AK-S2*B(KK)
      B(KK)=S2*AK+C2*B(KK)
      KK=KK+KSPNN
      IF(KK .LE. NT) GO TO 730
      AK=S1*S2
      S2=S1*C2+C1*S2
      C2=C1*C2-AK
      KK=KK-NT+KSPAN
      IF(KK .LE. KSPNN) GO TO 730
      C2=C1-(CD*C1+SD*S1)
      S1=S1+(SD*C1-CD*S1)
      KK=KK-KSPNN+JC
      IF(KK .LE. KSPAN) GO TO 720
      KK=KK-KSPAN+JC+INC
      IF(KK .LE. JC+JC) GO TO 710
      GO TO 100
C  PERMUTE THE RESULTS TO NORMAL ORDER---DONE IN TWO STAGES
C  PERMUTATION FOR SQUARE FACTORS OF N
  800 NP(1)=KS
      IF(KT .EQ. 0) GO TO 890
      K=KT+KT+1
      IF(M .LT. K) K=K-1
      J=1
      NP(K+1)=JC
  810 NP(J+1)=NP(J)/NFAC(J)
      NP(K)=NP(K+1)*NFAC(J)
      J=J+1
      K=K-1
      IF(J .LT. K) GO TO 810
      K3=NP(K+1)
      KSPAN=NP(2)
      KK=JC+1
      K2=KSPAN+1
      J=1
      IF(N .NE. NTOT) GO TO 850
C  PERMUTATION FOR SINGLE-VARIATE TRANSFORM (OPTIONAL CODE)
  820 AK=A(KK)
      A(KK)=A(K2)
      A(K2)=AK
      BK=B(KK)
      B(KK)=B(K2)
      B(K2)=BK
      KK=KK+INC
      K2=KSPAN+K2
      IF(K2 .LT. KS) GO TO 820
  830 K2=K2-NP(J)
      J=J+1
      K2=NP(J+1)+K2
      IF(K2 .GT. NP(J)) GO TO 830
      J=1
  840 IF(KK .LT. K2) GO TO 820
      KK=KK+INC
      K2=KSPAN+K2
      IF(K2 .LT. KS) GO TO 840
      IF(KK .LT. KS) GO TO 830
      JC=K3
      GO TO 890
C  PERMUTATION FOR MULTIVARIATE TRANSFORM
  850 K=KK+JC
  860 AK=A(KK)
      A(KK)=A(K2)
      A(K2)=AK
      BK=B(KK)
      B(KK)=B(K2)
      B(K2)=BK
      KK=KK+INC
      K2=K2+INC
      IF(KK .LT. K) GO TO 860
      KK=KK+KS-JC
      K2=K2+KS-JC
      IF(KK .LT. NT) GO TO 850
      K2=K2-NT+KSPAN
      KK=KK-NT+JC
      IF(K2 .LT. KS) GO TO 850
  870 K2=K2-NP(J)
      J=J+1
      K2=NP(J+1)+K2
      IF(K2 .GT. NP(J)) GO TO 870
      J=1
  880 IF(KK .LT. K2) GO TO 850
      KK=KK+JC
      K2=KSPAN+K2
      IF(K2 .LT. KS) GO TO 880
      IF(KK .LT. KS) GO TO 870
      JC=K3
  890 IF(2*KT+1 .GE. M) RETURN
      KSPNN=NP(KT+1)
C  PERMUTATION FOR SQUARE-FREE FACTORS OF N
      J=M-KT
      NFAC(J+1)=1
  900 NFAC(J)=NFAC(J)*NFAC(J+1)
      J=J-1
      IF(J .NE. KT) GO TO 900
      KT=KT+1
      NN=NFAC(KT)-1
      IF(NN .GT. MAXP) GO TO 998
      JJ=0
      J=0
      GO TO 906
  902 JJ=JJ-K2
      K2=KK
      K=K+1
      KK=NFAC(K)
  904 JJ=KK+JJ
      IF(JJ .GE. K2) GO TO 902
      NP(J)=JJ
  906 K2=NFAC(KT)
      K=KT+1
      KK=NFAC(K)
      J=J+1
      IF(J .LE. NN) GO TO 904
C  DETERMINE THE PERMUTATION CYCLES OF LENGTH GREATER THAN 1
      J=0
      GO TO 914
  910 K=KK
      KK=NP(K)
      NP(K)=-KK
      IF(KK .NE. J) GO TO 910
      K3=KK
  914 J=J+1
      KK=NP(J)
      IF(KK .LT. 0) GO TO 914
      IF(KK .NE. J) GO TO 910
      NP(J)=-J
      IF(J .NE. NN) GO TO 914
      MAXF=INC*MAXF
C  REORDER A AND B, FOLLOWING THE PERMUTATION CYCLES
      GO TO 950
  924 J=J-1
      IF(NP(J) .LT. 0) GO TO 924
      JJ=JC
  926 KSPAN=JJ
      IF(JJ .GT. MAXF) KSPAN=MAXF
      JJ=JJ-KSPAN
      K=NP(J)
      KK=JC*K+II+JJ
      K1=KK+KSPAN
      K2=0
  928 K2=K2+1
      AT(K2)=A(K1)
      BT(K2)=B(K1)
      K1=K1-INC
      IF(K1 .NE. KK) GO TO 928
  932 K1=KK+KSPAN
      K2=K1-JC*(K+NP(K))
      K=-NP(K)
  936 A(K1)=A(K2)
      B(K1)=B(K2)
      K1=K1-INC
      K2=K2-INC
      IF(K1 .NE. KK) GO TO 936
      KK=K2
      IF(K .NE. J) GO TO 932
      K1=KK+KSPAN
      K2=0
  940 K2=K2+1
      A(K1)=AT(K2)
      B(K1)=BT(K2)
      K1=K1-INC
      IF(K1 .NE. KK) GO TO 940
      IF(JJ .NE. 0) GO TO 926
      IF(J .NE. 1) GO TO 924
  950 J=K3+1
      NT=NT-KSPNN
      II=NT-INC+1
      IF(NT .GE. 0) GO TO 924
      RETURN
C  ERROR FINISH, INSUFFICIENT ARRAY STORAGE
 998  IERR=1
      RETURN
      END

      subroutine fetch_sens(io_res,filen,head,ierr)
c
c     subroutine will find response for station stat and channel chan
c     at stime and load it into response common block
c
c     input:
c     	io_res- io unit to open
c     	filen - file containing sensitivities
c     	head  - header record
c     output:
c     	ierr  - integer error flag
c           	= 0 for recovered response
c           	= 999 for no response found
c
      include '/usr/local/include/qlib2.inc'
      record /INT_TIME/ stime, bdate, edate
      record /EXT_TIME/ st
      include 'station_hdr.inc'
c
      character*3 cseed, chan
      character*4 cstat, cnetn, stat
      character*9 cunit
      character*(*) filen
      real*4 fp_lc, fp_hc, fp_sens
      integer*4 io_res, ierr, daymo, iere
      real*8 td1, td2 
c
c     Common block for saving instrument response information
c
      integer*4 iunit
      real*4 sens, fl, fh
      common /sens/ iunit, sens, fl, fh
c
c     Initialize
c
      ierr = 0
c
      iunit = 999
      sens = 0.0
      fl = 0.0
      fh = 0.0
c
      stat  = head.station_id
      chan  = head.channel_id
      stime = head.begtime
c
      open(io_res,file=filen)
c
c     Loop over responses until the correct one is found
c
c     Format of file:
c
c ARC  HHZ 1992.147.2200 2599.366.2359   0. -90. (DU/MS-1) BDSN
c      0.008333    32.000000    6.23183E+08
c ARC  HHN 1992.147.2200 2599.366.2359   0.   0. (DU/MS-1) BDSN
c      0.008333    32.000000    6.02140E+08
c
100   continue
      read(io_res,101,end=105) cstat, cseed,
     .    isyr, isdy, ishr, ismn,
     .    ieyr, iedy, iehr, iemn,
     .    azi, dip, cunit, cnetn
c
      if (cstat(4:4) .eq. '_') then
        cstat(4:4) =  ' '
      endif
      read(io_res,102) fp_lc, fp_hc, fp_sens
c
101   format(a4,1x,a3,1x,i4,1x,i3,1x,i2,i2,1x,i4,
     .  1x,i3,1x,i2,i2,1x,f4.0,1x,f4.0,1x,a9,1x,a4)
102   format(5x,f8.6,3x,f10.6,3x,1pe12.5)
c
c     form times
c     --changed to use DN's time routines 10/28/93
c
      st.year   = isyr
      st.doy    = isdy
      iere = daymo(isdy,st.month,st.day,isyr)
      if (iere .ne. 1) then
        ierr = 997
      end if
      st.hour   = ishr
      st.minute = ismn
      st.second = 0
      st.usec  = 0
      call f_ext_to_int(st,bdate)
c
      st.year   = ieyr
      if (ieyr .eq. 2599 .and. iedy .eq. 366) then
        st.doy  = 365
        st.month = 12
        st.day = 31
      else
        st.doy    = iedy
        iere = daymo(iedy,st.month,st.day,ieyr)
        if (iere .ne. 1) then
          ierr = 998
        end if
      end if
      st.hour   = iehr
      st.minute = iemn
      st.second = 0
      st.usec  = 0
      call f_ext_to_int(st,edate) 
      td1 = f_tdiff(stime, bdate)
      td2 = f_tdiff(stime, edate)
c
c     compare station name, channel and date 
c
      if (cstat .eq. stat) then
        if (cseed .eq. chan) then
          if (td1 .ge. 0.d0 .and. td2 .le. 0.d0) then
c
c           match!
c
            sens = fp_sens
            fl = fp_lc
            fh = fp_hc
            if (cunit .eq. '(DU/MS-2)') then
              iunit=2
            else if (cunit .eq. '(DU/MS-1)') then
              iunit=1
            else if (cunit .eq. '(DU/M)   ') then
              iunit=0
            else
              iunit=999
            end if
c
            head.sens = sens
            head.fl = fp_lc
            head.fh = fp_hc
            head.iunit = iunit
c
            go to 110
          end if
        end if
      end if
c
      go to 100
c
c     error exit
c
105   continue
      ierr = 999
      close(io_res)
      return
c
c     sucessful completion exit
c
110   continue
      close(io_res)
      return
c
c
      end

      real function atten(rx)
c
c     function to estimate attenuation
c       this function attributed to Richter, as modified by 
c         Jennings & Kanamori
c
c     rx is the focal distance (rx**2 = dist**2 + href**2) in km
c        where href is 8.00 km
c
      real*4 rx, xc, xn, xk
c
c     Define the default constants
c
      xc = 0.4971
      xk = 0.0053
      xn = 1.2178
c
      atten = xc * exp(-xk*rx) / (rx**xn)
c
      return
      end 

c
c

	subroutine kstart(string,k)
c
c     returns place of first non-blank character
c
	character*(*) string
      character*1 blank
      data blank/' '/
c
      k=0
      l=len(string)
      do i= 1,l
        if (string(i:i) .ne. blank) go to 2
      end do
	i=0
    2 continue
      k=i
	return
	end

      SUBROUTINE SVD1(M1,N1,M,N,A,U,V,Q,INDEX)
C$$$$$ CALLS NO OTHER ROUTINES
C  SINGULAR VALUE DECOMPOSITION)  FOR ALGO PROGRAM SEE WILKINSON+REINSCH
C  HANDBOOK FOR AUTOMATIC COMPUTATION VOL 2 - LINEAR ALGEBRA, PP140-144
C  TRANSLATED FROM ALGOL BY R.L.PARKER
C  THE MATRIX A(M,N) IS DECOMPOSED.  SINGULAR VALUES IN Q, PRE-MATRIX IN U,
C  POST-MATRIX IN V.   INDEX MAY BE 1,2,3 OR 4.  IF 1, FIND U,V. IF 2, FIND
C  ONLY U. IF 3, FIND ONLY V. IF 4, FIND NEITHER. IN ALL CASES, THE ARRAY  U
C  MUST BE SUPPLIED AS IT IS USED AS WORKING SPACE FOR THE ROUTINE.
C  PROGRAM ALTERED BY PAUL SILVER 4/15 TO HANDLE UNPACKED ARRAYS.
C  M1,N1 ARE DIMENSIONS IN MAIN ROUTINE.M,N ARE ACTUAL DIMENSIONS TO
C  BE USED IN THE SUBROUTINE.
C
C     single precision version
c     implicit double precision (a-h,o-z)
c
      DIMENSION A(M1,N1),U(M1,N1),V(N1,N1),Q(N1)
      DIMENSION E(10000)
C
      EPS=.556E-15
      TOL=1.0E-35
      DO 1100 J=1,N
      DO 1100 I=1,M
        U(I,J)=A(I,J)
 1100 continue
C  HOUSEHOLDER REDUCTION TO BI-DIAGONAL FORM
      G=0.0
      X=0.0
      DO 2900 I=1,N
      E(I)=G
      S=0.0
      L=I+1
      DO 2100 J=I,M
        S=U(J,I)**2 + S
 2100 continue
      IF (S .LT. TOL) GO TO 2500
      F=U(I,I)
      G=-SIGN(SQRT(S),F)
      H=F*G - S
      U(I,I)=F - G
      IF (L.GT.N) GO TO 2501
      DO 2400 J=L,N
      S=0.0
      DO 2200 K=I,M
        S=U(K,I)*U(K,J) + S
 2200 continue
      F=S/H
      DO 2300 K=I,M
       U(K,J)=U(K,J) + F*U(K,I)
 2300 continue
 2400 CONTINUE
      GO TO 2501
 2500 G=0.0
C
 2501 CONTINUE
      Q(I)=G
      S=0.0
      IF (L.GT.N) GO TO 2601
      DO 2600 J=L,N
 2600 S=U(I,J)**2 + S
 2601 IF (S.LT.TOL) GO TO 2800
      F=U(I,I+1)
      G=-SIGN(SQRT(S),F)
      H=F*G - S
      U(I,I+1)=F - G
      IF (L.GT.N) GO TO 2651
      DO 2650 J=L,N
 2650 E(J)=U(I,J)/H
 2651 CONTINUE
      IF (L.GT.M) GO TO 2850
      DO 2700 J=L,M
      S=0.0
      IF (L.GT.N) GO TO 2700
      DO 2670 K=L,N
 2670 S=U(J,K)*U(I,K) + S
      DO 2690 K=L,N
 2690 U(J,K)=U(J,K) + S*E(K)
 2700 CONTINUE
      GO TO 2850
 2800 G=0.0
 2850 Y=ABS(Q(I)) + ABS(E(I))
      IF (Y .GT. X) X=Y
 2900 CONTINUE
C
C  ACCUMULATION OF RIGHT-HAND TRANSFORMS (V)
C
      GO TO (3000,3701,3000,3701),INDEX
 3000 CONTINUE
      DO 3700 IBACK=1,N
      I=N+1-IBACK
      IF (G .EQ. 0.0) GO TO 3500
      H=U(I,I+1)*G
      IF (L.GT.N) GO TO 3500
      DO 3100 J=L,N
 3100 V(J,I)=U(I,J)/H
      DO 3400 J=L,N
      S=0.0
      DO 3200 K=L,N
 3200 S=U(I,K)*V(K,J) + S
      DO 3300 K=L,N
 3300 V(K,J)=V(K,J) + S*V(K,I)
 3400 CONTINUE
 3500 CONTINUE
      IF (L.GT.N) GO TO 3601
      DO 3600 J=L,N
      V(J,I)=0.0
 3600 V(I,J)=0.0
 3601 V(I,I)=1.0
      G=E(I)
      L=I
 3700 CONTINUE
 3701 CONTINUE
C
C  ACCUMULATION OF LEFT-HAND TRANSFORMS
      GO TO (4000,4000,4701,4701),INDEX
 4000 CONTINUE
      DO 4700 IBACK=1,N
      I=N+1-IBACK
      L=I+1
      G=Q(I)
      IF (L.GT.N) GO TO 4101
      DO 4100 J=L,N
 4100 U(I,J)=0.0
 4101 IF (G.EQ. 0.0) GO TO  4500
      H=U(I,I)*G
      IF (L.GT.N) GO TO 4401
      DO 4400 J=L,N
      S=0.0
      DO 4200 K=L,M
 4200 S=U(K,I)*U(K,J) + S
      F=S/H
      DO 4300 K=I,M
 4300 U(K,J)=U(K,J) + F*U(K,I)
 4400 CONTINUE
 4401 CONTINUE
      DO 4550 J=I,M
 4550 U(J,I)=U(J,I)/G
      GO TO 4700
 4500 CONTINUE
      DO 4600 J=I,M
 4600 U(J,I)=0.0
 4700 U(I,I)=U(I,I) + 1.0
C
C  DIAGONALIZATION OF BI-DIAGONAL FORM
 4701 EPS=EPS*X
      DO 9000 KBACK=1,N
      K=N+1-KBACK
C  TEST F-SPLITTING
 5000 CONTINUE
      DO 5100 LBACK=1,K
      L=K+1-LBACK
      IF (ABS(E(L)).LE. EPS) GO TO 6500
      IF (ABS(Q(L-1)) .LE. EPS) GO TO 6000
 5100 CONTINUE
C  CANCELLATION OF E(L), IF L.GT. 1
 6000 C=0.0
      S=1.0
      L1=L - 1
      DO 6200 I=L,K
      F=S*E(I)
      E(I)=C*E(I)
      IF (ABS(F) .LE. EPS) GO TO 6500
      G=Q(I)
      Q(I)=SQRT(F*F + G*G)
      H=Q(I)
      C=G/H
      S=-F/H
      GO TO (6050,6050,6200,6200),INDEX
 6050 CONTINUE
      DO 6100 J=1,M
      Y=U(J,L1)
      Z=U(J,I)
      U(J,L1)=Y*C + Z*S
      U(J,I)=-Y*S + Z*C
 6100 CONTINUE
 6200 CONTINUE
C  TEST F-CONVERGENCE
 6500 Z=Q(K)
      IF (L .EQ. K) GO TO  8000
C  SHIFT FROM BOTTOM 2 X 2 MINOR
      X=Q(L)
      Y=Q(K-1)
      G=E(K-1)
      H=E(K)
      F=((Y-Z)*(Y+Z) + (G-H)*(G+H))/(2.0*H*Y)
      G=SQRT(F*F + 1.0)
      F=((X-Z)*(X+Z) + H*(Y/(F + SIGN(G,F))-H))/X
C  NEXT Q-R TRANSFORMATION
      C=1.0
      S=1.0
      LPLUS=L + 1
      DO 7500 I=LPLUS,K
      G=E(I)
      Y=Q(I)
      H=S*G
      G=C*G
      Z=SQRT(F*F + H*H)
      E(I-1)=Z
      C=F/Z
      S=H/Z
      F=X*C + G*S
      G=-X*S + G*C
      H=Y*S
      Y=Y*C
      GO TO (7100,7201,7100,7201),INDEX
 7100 DO 7200 J=1,N
      X=V(J,I-1)
      Z=V(J,I)
      V(J,I-1)=X*C + Z*S
      V(J,I)=-X*S + Z*C
 7200 CONTINUE
 7201 Z=SQRT(F*F + H*H)
      Q(I-1)=Z
      C=F/Z
      S=H/Z
      F=C*G + S*Y
      X=-S*G + C*Y
      GO TO (7300,7300,7500,7500       ),INDEX
 7300 DO 7400 J=1,M
      Y=U(J,I-1)
      Z=U(J,I)
      U(J,I-1)=Y*C + Z*S
      U(J,I)=-Y*S + Z*C
 7400 CONTINUE
 7500 CONTINUE
      E(L)=0.0
      E(K)=F
      Q(K)=X
      GO TO  5000
C  CONVERGENCE
 8000 IF (Z .GE. 0.0) GO TO 9000
C  Q IS MADE NON-NEGATIVE
      Q(K)=-Z
      GO TO (8100,9000,8100,9000),INDEX
 8100 DO 8200 J=1,N
 8200 V(J,K)=-V(J,K)
 9000 CONTINUE
      RETURN
      END

      complex function wwlp (w)
c
c  .....WWSSN LP - Blacknest specified poles and zeros.....
c
c  based on the sac subroutine wwspbn - Blacknest
c
      complex*8 cz(3), cp(4), ck, s, t
c
c   .....Set poles and zeros.....
c
      data ck /(0.5985275,0.0)/
      data cz /3*(0.,0.)/
      data cp /( -0.25700,  0.3376),
     2         ( -0.25700, -0.3376),
     3         ( -0.06283,  0.0),
     4         ( -0.06283,  0.0) /
c
      s = cmplx(0.,w)
c
      t = ck
c
c     loop over common zeros and poles
c
      do ii = 1, 3
        t = t * ((s - cz(ii))/(s - cp(ii)))
      end do
c
c     loop over remaining poles
c
      do ii = 4, 4
        t = t / (s - cp(ii))
      end do
c
      wwlp = t
c
      return
      end

      SUBROUTINE demean(A,N)
C
C $$$$$ CALLS NO OTHER ROUTINE $$$$$
C
C   DEMEAN REMOVES THE MEAN FROM THE N POINT SERIES STORED IN
C   ARRAY A.
C
C                                                    
      INTEGER*4 N,I
      DIMENSION A(*)
      XM=0.
      DO 1 I=1,N
 1    XM=XM+A(I)
      XM=XM/N
      DO 2 I=1,N
 2    A(I)=A(I)-XM
      RETURN
      END

      subroutine cipnum( token,rnum,iflag )
c
c   purpose:
c      Interpret a token as a number. A real number is returned if
c      numeric interpretation is possible.
c
c   args:
c
c      token       character string to be interpreted
c      rnum        result if numeric - else = 0
c      iflag       =0 if o.k. else = ichar(first non-numeric)
c
c   versions and revisions:
c      for UNIVAC R.Goff Sept. 1981
c      for VAX/UNIX R.Goff Jan. 1981
c
      character*(*) token
      character*15 numstr
c
c   find length of token
c
      lt  =  index( token,' ' ) - 1
      if( lt .le. 0 ) lt = len( token )
c
c   scan token for bum chars
c
      do 100 i = 1,lt
      if( lge(token(i:i),'0') .and. lle(token(i:i),'9') ) go to 100
      if( token(i:i) .eq. 'e' ) go to 100
      if( token(i:i) .eq. 'E' ) go to 100
      if( token(i:i) .eq. '.' ) go to 100
      if( token(i:i) .eq. '+' ) go to 100
      if( token(i:i) .eq. '-' ) go to 100
c
c   return bum char in iflag
c
      rnum  =  0.
      iflag  =  ichar( token(i:i) )
      return
c
100   continue
c
c   move it to numstr right justified
c
      numstr  =  ' '
      numstr(16-lt:15) = token(1:lt)
c
c   use an internal read to decode it
c
      read( numstr,200 ) rnum
200   format(e15.0)
c
c   success
c
      iflag  =  0
      return
      end

      subroutine calc_cfr(npts,dt,ind,data,cfr)
c
c     subroutine for estimation of various characteristic functions
c
c     input:
c             npts   - number of points in time series
c             dt     - sampling rate in seconds
c             ind    - index of characteristic function of choice
c             data   - array containing 3 component time series
c     output:
c             cfr    - characteristic function
c
      parameter (maxp  = 65536)
c
      real*4 data(maxp,3)
      real*4 xn(maxp), yn(maxp), zn(maxp)
      real*4 ang(maxp,2), rn(maxp)
      real*4 cfr(*)
      real*4 k1, k2, k4, k8
c
      pi = 4.0*atan(1.0)
      cffc = 0.2
      k2 = 0.5/(dt*pi*cffc)
      k8 = 0.5
c
c     initialize values
c
      cfr(1) = 0.0
      sum1a = 0.0
      sum1b = 0.0
      sum4a = 0.0
      sum4b = 0.0
      savg = 0.0
      svar = 0.0
c
c Rex Allen
c
      if (ind .eq. 1) then
        do ii = 2, npts
          xx = data(ii,1)
          yy = data(ii,2)
          zz = data(ii,3)
          xdt = data(ii,1) - data(ii-1,1)
          ydt = data(ii,2) - data(ii-1,2)
          zdt = data(ii,3) - data(ii-1,3)
          sum1a = sum1a + abs(xx) + abs(yy) + abs(zz)
          sum1b = sum1b + abs(xdt) + abs(ydt) + abs(zdt)
          k1 = sum1a/sum1b
          cfr(ii) = xx*xx + yy*yy + zz*zz 
     .              + k1*(xdt*xdt + ydt*ydt + zdt*zdt)
        end do
c
c Bob Uhrhammer
c
      elseif (ind .eq. 2) then
        do ii = 2, npts
          xx = data(ii,1)
          yy = data(ii,2)
          zz = data(ii,3)
          xdt = data(ii,1) - data(ii-1,1)
          ydt = data(ii,2) - data(ii-1,2)
          zdt = data(ii,3) - data(ii-1,3)
          cfr(ii) = xx*xx + yy*yy + zz*zz
     .              + k2*(xdt*xdt + ydt*ydt + zdt*zdt)
        end do
c
c Rex Allen **2
c
      elseif (ind .eq. 3) then
        do ii = 2, npts
          xx = data(ii,1)
          yy = data(ii,2)
          zz = data(ii,3)
          xdt = data(ii,1) - data(ii-1,1)
          ydt = data(ii,2) - data(ii-1,2)
          zdt = data(ii,3) - data(ii-1,3)
          sum1a = sum1a + abs(xx) + abs(yy) + abs(zz)
          sum1b = sum1b + abs(xdt) + abs(ydt) + abs(zdt)
          k1 = sum1a/sum1b
          c1 = xx*xx + yy*yy + zz*zz
     .              + k1*(xdt*xdt + ydt*ydt + zdt*zdt)
          cfr(ii) = c1 * c1
        end do
c
c Baer envelop function
c
      elseif (ind .eq. 4) then
        do ii = 2, npts
          xx = data(ii,1)
          yy = data(ii,2)
          zz = data(ii,3)
          xdt = data(ii,1) - data(ii-1,1)
          ydt = data(ii,2) - data(ii-1,2)
          zdt = data(ii,3) - data(ii-1,3)
          sum4a = sum4a + xx*xx + yy*yy + zz*zz
          sum4b = sum4b + xdt*xdt + ydt*ydt + zdt*zdt
          k4 = sum4a/sum4b
          cfr(ii) = xx*xx + yy*yy + zz*zz
     .              + k4*(xdt*xdt + ydt*ydt + zdt*zdt)
        end do
c
c Baer preferred function
c -- must contain an error - to ugly to be true
c
      elseif (ind .eq. 5) then
        do ii = 2, npts 
          xx = data(ii,1) 
          yy = data(ii,2) 
          zz = data(ii,3) 
          xdt = data(ii,1) - data(ii-1,1) 
          ydt = data(ii,2) - data(ii-1,2) 
          zdt = data(ii,3) - data(ii-1,3) 
          sum4a = sum4a + xx*xx + yy*yy + zz*zz
          sum4b = sum4b + xdt*xdt + ydt*ydt + zdt*zdt   
          k4 = sum4a/sum4b
          c4 = xx*xx + yy*yy + zz*zz   
     .         + k4*(xdt*xdt + ydt*ydt + zdt*zdt) 
          sf = c4 * c4
          savg = savg + sf
          sfavg = savg/(3*ii)
          svar = svar + (sf - sfavg)**2
          sfvar = sqrt(svar)
          cfr(ii) = (sf - sfavg)/sfvar
        end do 
c
c Sarrin
c
      elseif (ind .eq. 6) then
        do ii = 2, npts  
          xx = data(ii,1)  
          yy = data(ii,2)  
          zz = data(ii,3)  
          cfr(ii) = abs(xx*yy*zz)
        end do
c
c  Uhrhammer angle function
c
      elseif (ind .eq. 7) then
        do ii = 1, npts
          xx = data(ii,1)  
          yy = data(ii,2)  
          zz = data(ii,3)  
          fmag = sqrt(xx*xx + yy*yy + zz*zz)
          rn(ii) = fmag
          xn(ii) = xx/fmag
          yn(ii) = yy/fmag
          zn(ii) = zz/fmag
        end do
        do ii = 2, npts - 1
          xnm = xn(ii-1)
          ynm = yn(ii-1)
          znm = zn(ii-1)
          xn0 = xn(ii)
          yn0 = yn(ii)
          zn0 = zn(ii)
          xnp = xn(ii+1)
          ynp = yn(ii+1)
          znp = zn(ii+1)
          dot_p = xnm*xnp + ynm*ynp + znm*znp
          ang(ii,1) = 0.5*asin(dot_p)
c
          xm=ynm*zn0-yn0*znm
          ym=znm*xn0-zn0*xnm
          zm=xnm*yn0-xn0*ynm
          xp=yn0*znp-ynp*zn0
          yp=zn0*xnp-znp*xn0
          zp=xn0*ynp-xnp*yn0
          cross_p = xm*xp + ym*yp + zm*zp
          ang(ii,2) = asin(cross_p)
        end do
        ang(1,1) = ang(2,1)
        ang(1,2) = ang(2,2)
        ang(npts,1) = ang(npts-1,1)
        ang(npts,2) = ang(npts-1,2)
c
        fx = 1.0/dt
        fx2 = fx*fx
        do ii = 2, npts - 1
          da1dt = ang(ii,1)*fx
          da2dt = ang(ii,2)*fx
          da1dt2 = (ang(ii+1,1)-2.0*ang(ii,1)+ang(ii-1,1))*fx2
          da2dt2 = (ang(ii+1,2)-2.0*ang(ii,2)+ang(ii-1,2))*fx2
          cfr(ii) = rn(ii)*(da1dt*da1dt+da2dt*da2dt
     .                + k2*(da1dt2*da1dt2+da2dt2*da2dt2))
        end do
        cfr(1) = cfr(2)
        cfr(npts) = cfr(npts-1)
c
c     Uhrhammer combined
c
      elseif (ind .eq. 8) then
        do ii = 1, npts
          xx = data(ii,1)
          yy = data(ii,2)
          zz = data(ii,3)
          fmag = sqrt(xx*xx + yy*yy + zz*zz)
          rn(ii) = fmag
          xn(ii) = xx/fmag
          yn(ii) = yy/fmag
          zn(ii) = zz/fmag
        end do
c
        do ii = 2, npts
          xnm = xn(ii-1)
          ynm = yn(ii-1)
          znm = zn(ii-1)
          xn0 = xn(ii)
          yn0 = yn(ii)
          zn0 = zn(ii)
          xnp = xn(ii+1)
          ynp = yn(ii+1)
          znp = zn(ii+1)
          dot_p = xnm*xnp + ynm*ynp + znm*znp
          ang(ii,1) = 0.5*asin(dot_p)
          xm=ynm*zn0-yn0*znm
          ym=znm*xn0-zn0*xnm
          zm=xnm*yn0-xn0*ynm
          xp=yn0*znp-ynp*zn0
          yp=zn0*xnp-znp*xn0
          zp=xn0*ynp-xnp*yn0
          cross_p = xm*xp + ym*yp + zm*zp
          ang(ii,2) = asin(cross_p)
        end do
        ang(1,1) = ang(2,1)
        ang(1,2) = ang(2,2)
        ang(npts,1) = ang(npts-1,1)
        ang(npts,2) = ang(npts-1,2)
c
        fx = 1.0/dt
        fx2 = fx*fx
        do ii = 2, npts - 1
          xx = data(ii,1)
          yy = data(ii,2)
          zz = data(ii,3)

          xdt = data(ii,1) - data(ii-1,1)
          ydt = data(ii,2) - data(ii-1,2)
          zdt = data(ii,3) - data(ii-1,3)
          cfr1 = xx*xx + yy*yy + zz*zz
     .              + k2*(xdt*xdt + ydt*ydt + zdt*zdt)

          da1dt = ang(ii,1)*fx
          da2dt = ang(ii,2)*fx
          da1dt2 = (ang(ii+1,1)-2.0*ang(ii,1)+ang(ii-1,1))*fx2
          da2dt2 = (ang(ii+1,2)-2.0*ang(ii,2)+ang(ii-1,2))*fx2
          cfr2 = rn(ii)*(da1dt*da1dt+da2dt*da2dt
     .                + k2*(da1dt2*da1dt2+da2dt2*da2dt2))

          cfr(ii) = k8*cfr1 + (1.0 - k8)*cfr2
        end do
        cfr(1) = cfr(2)
        cfr(npts) = cfr(npts-1)

      end if
c
c     all done
c
      return
      end

      subroutine fetch_response(io_res,filen,head,ierr)
c
c     subroutine will find response for station stat and channel chan
c     at stime and load it into response common block
c
c     input:
c     	io_res- io unit to open
c     	filen - file containing instrument information
c     	head  - station header structure
c     output:
c     	ierr  - integer error flag
c           	= 0 for recovered response
c          	 = 999 for no response found
c
      include '/usr/local/include/qlib2.inc'
      record /INT_TIME/ stime, bdate, edate
      record /EXT_TIME/ st
	include 'station_hdr.inc'
c
      character*3 chan
      character*4 stat
      character*3 cseed
      character*4 cstat, cchan, cnetn
      character*9 cunit
      character*(*) filen
      integer*4 io_res, iere, ierr, daymo
	real*8 td1, td2
c
c     Common block for saving instrument response information
c
      integer*4 iunit
      integer*4 npoles, nzeros
      real*4 ds, gain
      complex*8 poles(60)
      common /instr/ iunit, ds, gain, npoles, nzeros, poles
c
c     Initialize
c
      ierr = 0
c
      iunit = 999
      npoles = 0
      nzeros = 0
      gain = 0.0
      ds = 1.0
c
      stat  = head.station_id
      chan  = head.channel_id
	stime = head.begtime
c
      open(io_res,file=filen)
c
c     Loop over responses until the correct one is found
c
100   continue
      read(io_res,101,end=105) cstat, cchan,
     .    isyr, isdy, ishr, ismn,
     .    ieyr, iedy, iehr, iemn,
     .    azi, dip, cunit, cnetn, cseed
c
      if (cstat(4:4) .eq. '_') then
        cstat(4:4) =  ' '
      endif
      read(io_res,*) gs, nz, np
c
c     form times
c     --changed to use DN's time routines 10/28/93
c
      st.year   = isyr
      st.doy    = isdy
      iere = daymo(isdy,st.month,st.day,isyr)
      if (iere .ne. 1) then
        ierr = 997
      end if
      st.hour   = ishr
      st.minute = ismn
      st.second = 0
      st.usec   = 0
      call f_ext_to_int(st,bdate)
c
      st.year   = ieyr
      if (ieyr .eq. 2599 .and. iedy .eq. 366) then
        st.doy  = 365
        st.month = 12
        st.day = 31
      else
        st.doy    = iedy
        iere = daymo(iedy,st.month,st.day,ieyr)
        if (iere .ne. 1) then
          ierr = 998
        end if
      end if
      st.hour   = iehr
      st.minute = iemn
      st.second = 0
      st.usec   = 0
      call f_ext_to_int(st,edate) 
      td1 = f_tdiff(stime, bdate)
      td2 = f_tdiff(stime, edate)
c
c     compare station name, channel and date 
c
      if (cstat .eq. stat) then
        if (cseed .eq. chan) then
          if (td1 .ge. 0.d0 .and. td2 .le. 0.d0) then
c
c           match!
c
            head.azi = azi
            head.dip = dip
            head.gain = gs * ds
            head.nzeros = nz
            head.npoles = np
c
            gain = gs
            nzeros = nz
            npoles = np
            do jj = 1, nz
              kk = np + jj
              read(io_res,103) poles(kk)
            end do
            ip = int(np*0.5)*2
            do jj = 1, ip, 2
              read(io_res,104) poles(jj), poles(jj+1)
            end do
            if ((np - ip) .eq. 1) then
              read(io_res,104) poles(np)
            end if
            if (cunit .eq. '(DU/MS-2)') then
              iunit=2
            else if (cunit .eq. '(DU/MS-1)') then
              iunit=1
            else if (cunit .eq. '(DU/M)   ') then
              iunit=0
            else
              iunit=999
            end if
            do jj = 1, np + nz
              head.poles(jj) = poles(jj)
            end do
            head.iunit = iunit
            go to 110
          end if
        end if
      end if
c
c     no match - skip the poles and zeros and keep going
c
      iskip = nz + nint(np*0.5)
      do ii = 1, iskip
        read(io_res,*)
      end do
      go to 100
c
c     error exit
c
105   continue
      ierr = 999
      close(io_res)
      return
c
c     sucessful completion exit
c
110   continue
      close(io_res)
      return
c
c     format statements
c
101   format(2a4,1x,i4,1x,i3,1x,i2,i2,2x,i4,
     .  1x,i3,1x,i2,i2,2f8.2,1x,a9,1x,a4,1x,a3)
102   format(3x,e12.5,i3,i4)
103   format(1x,2e14.6)
104   format(4e14.6)
c
      end

      subroutine est_cfr(head,idc,dtr,dtc,d1,dw,iem,ic,
     &   file_pick,io_out,ierr)
c
c     subroutine for estimation of various characteristic functions
c
c     input:
c             head   - station/channel header
c             idc    - characteristic function index
c             dtr    - detection threshold
c             dtc    - detection time constant
c             d1     - data array
c             dw     - spectral array
c             iem    - crude component counter
c             io_out - unit number for writing
c     output:
c             iere   - error return code
c
      parameter (maxp  = 65536)
c
c     include files for header and time
c
      include '/usr/local/include/qlib2.inc'
      record /INT_TIME/ t0_time, t1_time
      record /EXT_TIME/ t2_time
      include 'station_hdr.inc'
c
      real*4 d1(*)
      real*4 data(maxp,3), a0(3)
      real*4 cfr(maxp)
      real*4 lta(maxp), sta(maxp)
      real*4 azm1(maxp), aoi1(maxp)
c
      real*8 tslew
c
      integer*4 ic(*)
c
      complex dw(*)
c
      character*1 ipo, ipt, ipp, istrc, cid
      character*3 chan
      character*4 stat
      character*6 ipd
      character*(*) file_pick
c
      common /filter/ np0, fl0, fh0
c
      data icall /0/
      data ipo /'i'/
      data ipt /'P'/
      data ipp /'Z'/
      data ipd /'0.0000'/
c
c     initialize error flag
c
      iere = 0
c
c     set constants for sta/lta determination
c
      c3 = 0.67
      c4 = 0.015
      c5 = dtr
      c6 = 0.05*dtr
      indc = idc
c
c     set variables for filtering
c
      pi = 4.0*atan(1.0)
      ind = 0
      ind2 = 7
      if (np0 .eq. 0) then
        ind2 = 0
      else
        npbb = np0
        fl = fl0
        fh = fh0
      end if
c
c     station parameters
c
      stat  = head.station_id
      chan  = head.channel_id
      npts  = head.num_pts
      dt  = 1.0/head.sample_rate
c
c     save this data
c
      do ii = 1, npts
        data(ii,iem) = d1(ii)
      end do
      a0(iem) = head.gain
c
c     save reference time if this is the first call
c
      if (icall .eq. 0) then
        t0_time = head.begtime
        icall = icall + 1
      end if
c
c     if we don't have three-components yet, return
c
      if (iem .ne. 3) then
        return
      else
        do ii = 1, 3
          if (ic(ii) .ne. 1) then
            iere = -iem
            return
          end if
        end do
      end if
c
c     open an output file
c
      inquire(file=file_pick,exist=lexist) 
      if (lexist) then 
        open(unit=io_out,file=file_pick,fileopt='eof') 
      else
        open(unit=io_out,file=file_pick)
        write(io_out,'(a13,i1,1x,2(f8.3,1x),i2,1x,3(f8.3,1x))')
     .   'Pickfile V.2 ', idc,dtr,dtc,npbb,fl,fh
        call f_int_to_ext(t0_time,t2_time)
        write(io_out,101) 'T ',t2_time.year, t2_time.doy,
     .     t2_time.hour, t2_time.minute, t2_time.second,  
     .     t2_time.usec
101     format(a,i4.4,1x,i3.3,1x,i2.2,":",i2.2,":",i2.2,".",i4.4)
      end if
c      
c     correct for instrument gain factor and filter
c
      gain = (a0(1) + a0(2) + a0(3))/3.0
      a1 = gain/a0(1)
      a2 = gain/a0(2)
      a3 = gain/a0(3)
c
      do ii = 1, npts
        data(ii,1) = data(ii,1)*a1
        data(ii,2) = data(ii,2)*a2
        data(ii,3) = data(ii,3)*a3
      end do
c
      call coinst2(npts,dt,ind,ind2,data(1,1),dw,npbb,fl,fh,iere)
      if (iere .ne. 0) then
        return
      end if
c
      call coinst2(npts,dt,ind,ind2,data(1,2),dw,npbb,fl,fh,iere)
      if (iere .ne. 0) then
        return
      end if
c
      call coinst2(npts,dt,ind,ind2,data(1,3),dw,npbb,fl,fh,iere)
      if (iere .ne. 0) then
        return
      end if
c
c     form appropriate characteristic functions
c
      sta(1) = 0.0
      lta(1) = 0.0
      call calc_cfr(npts,dt,indc,data,cfr)
c
c     now form the sta/lta functions for detection
c
      do ii = 2, npts
        sta(ii) = sta(ii-1) + c3*(cfr(ii) - sta(ii-1))
        lta(ii) = lta(ii-1) + c4*(cfr(ii) - lta(ii-1))
      end do
c
c     compute the azim and angle of incidence this set
c
      call calc_azm(npts,data,azm1,aoi1)
c
c     check for detections and write them out
c     --ignore the part of the time series which was tapered
c
      fps = npts * 5.0 * 0.005
      j1 = int(fps)
      j2 = npts - j1
c
      i1 = 0
      ftx = dt/dtc
      do ii = j1, j2
c
c       this helps prevent immediate redetections
c
c       if (i1 .ne. 0) then
c         dtx = (ii - i1)*ftx
c         alpha = 1.0 - exp(-dtx)
c       else
c         alpha = 1.0
c       end if
c
        if (i1 .ne. 0) then
          dtx = (ii - i1)*ftx
          if (dtx .lt. 1.0) then
            alpha = dtx*dtx*dtx
          else
            alpha = 1.0
          end if
        else
          alpha = 1.0
        end if
c
c       go back and try to find something early
c
        if (alpha*sta(ii) .gt. c5*lta(ii)) then
          k2 = ii
c
c         define an band for refining the estimate
c
          do kk = k2, i1 + 1, -1
            if (alpha*sta(kk) .lt. c6*lta(k2)) then
              k1 = kk
              go to 150
            end if
            k1 = k2 - 1
          end do
150       continue
c
          call find_onset(k1,k2,cfr,k0)
          call find_azm(k0,k2,npa,azm1,aoi1,azm,seazm,aaoim,seaaoim)
          cflevel = cfr(k0)
c
c         compute travel time based on current header time
c
          i1 = k0
          t1 = (k0 - 1)*dt
          it1s = int(t1)
          it1t = (t1 - it1s)*usecs_per_sec
          call f_add_time(head.begtime, it1s, it1t, t1_time)
          call f_int_to_ext(t1_time,t2_time)
c
c         compute time offset to reference time
c
          tslew = f_tdiff(t1_time,t0_time)
          t1 = tslew/usecs_per_sec
          k0 = t1/dt + 1          
c
c         what have we picked?
c
          if(aaoim .le. 45.0) then
            ipcnt=ipcnt+1
            ipt='P'//' '
            ipp='U'
            istrc='Z'
          elseif(aaoim .ge. 135.0) then
            ipcnt=ipcnt+1
            ipt='P'//' '
            ipp='D'
            istrc='Z'
          else
            iscnt=iscnt+1
            ipt='S'//' '
            if(azm .le. 45.0) then
              ipp='N'
              istrc='N'
            elseif(azm .le. 135.0) then
              ipp='E'
              istrc='E'
            elseif(azm .le. 225.0) then
              ipp='S'
              istrc='N'
            elseif(azm .le. 315.0) then
              ipp='W'
              istrc='E'
            else
              ipp='N'
              istrc='N'
            endif
          endif
          write(io_out,200) stat,chan(1:2),istrc,
     .      k0,ipo,ipt,t1,ipp,ipd,
     .      t2_time.year, t2_time.doy, t2_time.hour, 
     .      ':',t2_time.minute, ':', t2_time.second, '.', 
     .      t2_time.usec,
     .      npa,cflevel,azm,aaoim
200       format(1x,a4,1x,a2,a1,
     .      1x,i5,1x,a1,1x,a1,1x,f12.4,1x,a1,1x,a6,1x,
     .      i4.4,1x,i3.3,1x,i2.2,a1,i2.2,a1,i2.2,a1,i4.4,1x,
     .      i3,1x,e15.5,1x,2(f8.2,1x))
        end if
      end do
      close(io_out)
c
c     all done
c
      return
      end

	subroutine est_energy(head,d1,dw,dist,iem,ic,io_out,ierr)
c
c     subroutine for estimation of energy magnitude
c
c     input:
c             head   - station/channel header
c             d1     - data array
c             dw     - spectral array
c             dist   - epicentral distance in km
c             iem    - crude component counter
c             ic     - component index
c             io_out - unit number for writing
c     output:
c             ierr   - error return code
c
      parameter (maxp  = 65536)
c
c     include files for header and time
c
      include '/usr/local/include/qlib2.inc'
      include 'station_hdr.inc'
c
      real*4 d1(*)
      real*4 data(maxp,3), d2(maxp)
      real*4 dt, dist, rdist, r0, r1, q0, q1, atten, atten2
      integer*4 npts, iem, io_out, ierr
      integer*4 ic(*)
      complex*8 dw(*)
      character*3 chan
      character*4 stat
      logical lexist
c
      external atten, atten2
c
c     initialize error flag
c
      ierr = 0
c
c     conversion from m to cm and from km to cm
c
      xm2cm = 100.
      xkm2m = 1000.
      xkm2cm = xkm2m * xm2cm
      pi = 4.0*atan(1.0)
c
c     reference depth and related parameters
c
      href = 8.0
      rho0 = 2.5
      beta0 = 3.0 * xkm2cm
      cf = 2.0
      fudge = 4.0 * pi * rho0 * beta0 / (cf**2)
c
c     station parameters
c
      stat  = head.station_id
      chan  = head.channel_id
      npts  = head.num_pts
      dt  = 1.0/head.sample_rate
      cid  = chan(3:3)
c
c     set variables for energy estimate
c
      ind = 21
      ind2 = 2
      fl = 0.05
      fh = 5.00
      np = 0
c
c     remove instrument to velocity and bandpass filter
c
      call coinst2(npts,dt,ind,ind2,d1,dw,np,fl,fh,ierr)
      if (ierr .ne. 0) then
        return
      end if    
c
c     save this data and convert to cm/s
c
      do ii = 1, npts
        data(ii,iem) = d1(ii) * xm2cm
      end do
c
c     if we don't have three-components yet, return
c
      if (iem .ne. 3) then
        return
      else
        do ii = 1, 3
          if (ic(ii) .ne. 1) then
            ierr = -iem
            return
          end if
        end do
      end if
c
c     form the array of velocities squared
c
      do kk = 1, npts
        d2(kk) = data(kk,1)*data(kk,1)
     .         + data(kk,2)*data(kk,2)
     .         + data(kk,3)*data(kk,3)
      end do
c
c     now form the total integral
c
      hstep = 0.5*dt
      totint = 0.0
      do kk = 1, npts - 1
        totint = totint + hstep*(d2(kk) + d2(kk+1))
      end do
c
c     now estimate the attenuation
c
      rdist = sqrt(dist*dist + href*href)
      r0 = href * xkm2cm
      r1 = rdist * xkm2cm
c
c     Either Richter attenuation, as modified by Jennings & Kanamori 1987
c
c      q0 = atten(href)
c      q1 = atten(rdist)
c
c     OR revised attenuation from Kanamori 1993
c
      q0 = atten2(href)
      q1 = atten2(rdist)
c
c     ok - form energy estimate
c
      atten_fac = ((r0*q0)/(r1*q1))**2
c
      ener = fudge * r1 * r1 * atten_fac * totint
      emag = (alog10(ener) - 9.05)/1.96
c
c     output file for energy magnitude
c
      call klen(stat,kk)
      inquire(file='energy.wave',exist=lexist)
      if (lexist) then
        open(unit=io_out,file='energy.wave',fileopt='eof')
      else
        open(unit=io_out,file='energy.wave')
        write(io_out,'(a2)') '# '
        write(io_out,'(a2)') '# '
      end if
      write(io_out,200) stat(1:kk),chan(1:2), head.network_id,
     .  ' EMAG ',emag, rdist, ener, totint
200   format(1x,a4,1x,a2,1x,a4,1x,a6,1x,f5.2,1x,f7.2,1x,2e15.5)
      close(io_out)
c
      do kk = 1, npts
        d1(kk) = d2(kk)
      end do
c
c     all done
c
      return
      end

	subroutine find_onset(j0,j1,cf,jj)
c
c ...... find maximum onset time probability
c ...... stolen from Bob
c
      parameter (npoints = 10000)
c
	real*4 cf(*), p(npoints)
	integer*4 j0,jj,j1
c
	k=0
	do i=j0,j1
	  k=k+1
	  f=cf(j1)-cf(i)
	  fp=cf(i+1)-cf(i-1)
	  fpp=cf(i+1)-2.d0*cf(i)+cf(i-1)
	  p(k)=f*fp*fpp
      end do
	pmax=p(1)
	if(k.lt.2) then
	  jj=j0
	else
	  jj=j0
	  do i=2, k
          if (p(i) .gt. pmax) then
	      pmax=p(i)
	      jj=j0+i-1
	    endif
        end do
	endif
c
	return
	end

      complex function wwsp (w)
c
c .....WWSSN SP - Blacknest specified poles and zeros.....
c
c  based on the sac subroutine wwspbn - Blacknest
c
      complex*8 cz(3), cp(5), ck, s, t
c
c   .....Set poles and zeros.....
c
      data ck /(432.83395,0.0)/
      data cz /3*(0.,0.)/
      data cp /( -4.04094,  6.47935 ),
     2         ( -4.04094, -6.47935 ),
     3         ( -9.25238,  0.0 ),
     4         ( -7.67430,  0.0 ),
     5         ( -16.72981, 0.0 )/
c
      s = cmplx(0.,w)
c
      t = ck
c
c     loop over common zeros and poles
c
      do ii = 1, 3
        t = t * ((s - cz(ii))/(s - cp(ii)))
      end do
c
c     loop over remaining poles
c
      do ii = 4, 5
        t = t / (s - cp(ii))
      end do
c
      wwsp = t
c
      return
      end

      complex function wood(w)
c
c     compute nominal Wood Anderson response
c 
c     w is angular frequency in rad/s
c
      complex*8 cz(2),cp(2), ck, s, t
c
c     poles and zero of Wood Anderson response
c     --from the file seisp.stf
c
      data ck /(2.08000E+06,0.)/
      data cz /2*(0.,0.)/
      data cp /(-0.541925E+01, -0.568479E+01),
     1         (-0.541925E+01,  0.568479E+01)/
c
      s = cmplx(0.,w)
c
      t = ck
c
c     loop over zeros and poles
c
      do ii = 1, 2
        t = t * ((s - cz(ii))/(s - cp(ii)))
      end do
c
      wood = t
c
      return
      end
